function Book(){
	this.identifier="";
	this.title="";
	this.autor="";
	this.cover="";
	this.lastdate=new Date().getTime();
	this.isCollection=false;
	this.size=0;
	this.bookfolder="";
	this.lastsynced=0;
	
	this.spine=[];
	this.toc=[];
	
	this.bookmarks=[];
	this.notes=[];
	this.highlights=[];
	
	this.format="";
	
	this.currentPage=0;
	this.currentNPages=0;
	this.currentPointer=0;
	this.currentPosition=null;
	this.useBookStyles=true;
	this.percent=0;
	this.currentVoicePosition={};
	
	this.status={started: false, finished: false, pc:0 };
	
	this.history=[];
	//{identifier: identifier, 'title':title, 'autor':autor, 'cover':cover, 'lastdate': 0}
}
Book.prototype.loadBook = function(identifier){
	var o=localStorage.getItem(identifier);
	if(o){
		o=JSON.parse(o);
		for(var p in o){
			this[p]=o[p];
		}
		return true;
	}
	this.history=[];
	return false;
};
Book.prototype.getBookObject = function(){
	return JSON.stringify(this);
};
Book.prototype.saveBook = function(){
	var temp=this.history;
	this.history=[];
	var o=this.getBookObject();
	localStorage.setItem(this.identifier, o);
	this.history=temp;
};
Book.prototype.onBookRemoved = function(){
};
Book.prototype.removeBook = function(identifier){
	localStorage.removeItem(identifier);
	filesystem.root.getDirectory(booksFolder.fullPath+'/'+identifier, {}, function(dirEntry){
	    dirEntry.removeRecursively(function() {
	    	console.log('Directory removed.');
	    	this.onBookRemoved();
	    }.bind(this), function(e){
	    	console.log(e);
	    	this.onBookRemoved();
	    }.bind(this));
	}.bind(this), function(e){
		  console.log(e);
		  this.onBookRemoved();
	}.bind(this));

};

Book.prototype.getPercentage=function(){
	var ahora=this.spine[this.currentPointer].src;
	var totalahora=0;
	
	for(var i in this.spine){
		var s=this.spine[i];
		if(s.src!=ahora){
			totalahora+=s.size;
		}else{
			if(this.currentNPages=="0")
				this.currentNPages="1";
			totalahora+=((s.size/this.currentNPages)* (this.currentPage+1));
			break;
		}
	}
	console.log(totalahora, this.currentPage, this.currentNPages);
	
	this.percent=((totalahora*100)/this.size);
	if(this.percent==100){
		this.setStatus(true, true);
	}
	return Math.floor(this.percent);
};
Book.prototype.getPercentageEndChapter=function(){
	var ahora=this.spine[this.currentPointer].src;
	var totalahora=0;
	for(var i in this.spine){
		var s=this.spine[i];
		totalahora+=s.size;
		if(s.src==ahora){
			break;
		}
	}
	console.log("getPercentageEndChapter: "+ ((totalahora*100)/this.size));
	return ((totalahora*100)/this.size);
};
Book.prototype.setStatus=function(started, finished){
	if(this.percent>=100){
		finished=true;
	}
	this.status.started=started;
	this.status.finished=finished;
	this.status.pc=this.percent;
	this.saveBook();
};

Book.prototype.getCurrentChapterSrc=function(){
	return this.spine[this.currentPointer].src;
};
Book.prototype.getChapterFromSrc=function(src){
	for(var i in this.spine){
		var s=this.spine[i];
		var tocsrc=s.src;
		var pos=tocsrc.indexOf("#");
		if(pos>=0){
			tocsrc=tocsrc.substring(0, pos);
		}
		var temp=tocsrc.split("/");
		var temp2=src.split("/");
		//y si tengo dos folders con un archivo de igual nombre?
		if(s.src==src || temp[temp.length-1]==temp2[temp2.length-1]){
			return i;
		}
	}
	return null;
};
Book.prototype.getNetxChapter=function(){
	if(this.currentPointer<(this.spine.length-1)){
		this.currentPointer++;
		this.currentPage=0;
		this.saveBook();
		return this.getUrl(this.spine[this.currentPointer].src);
	}
	return "";
};

Book.prototype.getPrevChapter=function(){
	if(this.currentPointer>0){
		this.currentPointer--;
		this.currentPage=100000;
		this.saveBook();
		return this.getUrl(this.spine[this.currentPointer].src);
	}
	return "";
};

Book.prototype.getUrl=function(c){
	var u="";
	if(c!=null){
		this.currentPointer=this.getPointertoChapter(c);
		console.log("this.currentPointer: "+this.currentPointer);
		this.saveBook();
		var myPattern = / /g;
		u="file://"+this.bookfolder+"/"+c.replace(myPattern, "%20");
		console.log("CARGANDO URL: "+c);
		console.log("CARGANDO URL: "+u);
	}
	return u;
};

Book.prototype.getPointertoChapter=function(c){
	c=unescape(c);
	var po=-1;
	var c2=c;
	var c3="";
	if(c.indexOf("#")>0){
		c2=c.substring(0, c.indexOf("#"));//url sin hashtag
	}
	for(var i=0; i<this.toc.length; i++){
		c3=unescape(this.toc[i].src);
		if(this.toc[i].src.indexOf("#")>0){
			c3=this.toc[i].src.substring(0, this.toc[i].src.indexOf("#"));//url sin hashtag
		}
		//si con o sin hastag es la misma url
		if(c==this.toc[i].src || c2==this.toc[i].src || c==c3 || c2==c3){
			//this.currentPointer=i;
			break;
		}
	}
	for(i=0; i<this.spine.length; i++){
		c3=unescape(this.spine[i].src);
		if(this.spine[i].src.indexOf("#")>0){
			c3=this.spine[i].src.substring(0, this.spine[i].src.indexOf("#"));//url sin hashtag
		}
		if(c==this.spine[i].src || c2==this.spine[i].src || c==c3 || c2==c3){
			po=i;
			break;
		}
	}
	return po;
};
Book.prototype.getTocIndexFromChapter=function(){
	//buscamos el punto anterior
	var pointer=this.currentPointer;
	while(pointer>=0){
		var str=this.spine[pointer].src;
		console.log(str);
		for(var j=0; j<this.toc.length; j++){
			var testutl=this.toc[j].src;
			console.log(str, testutl);
			var pos=testutl.indexOf("#");
			if(pos>0){
				testutl=testutl.substring(0, pos);
			}
			
			if(str.endsWith(testutl) || unescape(str).endsWith(unescape(testutl))){
				console.log("yes it is", j);
				return j;
				break;
			}
		}
		pointer--;
	}
	return 0;
};


Book.prototype.setCurrentPage=function(npage){
	console.log("setCurrentPage "+npage);
	this.currentPage=npage;
	this.updateHistory();
	this.saveBook();
};

Book.prototype.updateHistory=function(){
	if(this.history.length==0 || (this.history[this.history.length-1].currentPointer!=this.currentPointer) || (this.history[this.history.length-1].currentPage!=this.currentPage && this.history[this.history.length-1].currentPointer==this.currentPointer)){
		var temp={};
		temp.currentPage=this.currentPage;
		temp.currentNPages=this.currentNPages;
		temp.currentPointer=this.currentPointer;
		this.history.push(temp);
	}
};

Book.prototype.getChapterFromPercentage=function(value){
	var cap=this.spine[this.currentPointer].src;
	var totaltemp=0;
	for(var i=0; i<this.spine.length; i++){
		var s=this.spine[i];
		totaltemp+=s.size;
		var per=totaltemp*100/this.size;
		if(per>value){
			cap=s.src;
			break;
		}
	}
	return cap;
};

Book.prototype.getPageFromPercentage=function(c, numpages){
	var totaltemp=0;
	var page=0;
	for(var i=0; i<this.spine.length; i++){
		var s=this.spine[i];
		if(s.src==c.chapter){
			var pagesize=s.size/numpages;
			for(var i=0; i<numpages;i++){
				totaltemp+=pagesize;
				var per=Math.floor((totaltemp)*100/this.size);
				if(per>=Math.floor(c.per)){
					page=i;
					break;
				}
			}
			break;
		}
		totaltemp+=s.size;
	}
	if(page==0 && c.per==100){
		page=100000;
	}
	return page;
};

Book.prototype.removeBookmark=function(date){
	for(var i=0; i<this.bookmarks.length;i++){
		if(this.bookmarks[i].date==date){
			this.bookmarks.splice(i, 1);
			break;
		}
	}
	this.saveBook();
};

Book.prototype.removeNote=function(date){
	for(var i=0; i<this.notes.length;i++){
		if(this.notes[i].date==date){
			this.notes.splice(i, 1);
			break;
		}
	}
	this.saveBook();
};

Book.prototype.removeHighlight=function(date){
	for(var i=0; i<this.highlights.length;i++){
		if(this.highlights[i].date==date){
			this.highlights.splice(i, 1);
			break;
		}
	}
	this.saveBook();
};