function Collections(){
	this.collections=[];
	
	var data=localStorage.getObject("collections");
	if(data){
		this.collections=data;
	}
}
Collections.prototype.getCollections = function(){
	return this.collections;
};
Collections.prototype.getCollection = function(id){
	for(var i=0; i<this.collections.length; i++){
		if(this.collections[i].idbook==id){
			var col=new Collection("", "");
			col.load(this.collections[i]);
			return col;
		}
	}
	return null;
};
Collections.prototype.updateCollection = function(id, col){
	for(var i=0; i<this.collections.length; i++){
		if(this.collections[i].idbook==id){
			this.collections[i]=col;
			this.save();
			break;
		}
	}
};
Collections.prototype.addBookToCollection = function(id, book){
	var col=this.getCollection(id);
	col.addBook(book);
	this.updateCollection(id, col);
};

Collections.prototype.isBookInAnyCollection = function(book){
	for(var i=0; i<this.collections.length; i++){
		var col=this.collections[i];
		for(var j=0; j<col.books.length; j++){
			if(col.books[j]==book){
				return true;
			}
		}
	}
	return false;
};
Collections.prototype.addCollection = function(col){
	this.collections.push(col);
	this.save();
};
Collections.prototype.delCollection = function(col){
	if(this.collections.indexOf(col)>=0){
		this.collections.splice(this.collections.indexOf(col), 1);
		this.save();
	}
};
Collections.prototype.delCollectionById = function(id){
	var chilsToDel=[];
	//tengo que borras las posibles colecciones que dependan de ella.
	for(var j=0; j<this.collections.length; j++){
		if(this.collections[j].parent==id){
			chilsToDel.push(this.collections[j].idbook);
		}
	}
	for(j=0; j<chilsToDel.length; j++){
		this.delCollectionById(chilsToDel[j]);
	}
	
	for(var i=0; i<this.collections.length; i++){
		if(this.collections[i].idbook==id){
			//muevo los libros de la coleccion al padre
			if(this.collections[i].parent!="0")
				this.mergeBookCols(this.collections[i].idbook, this.collections[i].parent);
			this.collections.splice(i, 1);
			break;
		}
	}
	this.save();
};
Collections.prototype.delBookFromCollection = function(id, book){
	var col=this.getCollection(id);
	if(col && col.isBookInCollection(book)){
		//existe
		col.delBook(book);
		this.updateCollection(id, col);
	}
};
Collections.prototype.openCollection = function(id){
	var col=this.getCollection(id);
	col.fecha=new Date().time.toString(10);
	this.updateCollection(id, col);
};
Collections.prototype.save = function(){
	localStorage.setObject("collections", this.collections);
};
Collections.prototype.reset = function(){
	collections=[];
	localStorage.removeItem("collections");
};
Collections.prototype.mergeBookCols = function(fromcol, tocol){
	var col1=this.getCollection(fromcol);
	var col2=this.getCollection(tocol);
	if(col1 && col2){
		col2.books=col2.books.concat(col1.books);
		this.updateCollection(tocol, col2);
	}
};
Collections.prototype.setNewParent = function(id, newparent){
	var col=this.getCollection(id);
	col.parent=newparent;
	this.updateCollection(id, col);
};
