function NewBook(identifier, title, author){
   this.identifier=identifier;
   this.title = title;
   this.author = author;
   this.cover="";
   this.files=[];
   this.spine=[];
   this.toc=[];
   this.downloadImages=false;
   this.imagesToDownloadList=[];
   
   this.bookFolder=null;
   this.booksFolder=null;
   this.saveFilesPunt=0;
   this.puntImg=0;
}
NewBook.prototype.setBooksFolder = function(cover){
	this.booksFolder=booksFolder;
};
NewBook.prototype.setDownloadImages = function(d){
	this.downloadImages=d;
};
NewBook.prototype.setCover = function(cover){
	this.cover=cover;
};
NewBook.prototype.addSpine = function(spine){
	this.spine.push(spine);
};
NewBook.prototype.addFile = function(file){
	this.files.push(file);
};
NewBook.prototype.createBook = function(){
	this.spine.sort(function(a, b){
	    if ( a.playOrder< b.playOrder )
	        return -1;
	    if ( a.playOrder > b.playOrder )
	        return 1;
	    return 0;
	});
	//elimino el libro si ya existia
	this.removeExistingBook();
};

NewBook.prototype.removeExistingBook = function(){
	filesystem.root.getDirectory(booksFolder.fullPath+'/'+this.identifier, {}, function(dirEntry){
	    dirEntry.removeRecursively(function() {
	    	console.log('Directory removed.');
	    	this.createBookFolder();
	    }.bind(this), function(e){
	    	this.creationError();
	    }.bind(this));
	}.bind(this), function(e){
		  console.log(e);
		  console.log(this);
		  this.createBookFolder();
	}.bind(this));
};
NewBook.prototype.createBookFolder = function(){
	console.log("createBookFolder");
	filesystem.root.getDirectory(booksFolder.fullPath+'/'+this.identifier, {create:true}, function(dirEntry) {
		this.bookFolder=dirEntry;
		console.log(dirEntry);
		this.getImageFiles();
	}.bind(this), 
	function(e){//error creating folder
		  console.log(e);
		  this.creationError();
	}.bind(this));
};
NewBook.prototype.creationComplete = function(){
	console.log("CREATION COMPLETE");
};
NewBook.prototype.creationError = function(){
	console.log("CREATION Error");
};
NewBook.prototype.onProgress = function(status, current, total){
	console.log("onProgress "+status+" "+current+" "+total);
};

NewBook.prototype.getImageFiles = function(){
	console.log("getImageFiles");
	var o={};
	o.url=this.cover;
	o.name="cover.png";
	this.imagesToDownloadList.push(o);

	this.puntImg=0;
	if(this.downloadImages){
		//this.saveFiles();
		for(var i=0; i<this.files.length; i++){
			var file=this.files[i];
			var myRegexp = /<\s*img [^\>]*src\s*=\s*(["\'])(.*?)\1/igm;
			//console.log(file);
			var match;
			while ((match=myRegexp.exec(file.html)) !=null) {
			    //match = myRegexp.exec(file.html);
			    replac=this.filterImageFiles(match);
				file.html=file.html.replace(match[0], replac);
			}
		}
		console.log(this.imagesToDownloadList);
		this.saveFiles();
	}else{
		this.saveFiles();
	}
};
NewBook.prototype.filterImageFiles = function(match){
	//console.log(match);
	var url=match[2];

	var name=this.puntImg.toString();
	this.puntImg++;
	var o={};
	if(url.toLowerCase().lastIndexOf(".jpg")>=0){
		name=name+".jpg";
	}else if(url.toLowerCase().lastIndexOf(".jpeg")>=0){
		name=name+".jpeg";
	}else if(url.toLowerCase().lastIndexOf(".gif")>=0){
		name=name+".gif";
	}else if(url.toLowerCase().lastIndexOf(".png")>=0){
		name=name+".png";
	}else{
		name=name+".jpg";
	}
	o.url=url;
	o.name=name;
	this.imagesToDownloadList.push(o);
	return "<img src=\""+name+"\" style=\"display:block !important; margin: o auto !important;\" ";
};
NewBook.prototype.saveFiles = function(){
	this.saveFilesPunt=0;
	this.saveNextFile();
};
NewBook.prototype.saveNextFile = function(){
	console.log("saveNextFile");
	if(this.saveFilesPunt<this.files.length){
		this.onProgress("savenextfile", this.saveFilesPunt, this.files.length);
		var file=this.files[this.saveFilesPunt];
		console.log(file);
		this.saveFilesPunt++;
		var folders=file.id.split('/');
		folders.pop();
		if(folders.length>0)
			this.createDir(this.bookFolder, file, folders);
		else
			this.createFile(file);
	}else{
		this.puntImg=0;
		this.saveImages();
	}
};

NewBook.prototype.createDir=function(rootFolder, file, folders) {
	rootFolder.getDirectory(folders[0], {create: true}, function(dirEntry) {
		folders=folders.slice(1);
	    if (folders.length>0) {
	    	this.createDir(dirEntry, file, folders);
	    }else{
	    	this.createFile(file);
	    }
	  }.bind(this), function(e){
		  console.log(e);
		  this.creationError();
	  }.bind(this));
};
NewBook.prototype.createFile=function(entry){
	this.bookFolder.getFile(entry.id, {create:true}, function(fileEntry) {
	    fileEntry.createWriter(function(fileWriter) {
	      fileWriter.onwriteend = function(e) {
	        console.log('Write completed.');
	        this.saveNextFile();
	      }.bind(this);
	      fileWriter.onerror = function(e) {
	        console.log('Write failed: ' + e.toString());
	        this.saveNextFile();
	      }.bind(this);

	      // Create a new Blob and write it to log.txt.
	      //var bb = new BlobBuilder();
	      var aFileParts = [entry.html];
	      var bb = new Blob(aFileParts, {type : entry.contentType});
	      fileWriter.write(bb);
	    }.bind(this), function(e){
			  console.log(e);
			  this.creationError();
		}.bind(this));
	}.bind(this), function(e){
		  console.log(e);
		  this.creationError();
	}.bind(this));
};

NewBook.prototype.saveImages = function(){
	//o.url=url;
	//o.imgname=name;
	//this.imagesToDownloadList.push(o);
	console.log("saveImages "+this.puntImg+" "+this.imagesToDownloadList.length);
	if(this.puntImg<this.imagesToDownloadList.length){
		var img=this.imagesToDownloadList[this.puntImg];
		this.puntImg++;
		var me=this;
		console.log(img);
		var xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function(){
		    if (this.readyState == 4){
		    	if(this.status == 200){
			        console.log("IMAGE DOWNLOADED OK");
			        console.log(img.name);
			        var response=this.response;
			        me.bookFolder.getFile(img.name, {create:true}, function(fileEntry) {
			    	    fileEntry.createWriter(function(fileWriter) {
			    	      fileWriter.onwriteend = function(e) {
			    	    	  console.log('Write completed.');
			    	    	  me.saveImages();
			    	      };
			    	      fileWriter.onerror = function(e) {
			    	        console.log('Write failed: ' + e.toString());
			    	        me.saveImages();
			    	      };
			    	      console.log(response);
	
			    	      fileWriter.write(response);
			    	    }, function(e){
			    	    	console.log("ERROR WRITING IMAGE");
			    			  console.log(e);
			    			  me.saveImages();	
			    		});
			    	}, function(e){
			    		console.log("ERROR CREATING IMAGE");
			    		  console.log(e);
			    		  me.saveImages();
			    	});
		    	}else{
			        console.log("Failed Image "+this.response);
			        me.saveImages();
		    	}
		    }
		};
		xhr.open('GET', img.url);
		xhr.responseType = 'blob';
		xhr.onerror = function () {
			console.log("ON ERROR XHR");
			console.log(xhr.status);
			me.saveImages();
		}; 
		xhr.send(); 
	}else{
		console.log("FOTOS DOWNLOADED");
		this.copyCover();
	}
};

NewBook.prototype.copyCover = function(){
	console.log("copyCover");
	this.saveMetadata();
};
NewBook.prototype.saveMetadata = function(){
	console.log("saveMetadata");
	var cover="file://"+blackberry.io.home+"/books/"+this.identifier+"/cover.png";
		
	var b=new Book();
	b.identifier=this.identifier;
	b.title=this.title;
	b.autor=this.author;
	b.cover=cover;
	b.lastdate=0;
	b.isCollection=false;
	b.saveBook();
	console.log(b);
	this.creationComplete();
};
/*

localStorage.setItem(identifier+"_pointsSpine", null);
			localStorage.setItem(identifier+"_pointsToc", null);
			localStorage.setItem(identifier+"_size", null);
			localStorage.setItem(identifier+"_status", null);
			localStorage.setItem(identifier+"_notes", null);
			localStorage.setItem(identifier+"_bookmarks", null);
			localStorage.setItem(identifier+"_highlights", null);
			
			localStorage.setItem(identifier, "0|0|0|false");
			var status:Object=new Object();
			status.started=false;
			status.finished=false;
			status.pc=0;
			localStorage.setItem(identifier+"_status", status);
						localStorage.setItem(identifier+"_pointsSpine", pointsSpine);
			localStorage.setItem(identifier+"_pointsToc", pointsSpine);

						localStorage.setItem(identifier+"_info", "||Instapaper|instapaper.png|"+ebookdir.nativePath+"|"+new Date().time);
						
									var totalSize:Number=0;
			for each(var s:Object in pointsSpine){
				totalSize+=s.size;
			}
			localStorage.setItem(this.identifier+"_size", totalSize);

			
*/