var translator=new Translator();
var position=null;
var book=null;

function loadTranslator(params){
	document.getElementById('addnoteaction').hide();
	book=params.book;
	position=params.position;
	$('#fromtext').val(params.text);
	$('#Spinner').show();
	var langs=localStorage.getObject("idiomas");
	translator.error=function(e){
		console.log(e);
		Toast.regular($.localize.data['app'].errortranslator, 3000);
	};
	if(langs){
		translator.langArray=langs;
		loadLanguages();
	}else{
		translator.onGetLanguageNames=function(){
			console.log("LANG END");
			localStorage.setObject("idiomas", translator.langArray);
			loadLanguages();
		};
		translator.GetLanguageNames();
	}
}
function translate(){
	$('#Spinner').show();
	$('#totext').val('');
	translator.onTranslate=function(result){
		$('#Spinner').hide();
		$('#totext').val(result);
		document.getElementById('addnoteaction').show();
		
	};
	localStorage.setItem("lang_from", $('#fromlanguages').val());
	localStorage.setItem("lang_to", $('#tolanguages').val());
	translator.translate($('#fromlanguages').val(), $('#tolanguages').val(), $('#fromtext').val());
}

function loadLanguages(){
	var i=0;
	
	var lang=navigator.language;
	var langtemp=lang.split("-");
	
	var fromlang=-1;
	var tolang=-1;
	var o=localStorage.getItem("lang_from");
	if(o)
		fromlang=o;
	o=localStorage.getItem("lang_to");
	if(o)
		tolang=o;
	
	
	var fromdown = document.getElementById('fromlanguages');
	var todown = document.getElementById('tolanguages');
	
	for(i=0; i<translator.langArray.length; i++){
	    var option = document.createElement('option');
		option.setAttribute('value', translator.langArray[i].lang);
		option.innerHTML = translator.langArray[i].label;
		fromdown.appendChild(option);
		
	    option = document.createElement('option');
		option.setAttribute('value', translator.langArray[i].lang);
		option.innerHTML = translator.langArray[i].label;
		todown.appendChild(option);
	}
	fromdown.refresh();
	todown.refresh();
	
	if(lang!=""){
		for(i=0; i<translator.langArray.length;i++){
			if(translator.langArray[i].lang==lang || translator.langArray[i].lang==langtemp[0]){
				fromdown.setSelectedItem(i);
				break;
			}
		}
	}
	if(fromlang!=-1){
		for(i=0; i<translator.langArray.length;i++){
			if(translator.langArray[i].lang==fromlang){
				fromdown.setSelectedItem(i);
				break;
			}
		}
	} 
	
	if(tolang!=-1){
		for(i=0; i<translator.langArray.length;i++){
			if(translator.langArray[i].lang==tolang){
				todown.setSelectedItem(i);
				break;
			}
		}
	}else{
		for(i=0; i<translator.langArray.length;i++){
			if(translator.langArray[i].lang==lang  || translator.langArray[i].lang==langtemp[0]){
				todown.setSelectedItem(i);
				break;
			}
		}
	}
	$('#Spinner').hide();
}

function addNoteFromTranslator(){
	if($('#totext').val().trim().length>0){
		var tempo={};
		tempo.page=book.currentPage;
		tempo.npage=book.currentNPages;
		tempo.pointer=book.currentPointer;
		tempo.label=$('#totext').val();
		tempo.date=new Date().getTime();
		tempo.position=position;
		
		var color=localStorage.getItem("note-color");
		if(!color)
			color="#FFFF00";
		state=color.substring(1);
		state=parseInt("0x"+state, 16);
		tempo.color=state;
		
		book.notes.push(tempo);
		book.lastsynced=book.lastsynced+1;
		book.saveBook();
		cloudsync.saveBookNotes(book);
		Toast.regular("Note added from translator results", 3000);
	}
}

function Translator(){
	this.appId="B80FE9D6E9C8459895E15F27EC0E884A8B576122";
	this.host="http://api.microsofttranslator.com/v2/Http.svc/";
	this.langArray=[];
}

Translator.prototype.translate=function(from, to, text){
	var url="http://api.microsofttranslator.com/V2/Http.svc/Translate?appId="+this.appId+"&text="+escape(text)+"&from="+from+"&to="+to+"&contentType=text/plain";
	 $.ajax({
		 type: 'GET',
		 url: url,
		 dataType: "xml",
		 data: { 
		    },
		 success: function(data) {
			 console.log($(data).find('string').text());
			 this.onTranslate($(data).find('string').text());
		 }.bind(this),
		 error: function(data) {
			 this.error(data);
		 }.bind(this)
	});
};
Translator.prototype.GetLanguageNames=function(){
	var url=this.host+"GetLanguagesForTranslate?appId="+this.appId;
	 $.ajax({
		 type: 'GET',
		 url: url,
		 dataType: "xml",
		 data: { 
		    },
		 success: function(data) {
			 localStorage.setItem("idiomas_date", new Date().getTime());
			 console.log(data);
			 this.langArray=[];
			 var este=this;
			 $(data).find('string').each(function(){
				var o={};
				o.lang=$(this).text();
				o.label="";
				este.langArray.push(o);
			 });
			 var url="http://api.microsofttranslator.com/V1/Http.svc/GetLanguageNames?appId="+this.appId+"&locale="+navigator.language;
			 $.ajax({
				 type: 'GET',
				 url: url,
				 data: { 
				    },
				 success: function(data) {
					var a=data.split("\n");
					for(var i=0; i<a.length; i++){
						if(a[i].trim()!=""){
							this.langArray[i].label=a[i].trim();
						}
					}
					 
					 this.langArray.sort(function(a, b){
						if(a['label'] < b['label'])
							return -1;
						else if(a['label']>b['label'])
							return 1;
						return 0;
					});
						
					 this.onGetLanguageNames();
				 }.bind(this),
				 error: function(data) {
					 this.error(data);
				 }.bind(this)
			});

		 }.bind(this),
		 error: function(data) {
			 this.error(data);
		 }.bind(this)
	});
};
Translator.prototype.onGetLanguageNames=function(){};
Translator.prototype.onTranslate=function(result){};
Translator.prototype.error=function(e){};
