/*
 * Copyright 2013 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
var langs=['es', 'en', 'vi', 'zh', 'de', 'ru', 'cs', 'it', 'fr', 'id', 'ja', 'ar', 'pt', 'pl'];
var filesystem=null;
var booksFolder=null;
var validfiles=["epub", "fb2", "mobi", "prc", "azw", "pdb"];
var validfilesExtensions=["*.epub", "*.fb2", "*.mobi", "*.prc", "*.azw", "*.pdb"];
var booklist=[];
var row;
var showList=false;
var searchBooksShow=false;
var wasDeleteBook=false;
var collections=new Collections();
var activeCollection=0;
var automaticDone=false;
var wasOpenAction=false;
var openActionUrl="";
var readingIframe=null;
var lastBookImported="";
var lastImportedBooks=0;
/*
 * Libraries variables to maintain context 
 */
var libraries=[];
var opdsInitParams=null;
var lastListElement=null;
var NextURL=null;
var isLoadingNextPage=false;
var historyLibrary=[];
var historyPunt=0;
var lastLoadedItems=[];
var downloadItems=[];
var searchUrl=null;
var currentScreen="";
var maximizedApp=false;
var lastBook=null;
var readerEvents=[];
var sortBooksField="title";
var reloadAfterSort=true;
var anchor="";

$(window).resize(setHomeBackgrounds);
function setHomeBackgrounds(){
	$(".gridrow").css("background-image", "url('../assets/estante"+window.innerWidth+".jpg')");
	if(bb.screens.length>0 && bb.screens[bb.screens.length-1].id=="home")
		$("#homeScreen").css("background-image", "url('assets/fondoestante"+window.innerWidth+".jpg')");
}
var Application = {

    // Application Constructor
    initialize: function() {
    	lastBook=localStorage.getItem("lastBook");
        this.bindEvents();
        zip.workerScriptsPath = "js/lib/zipjs/";
    },

    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        document.addEventListener("resume", this.onResume, false);
    },

    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onResume: function() {
    	console.log("APP MAXIMIZED");
    	maximizedApp=true;
    },
    onDeviceReady: function() {
        Application.receivedEvent('deviceready');
	    blackberry.io.sandbox = false;
	    doLocalize(document.body);//para precargar los idiomas
	    document.addEventListener('invoked', pushClient.onInvoke);
	    pushClient.register();
	    
        bb.init({
            actionBarDark: false,
            controlsDark: false,
            coloredTitleBar: true,
            listsDark: false,
            highlightColor: '#00A8DF',         
            
            // Fires "before" styling is applied and "before" the screen is inserted in the DOM
            onscreenready: function(element, id, params) {
            	doLocalize(element);
            	currentScreen=id;
            	for(var e in readerEvents){
            		var ev=readerEvents[e];
            		
            		if(ev.type){
            			blackberry.event.removeEventListener(ev.name, ev.callback);	
            		}else{
            			document.removeEventListener(ev.name, ev.callback);	
            		}
            	}
            	//elimino los eventos de volumen
            	var keyBindings = [];
            	community.mediakeys.bind(keyBindings, function (error) { console.log("unable to bind media keys: "+error); });
            	
            	console.log("PRE dom ready "+id);
            	if (id === "home") {
            		element.getElementById('homeScreen').style['background-image']="url('assets/fondoestante"+window.innerWidth+".jpg')";
            		$(".gridrow").css("background-image", "url('../assets/estante"+window.innerWidth+".jpg')");
            		showList=false;
            		bookSortShow=false;
            		if(lastBook==null || wasOpenAction){
		        		var items=0;
		        		var rows=1;
		        		row=addRow(element);
		        		element.getElementById('shelvegroup').appendChild(row);
		
		        		var maxItems=3;
		        		var ancho=Math.min(window.innerWidth, window.innerHeight);
		        		var maxItems=Math.floor(ancho/240);
		        		if(maxItems==6)
		        			maxItems=5;
		        		for(var i=0; i<booklist.length; i++){
		        			row.appendChild(addItem(booklist[i]));
		        			items++;
		        			if(items==maxItems){
		        				items=0;
		        				row=addRow(element);
		        				rows++;
		        				element.getElementById('shelvegroup').appendChild(row);
		        			}
		        		}
		        		var minrows=Math.ceil(window.innerHeight/276);
		        		var dif=minrows-rows;
		    			for(var i=0; i<dif; i++)
		    				element.getElementById('shelvegroup').appendChild(addRow());
            		}
            	}
            	if (id === "collectionOpen") {
            		element.getElementById('homeScreen').style['background-image']="url('assets/fondoestante"+window.innerWidth+".jpg')";
            		$(".gridrow").css("background-image", "url('../assets/estante"+window.innerWidth+".jpg')");
            		var items=0;
            		var rows=1;
            		var maxItems=3;
            		var ancho=Math.min(window.innerWidth, window.innerHeight);
            		if(ancho>800)
            			maxItems=5;
            		row=addRow(element);
            		element.getElementById('shelvegroup').appendChild(row);

            		for(var i=0; i<booklist.length; i++){
            			row.appendChild(addItem(booklist[i]));
            			items++;
            			if(items==maxItems){
            				items=0;
            				row=addRow(element);
            				rows++;
            				element.getElementById('shelvegroup').appendChild(row);
            			}
            		}
            		var minrows=Math.ceil(window.innerHeight/276);
            		var dif=minrows-rows;
        			for(var i=0; i<dif; i++)
        				element.getElementById('shelvegroup').appendChild(addRow());
            	}

            	if (id === "homelist") {
            	}
            	if(id=="reader"){
            		$('#voicecontrols').remove();
            		$('#swipemenu').remove();
            		$('#flipbook').remove();
            		$('#Spinner').remove();
            	}
            	blackberry.app.unlockOrientation();
            },

            // Fires "after" styling is applied and "after" the screen is inserted in the DOM
            ondomready: function(element, id, params) {
            	console.log("dom ready "+id);
            	syncSilent=false;
            	
            	//Toast.regular('You have no opened books', 2000);
            	if (id === "home") {
            		setSelectByValue("sortdropdown", sortBooksField);
            		$(".gridrow").css("background-image", "url('../assets/estante"+window.innerWidth+".jpg')");

            		setCover();
            		document.getElementById('sortdropdown').hide();
            		document.getElementById('searchtextfield').hide();
            		if(booklist.length==0){
            			Toast.regular($.localize.data['app'].shelvesempty, 3000);
            		}
            		console.log("LAST IMPORTED ", lastBookImported, lastImportedBooks);
            		if(wasOpenAction){
            			lastBook=null;
            			localStorage.removeItem("lastBook");
            			openInvokedBook();
            		}else{
	            		if(!automaticDone)
	            			doAutomaticFolders();//lanzo la importacion automatica
	            		automaticDone=true;
            		}
            		/*
            		if(lastImportedBooks==1 && lastBookImported!=null && lastBookImported!=""){
            			lastBook=lastBookImported;
            			lastImportedBooks=0;
            			lastBookImported=null;
            		}
            		*/
            		if(lastBook!=null){
            			readBookProcess(lastBook, false);
            		}else{
            			localStorage.removeItem("lastBook");
            		}
            	}
            	if (id === "homelist") {
            		setSelectByValue("sortdropdown", sortBooksField);
            		
            		setCover();
            		document.getElementById('sortdropdown').hide();
            		document.getElementById('searchtextfield').hide();
            		bookSortShow=false;
            		showList=true;
            		
            		if(lastBook==null || wasOpenAction)
            			loadBooksOnList();
            		if(booklist.length==0){
            			Toast.regular($.localize.data['app'].shelvesempty, 3000);
            		}
            		if(wasOpenAction){
            			lastBook=null;
            			localStorage.removeItem("lastBook");
            			openInvokedBook();
            		}else{
	            		if(!automaticDone)
	            			doAutomaticFolders();//lanzo la importacion automatica
	            		automaticDone=true;
            		}
            		/*
            		if(lastImportedBooks==1 && lastBookImported!=null && lastBookImported!=""){
            			lastBook=lastBookImported;
            			lastImportedBooks=0;
            			lastBookImported=null;
            		}
            		*/
            		if(lastBook!=null){
            			readBookProcess(lastBook, false);
            		}else{
            			localStorage.removeItem("lastBook");
            		}
            	}
            	if (id === "help"){
            		
            	}
            	if(id=="share"){
            		findTargetsToShare(params);
            	}
            	if(id==="settingscloud"){
            		loadSavedData();
            	}
            	if(id==="settingscloudsavedbooks"){
            		getSyncBooksList();
            	}
            	if(id==="settingsschedule"){
            		loadSavedData();
            	}
            	if(id==="settingsinstapaper"){
            		doStartInstapaper();
            	}
            	if(id==="settingspocket"){
            		doStartPocket();
            	}
               	if(id==="settingsfeedly"){
            		doStartFeedly();
            	}
               	if(id==="collectionadd"){
               		loadCollections(params);
            	}
               	if(id==="collectionOpenlist"){
            		setCover();
            		loadBooksOnList();
               		loadCollectionOpen(params);
               		$('.bb-action-bar-10dot3-back-button').click(function(e) {
               			console.log("CLICK BACK");
                   		activeCollection=0;
               			getBooksList(closeCurrenScreen);
               		});
            	}
               	if(id==="collectionOpen"){
            		$(".gridrow").css("background-image", "url('../assets/estante"+window.innerWidth+".jpg')");
            		if(bb.screens[bb.screens.length-1].id=="home")
            			$("#homeScreen").css("background-image", "url('assets/fondoestante"+window.innerWidth+".jpg')");

               		loadCollectionOpen(params);
               		$('.bb-action-bar-10dot3-back-button').click(function(e) {
               			console.log("CLICK BACK");
                   		activeCollection=0;
               			getBooksList(closeCurrenScreen);
               		});
            	}
               	if(id==="libraries"){
               		loadLibraries();
            	}
               	if(id==="librariesAdd"){
               		loadLibrariesAdd();
            	}
               	if(id==="librariesOPDS"){
               		loadOPDS(params);
            	}
               	if(id==="librariesOPDSdetail"){
               		loadOPDSdetail(params);
            	}
               	if(id==="librariesDownloads"){
               		loadDownloads();
            	}
               	if(id==="settingsGeneral"){
               		loadSettings();
            	}
               	if(id==="settingsBackup"){
               		loadSettingsBackup();
            	}
            	if(id=="reader"){
            		loadBook(params);
            	}
            	if(id=="readertoc"){
            		loadToc(params);
            	}
            	if(id=="readerbookmarks"){
            		loadBookmarks(params);
            	}
            	if(id=="readernotes"){
            		loadNotes(params);
            	}
            	if(id=="readersettings"){
            		loadSettings(params);
            	}
            	if(id=="readeraddnote"){
            		loadAddNote(params);
            	}
            	if(id=="readertranslator"){
            		loadTranslator(params);
            	}
            	if(id=="readerdictionary"){
            		loadDictionary(params);
            	}
            }
        });
        
	    window.webkitRequestFileSystem(window.PERSISTENT, 1024 * 1024 * 1024, onInitFs, errorHandler);
		console.log("Deviceready");
    },

    // Update DOM on a Received Event
    receivedEvent: function(id) {
        console.log('Received Event: ' + id);
    }
};

function setSelectByValue(eID,val){ //Loop through sequentially//
	console.log("setSelectByValue", val);
	var index=0;
	reloadAfterSort=false;
	switch(val){
	case "autor":index=1;break;
	case "lastdate":index=2; break;
	}
	if(index==0 && $('#sortdropdown').val()=="title"){//ñapa, en este caso no se dispara el evento que lo cancela
		reloadAfterSort=true;
	}
	document.getElementById('sortdropdown').setSelectedItem(index);
	/*
  var ele=document.getElementById(eID);
  for(var ii=0; ii<ele.length; ii++){
    if(ele.options[ii].value==val) { //Found!
      ele.options[ii].selected='selected';
    }else{
    	ele.options[ii].selected='';
    }
  }
  */
}

function onInitFs(fs) {
	console.log("onInitFs");
	filesystem=fs;
	filesystem.root.getDirectory(blackberry.io.home+"/books/", {create:true},
	        function (folder) {
				booksFolder=folder;
        		sortBooksField=localStorage.getItem("sortBooksField");
        		if(sortBooksField==null)
        			sortBooksField="title";
		        // start the app
				getBooksList(startApp);
	        },
	        function (error) {
	            console.log(error);
	        }
	    );
}




function fail(error) {
	console.log("read entries error");
	console.log(error);
}

function errorHandler(e) {
	console.log(e);
    var msg = '';

    switch (e.code) {
    case FileError.QUOTA_EXCEEDED_ERR:
        msg = 'QUOTA_EXCEEDED_ERR';
        break;
    case FileError.NOT_FOUND_ERR:
        msg = 'NOT_FOUND_ERR';
        break;
    case FileError.SECURITY_ERR:
         msg = 'SECURITY_ERR';
         break;
    case FileError.INVALID_MODIFICATION_ERR:
         msg = 'INVALID_MODIFICATION_ERR';
         break;
    case FileError.INVALID_STATE_ERR:
         msg = 'INVALID_STATE_ERR';
         break;
    default:
         msg = 'Unknown Error '+e.code;
        break;
    };

    
    console.log('Error: ' + msg);
}



var books=[];
var cols=3;

function showListView(){
	if(showList){
		bb.pushScreen('home.html', 'home');
		localStorage.setItem("lastViewType", "icon");
	}else{
		bb.pushScreen('homelist.html', 'homelist');
		localStorage.setItem("lastViewType", "list");
	}
}
function showHideSearchBooks(){
	document.getElementById('sortdropdown').hide();
	if(searchBooksShow){
		document.getElementById('searchtextfield').hide();
		searchBooksShow=0;
	}else{
		searchBooksShow=1;
		document.getElementById('searchtextfield').show();
	}
}
function addRow(){
	//monto las columnas ajustadas a la menor de las medidas
	var w=window.innerWidth;
	var h=window.innerHeight;
	var size=Math.min(w, h);
	var numcolumns=Math.floor(size/240);
	if(numcolumns==6)
		numcolumns=5;
	var row = document.createElement('div');
	row.setAttribute('data-bb-type','row');
	row.setAttribute('data-bb-columns', numcolumns);
	//row.setAttribute('style','background-image:url("assets/estante2.png"); height:276px; width:100%;');
	row.setAttribute('class','gridrow');
	//background-image:url('assets/estante2.png'); height:276px; width:100%;
	return row;
}
function addItem(book){
	  var item = document.createElement('div');
	  item.setAttribute('data-bb-type','item');
	  item.setAttribute('data-bb-title',book.title);
	  item.innerHTML = book.autor;
	  item.setAttribute('data-bb-img',book.cover);
	  item.setAttribute('style','height:270px');
	  item.setAttribute('identifier', book.identifier);
	  item.setAttribute('isCollection', book.isCollection);
	  item.onclick = readBook;
	  return item;
}
function onContextShow(itemNode){
	  console.log("itemNode.onContextShow");
	  console.log(itemNode);
};

function getBooksFromCollections(){
	//elimino libros en colecciones
	var l=booklist.length-1;
	for(var i=l; i>=0; i--){
		var id=booklist[i].identifier;
		if(collections.isBookInAnyCollection(id)){
			booklist.splice(i, 1);
		}
	}
	//añado colecciones
	var cols=collections.getCollections();
	for(var i=0; i<cols.length; i++){
		var book=new Book();
		book.identifier=cols[i].idbook;
		book.title=cols[i].title;
		book.autor=cols[i].autor;
		book.isCollection=true;
		book.lastdate=cols[i].fecha;
		book.cover="local://assets/covercollection.png";
		booklist.push(book);
	}
}
function callbackAfterDelete(){
	if(showList){
		loadBooksOnList();
		//var selected = document.getElementById('bookslist').selected;
		//selected.remove();
	}else{
		bb.pushScreen('home.html', 'home');
	}
}
function getBooksList(callback){
	console.log("getBooksList");
	booklist=[];
	if(activeCollection==0){
		filesystem.root.getDirectory(booksFolder.fullPath, {},
	        function (folder) {
	        	var dirReader = folder.createReader();
	        	var entries = [];
	        	var readEntries = function() {
	            	dirReader.readEntries (function(results) {
	                	if (!results.length) {
	                        for(var i in entries){
	                        	var folder=entries[i];
	                        	var book=new Book();
	                        	if(book.loadBook(folder.name)){
		                        	booklist.push(book);
	                        	}else{
	                        		console.log("elimino libro zombie: "+folder.name);
	                        		folder.removeRecursively(function() {
	                        			console.log("eliminado libro zombie: "+folder.name);
	                        	    }, function(e){
	                        	    	console.log(e);
	                        	    });
	                        	}
	                        }
	                        getBooksFromCollections();
	                        sortBooks();
	                        //ojo! puedo no estar en la home! hay que comproabrlo
	                        if(callback!=null)
	                        	callback();
	                    } else {
	                    	entries = entries.concat(toArray(results));
	                    	readEntries();
	                    }
	             }, fail);
	        	};
	        	readEntries();
	        },
	        function (error) {
	        	console.log("error with getting directory.");
	            console.log(error);
	        }
	    );
	}else{
		//cargo una collection
		var col=collections.getCollection(activeCollection);
		for(var i=0; i<col.books.length; i++){
			var book=new Book();
			book.loadBook(col.books[i]);
			booklist.push(book);
		}
        sortBooks();
        //ojo! puedo no estar en la home! hay que comproabrlo
		if(currentScreen=="homelist"){
			bb.pushScreen("collectionOpenlist.html", "collectionOpenlist", {'identifier': activeCollection});
		}else if(currentScreen=="home"){//collectionOpen
			bb.pushScreen("collectionOpen.html", "collectionOpen", {'identifier': activeCollection});
		}
		
		if(currentScreen=="collectionOpenlist"){
			helper.replaceScreen("collectionOpenlist.html", "collectionOpenlist", {'identifier': activeCollection});
		}else if(currentScreen=="collectionOpen"){//collectionOpen
			helper.replaceScreen("collectionOpen.html", "collectionOpen", {'identifier': activeCollection});
		}
        //if(callback!=null)
        //	callback();
	}
}

function loadBooksOnList(){
	var items=[];
	for(var i=0; i<booklist.length; i++){
		var item = document.createElement('div');
		item.setAttribute('data-bb-type','item');
		item.setAttribute('data-bb-title', booklist[i].title);
		item.innerHTML=booklist[i].autor;
		item.setAttribute('data-bb-img', booklist[i].cover);
		item.setAttribute('identifier', booklist[i].identifier);
		item.setAttribute('isCollection', booklist[i].isCollection);
		
		item.onclick = readBookFromList;
		items.push(item);
	}
	document.getElementById('bookslist').refresh(items);
	if(items.length==0)
		document.getElementById('bookslist').clear();	
}
function sortBooks(){
	booklist.sort(function(a, b){
		if(sortBooksField=="lastdate"){//estos van en orden inverso
			if(a[sortBooksField] > b[sortBooksField])
				return -1;
			else if(a[sortBooksField]<b[sortBooksField])
				return 1;
			return 0;
		}else{
			if(a[sortBooksField].toLowerCase() < b[sortBooksField].toLowerCase())
				return -1;
			else if(a[sortBooksField].toLowerCase()>b[sortBooksField].toLowerCase())
				return 1;
			return 0;
		}
	});
}
function updateSortBooks(){
	console.log("updateSortBooks", reloadAfterSort);
	if(reloadAfterSort){
		sortBooksField=$('#sortdropdown').val();
		localStorage.setItem("sortBooksField", sortBooksField);
		sortBooks();
		if(showList){
			loadBooksOnList();
		}else{
			console.log("PUSH HOME");
			bb.pushScreen("home.html", "home");
		}
	}else{
		reloadAfterSort=true;
	}
}
var bookSortShow=false;
function showHideSortBooks(){
	if(bookSortShow){
		document.getElementById('sortdropdown').hide();
		bookSortShow=false;
	}else{
		bookSortShow=true;
		document.getElementById('sortdropdown').show();
	}
}
function closeCurrenScreen(){
	bb.popScreen();
}
function startApp(){
	Bbm.register();
	var t=localStorage.getItem("lastViewType");
	if(t && t=="list"){
		bb.pushScreen('homelist.html', 'homelist');
	}else{
		bb.pushScreen('home.html', 'home');
	}
	
	window.addEventListener('contextmenu', onContextMenu);
}
function onContextMenu(e){
	console.log(e);
	
	if(bb.screens[bb.screens.length-1].id=="home" || bb.screens[bb.screens.length-1].id=="homelist" || bb.screens[bb.screens.length-1].id=="collectionOpen" || bb.screens[bb.screens.length-1].id=="collectionOpenlist"){
		var target=e.target.parentNode;
		if(e.target.nodeType==3){
			target=target.parentNode.parentNode.parentNode;
		}
		console.log(target);
		var iscol=(target.getAttribute("iscollection")==="true");
		if(iscol){
			//document.getElementById('readnowbutton').setCaption('Open');
			document.getElementById('tocollectionbutton').hide();
		}else{
			//document.getElementById('readnowbutton').setCaption('Read now');
			document.getElementById('tocollectionbutton').show();
		}
	}
}

//removes all screens from stack until home or homelist
function gotoFirstScreen(){
	if(currentScreen=="home" || currentScreen=="homelist"){
		openInvokedBook();	
	}else{
		var len=bb.screens.length-2;
		for(var i=len; i>=0; i--){
			//busco la primera home o homelist, si no la elimino del stack
			if(bb.screens[i].id=="home" || bb.screens[i].id=="homelist" ){
				break;
			}else{
				bb.screens.splice(i, 1);
			}
		}
		bb.popScreen();
	}
}
function openInvokedBook(){
	filesToImport.push(openActionUrl);
	importSilent=false;
	importPunt=0;
	if(filesToImport.length==1){
		document.getElementById('bulkprogress').hide();
	}
	$('#loading').show();
	checkifBooksExist();
	wasOpenAction=false;

}
function dolike(){
    try {
        blackberry.ui.dialog.standardAskAsync($.localize.data['app'].liketext, blackberry.ui.dialog.D_OK_CANCEL, dolikeCallBack, {title : $.localize.data['app'].ilikeplayepub});
    } catch (e) {
        alert("Exception in standardDialog: " + e);
    }
}

function dolikeCallBack(selection){
    console.log(selection);
    if(selection['return']=="Ok"){
	    blackberry.invoke.invoke({
	    	target: "sys.appworld",
	        action: "bb.action.VIEW",
	        uri : "appworld://content/48654",
	    }, function(){}, function(){});
    }
}

function inviteToDownload(){
	if(Bbm.registered){
		Bbm.inviteToDownload();
	}
}
function share(){
	var text=$.localize.data['app'].sharetext;
	var url="http://appworld.blackberry.com/webstore/content/48654/";
	//bb.pushScreen("share.html", "share", {'text': text, 'url': url});
	
    var title = 'Share';
    var request = {
        action: 'bb.action.SHARE',
        mime : 'text/plain',
        data: text+" "+url,
        target_type: ["APPLICATION", "VIEWER", "CARD"]
    };
    blackberry.invoke.card.invokeTargetPicker(request, title, function(msg) {}, function(e) {});
}


function setNotToSleep(){
	//blackberry.display.getPreventSleepStatus(onSuccess, onError)
	blackberry.display.setPreventSleep(true, function (){
		
	}, function(){
		
	});
}

function openHelp(){
    blackberry.invoke.invoke({
    	target: "sys.browser",
        uri: 'http://playepub.com/quick-help/'
    }, function(){}, function(){});
}
//blackberry.app.lockOrientation(orientation)
//blackberry.app.unlockOrientation()
/*
function onOrientationChange(orientation) {
    console.log("New orientation is: " + orientation);
}

document.addEventListener("orientationchange", 
    onOrientationChange);*/


var utils = {
	/* Logs events to the screen and console. */
	'log' : function(value) {
		console.log(value);
	}
};

/*********************
 * COVER FUNCTIONS
 */
function setCover(){
	var covers = [], fullsize = new blackberry.ui.cover.Cover('fullSize',
			blackberry.ui.cover.TYPE_IMAGE), halfsize = new blackberry.ui.cover.Cover(
			'halfSize', blackberry.ui.cover.TYPE_IMAGE);

	fullsize.width = 334;
	fullsize.height = 396;
	//fullsize.text.push(new blackberry.ui.cover.Label('fullSize snapshot', 12));
	fullsize.path = 'local:///assets/CoverQNX.png';
	
	//halfsize.text.push(new blackberry.ui.cover.Label('halfSize image', 12));
	halfsize.path = 'local:///assets/CoverQNX720.png';
	
	covers.push(fullsize);
	covers.push(halfsize);

	blackberry.ui.cover.updateCovers(covers, function() {
		console.log('Covers updated');
	}, function() {
		console.log('Cover update error');
	});  
	
	console.log("PIN: "+blackberry.identity.uuid);
	console.log("DEVICE: "+blackberry.system.hardwareId);
}


/*************************
 * SYNC FUNCTIONS
 */
var availableSyncs=[];
var syncpunt=0;
var onSync=false;
var syncSilent=false;
function sync(){
	syncSilent=false;
	doSync();
}
function doSync(){
	var onlywifi=localStorage.getItem("schedule-only-wifi");
	if(onlywifi=="true" && syncSilent && blackberry.connection.type!="wifi"){
		//estamos sin wifi wn sync pero solo quiero con wifi 
		blackberry.app.exit();
		return;
	}
	if(!onSync){
		console.log("sync");
		availableSyncs=[];
		syncpunt=0;
		Instapaper.init(null, null);
		console.log("instapaper isauth "+Instapaper.isAuth);
	
		if(Instapaper.isAuth){
			availableSyncs.push('instapaper');
		}
		Pocket.init(null, null);
		console.log("Pocket isauth "+Pocket.isAuth);
		if(Pocket.isAuth){
			availableSyncs.push('pocket');
		}
		Feedly.init();
		console.log("Feedly isauth "+Feedly.isLogged());
		if(Feedly.isLogged()){
			availableSyncs.push('feedly');
		}
		if(availableSyncs.length==0 && !syncSilent){
			Toast.regular($.localize.data['app'].nosyncs, 2000);
		}else{
			if(!syncSilent)
				Toast.regular($.localize.data['app'].startingsync, 2000);
			var myVar=setTimeout(function(){
				window.clearInterval(myVar);
				doNextSync();
			},2000);
		}
	}else{
        var options = {
                timeout: 3000,
                buttonText: $.localize.data['app'].cancel,
                buttonCallback: function(){
                	console.log("SYNC CANCEL");
                	if(onSync){
                		var nextsync=availableSyncs[syncpunt];
                		switch(nextsync){
                		case 'instapaper':
                           	Instapaper.cancel();
                			break;
                		case 'pocket':
               				Pocket.cancel();
                			break;
                		case 'feedly':
                           	Feedly.cancel();
                			break;
                		}
                	}
    			}
            };
			blackberry.ui.toast.show($.localize.data['app'].syncrunning, options, 3000);
	}
}
function doNextSync(){
	if(syncpunt<availableSyncs.length){
		onSync=true;
		var nextsync=availableSyncs[syncpunt];
		switch(nextsync){
		case 'instapaper':
            var options = {
                timeout: 3000,
                buttonText: "Cancel",
                buttonCallback: function(){
                	console.log("Instapaper CANCEL");
                	Instapaper.cancel();
    			}
            };
            if(!syncSilent)
            	blackberry.ui.toast.show($.localize.data['app'].startinginstapapersync, options, 3000);
			Instapaper.syncComplete=function(){
				doNextSync();
			};
			Instapaper.authKO=function(){ 
				doNextSync();
			};
			Instapaper.listAll();
			break;
		case 'pocket':
            var options = {
                timeout: 3000,
                buttonText: "Cancel",
                buttonCallback: function(){
                	console.log("POCKET CANCEL");
    				Pocket.cancel();
    			}
            };
            if(!syncSilent)
            	blackberry.ui.toast.show($.localize.data['app'].startingpocketsync, options, 3000);
			Pocket.syncComplete=function(){
				doNextSync();
			};
			Pocket.authKO=function(){ 
				doNextSync();
			};
			Pocket.fetchRedits();
			break;
		case 'feedly':
            var options = {
                timeout: 3000,
                buttonText: "Cancel",
                buttonCallback: function(){
                	console.log("FEEDLY CANCEL");
                	Feedly.cancel();
    			}
            };
            if(!syncSilent)
            	blackberry.ui.toast.show($.localize.data['app'].startingfeedlysync, options, 3000);
			Feedly.syncComplete=function(){
				doNextSync();
			};
			Feedly.authKO=function(){
				doNextSync();
			};
			Feedly.listAll();
			break;
		}
		syncpunt++;
	}else{
		onSync=false;
		if(!syncSilent){
        	Toast.regular($.localize.data['app'].syncfinished, 2000);
			
			getBooksList(callbackAfterDelete);
		}else if(!maximizedApp){
			blackberry.app.exit();//si es silent sync cierro la app
		}
	}
}


/*******************
/* SHELVES CONTEXT MENU
*/

function removeBook(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	console.log(selected);
	var bookid=selected.getAttribute("identifier");
	var iscol=selected.getAttribute("isCollection");
	
	console.log(bookid);
	if(iscol=="true"){
		blackberry.ui.dialog.standardAskAsync($.localize.data['app'].sureremovecollection, blackberry.ui.dialog.D_OK_CANCEL, function(selection){
			if(selection['return']=="Ok"){
				console.log("yes remove");
				collections.delCollectionById(bookid);
				getBooksList(callbackAfterDelete);
			}
		}, {title : "Remove collection"});
	}else{
		blackberry.ui.dialog.standardAskAsync($.localize.data['app'].sureremovethisbook, blackberry.ui.dialog.D_OK_CANCEL, function(selection){
			if(selection['return']=="Ok"){
				console.log("yes remove");
				var b=new Book();
				b.onBookRemoved=function(){
					console.log("book has been removed");
					getBooksList(callbackAfterDelete);
				};
				b.removeBook(bookid);
			}
		}, {title : "Remove book"});
	}
}
function removeBookfromCollection(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;

	var bookid=selected.getAttribute("identifier");
	console.log("activeCollection: "+activeCollection);
	console.log("bookid "+bookid);
	collections.delBookFromCollection(activeCollection, bookid);

	getBooksList(function(){
		console.log(bb.screens);
		
	});//reseteo esta coleccion
}

function readBookFromContext(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;

	var bookid=selected.getAttribute("identifier");
	var iscol=selected.getAttribute("isCollection");
	readBookProcess(bookid, iscol);
}
function readBookFromList(){
	var selected = document.getElementById('bookslist').selected;
	var bookid=selected.getAttribute("identifier");
	var iscol=selected.getAttribute("isCollection");
	readBookProcess(bookid, iscol);
}
function readBook(){
	var bookid=this.getAttribute("identifier");
	var iscol=this.getAttribute("isCollection");
	readBookProcess(bookid, iscol);
}
function readBookProcess(bookid, iscol){
	console.log(bookid);
	console.log(iscol);
	if(iscol=="true"){
		activeCollection=bookid;
		getBooksList(null);
	}else{
		bb.pushScreen("reader.html", "reader", {"bookid": bookid});
	}
}

function moveBookToCollection(){
    var context = document.getElementById('contextlist');
	var selected=context.menu.selected.selected;
	console.log(selected);
	var bookid=selected.getAttribute("identifier");
	bb.pushScreen("collectionadd.html", "collectionadd", {'identifier': bookid});	
}


/*
 * book download function to keep context
 */
function getDownloadName(tempfile){
	var myPattern = /\W/g; 
	tempfile=tempfile.replace(myPattern, "");
	myPattern = /\n/g; 
	tempfile=tempfile.replace(myPattern, "");
	myPattern = /\r/g; 
	tempfile=tempfile.replace(myPattern, "");
	myPattern = /\//g; 
	tempfile=tempfile.replace(myPattern, "");
	myPattern = /\\/g; 
	tempfile=tempfile.replace(myPattern, "");
	return tempfile;
}
function addDownload(type, title, url, image){
	console.log("addDownload "+url);
	var fileTransfer = new FileTransfer();
	var uri = encodeURI(url);
	var name=getDownloadName(title)+"."+type;

	//var fp = filesystem.root.toURL()+"category/xyz.jpg";
	
	//var localuri="/accounts/1000/shared/downloads/"+name;
	var localuri=localStorage.getItem("librariesDownloadFolder");
	if(!localuri){
		localuri=blackberry.io.sharedFolder+"/books";
	}
	localuri="file://"+localuri+"/"+name;
	console.log(localuri);
	for(var i=0; i<downloadItems.length; i++){
		var d=downloadItems[i];
		if(d.url==url){
			Toast.regular($.localize.data['app'].alreadydownloading+" "+name, 2000);
			return;
		}
	}
	var downloadid=new Date().getTime();
	fileTransfer.downloadid=downloadid;
	downloadItems.push({id: downloadid, name: name, title: title, url: url, localuri: localuri, status: $.localize.data['app'].downloading, image: image, ft: fileTransfer});
	console.log(fileTransfer);
	fileTransfer.onprogress = function(progressEvent) {
		var pg=Math.floor((progressEvent.loaded/progressEvent.total)*100);
		if(pg==100){
			downloadUpdateStatus(this.downloadid, "Finished");
		}else{
			downloadUpdateStatus(this.downloadid, "Downloading "+pg+"%");
		}
	}.bind(fileTransfer);
	
	fileTransfer.download(
	    uri,
	    localuri,
	    function(entry) {
	        console.log("download complete: " + entry);
	        //aqui abro
	    	var autoopen=localStorage.getItem("autolibraryopen");
	    	var open=(autoopen == "true");
	    	if(open){
		    	downloadUpdateStatus(this.downloadid, "Finished");
		    	Toast.regular($.localize.data['app'].downloadcomplete+entry.name+". "+$.localize.data['app'].nowopening, 2000);
	    		importSilent=true;
				filesToImport.push(entry.fullPath);
				checkifBooksExist();
	    	}else{
		    	downloadUpdateStatus(this.downloadid, "Finished");
		        Toast.regular($.localize.data['app'].downloadcomplete+entry.name, 2000);
	    	}
	    }.bind(fileTransfer),
	    function(error) {
	        console.log("download error ");
	        console.log(error);
	        
	        if(error.code==FileTransferError.ABORT_ERR){
		    	downloadUpdateStatus(this.downloadid, $.localize.data['app'].canceled);
		    	//doLoadDownloads();//si se cancela es que estoy en esta pantalla
	        }else{        
		    	downloadUpdateStatus(this.downloadid, $.localize.data['app'].error);
	        	Toast.regular($.localize.data['app'].errordownloading+" "+error.target, 2000);
	        }
	    }.bind(fileTransfer),
	    true
	);
	Toast.regular($.localize.data['app'].downloading+" "+name, 2000);
	
}

function downloadUpdateStatus(local, status){
	console.log(local, status);
	for(var i=0; i<downloadItems.length; i++){
		if(downloadItems[i].id==local){
			downloadItems[i].status=status;
			console.log(currentScreen);
			if(currentScreen=="librariesDownloads"){
				//tengo que actualizar!!
				$('#download'+local+' > .bb-image-list-item-details > .description').html(status);
			}
			break;
		}
	}
}

function doLocalize(element){
    //var opts = { language: "ja", pathPrefix: "../test/lang", skipLanguage: "en-US" };
	var defaultLanguage = navigator.language || navigator.userLanguage;
	defaultLanguage=defaultLanguage.substring(0, 2).toLowerCase();
	var a = langs.indexOf(defaultLanguage); 
	if(a==-1)
		defaultLanguage="en";
	console.log("defaultLanguage", defaultLanguage);
	var opts = {  language: defaultLanguage, pathPrefix: "/locale" };
	$(element).find("[data-localize]").localize("app", opts);
	
	var atributes=["data-bb-caption", "data-bb-back-caption", "data-bb-label", "data-bb-action-caption", "data-bb-title"];
	for(var i=0; i<atributes.length; i++){
		var atr=atributes[i];
	    $(element).find("["+atr+"]").each(function() {
	        var key = $(this).attr(atr);
	        if($.localize.data['app'][key]){//si existe la key
	        	$(this).attr(atr, $.localize.data['app'][key]);
	        }else{
	        	console.log("KEY NOT EXISTS "+key)
	        }
	      });
	}
}


/************
Q10 shortcuts

					switch(event.keys[0]){
						case 32://space
							if(bookstl.selectedIndex<(bookstl.dataProvider.length-1)){
								bookstl.selectedIndex=bookstl.selectedIndex+1;
								bookstl.selectCell();
							}
							break;
						case 84://T
							bookstl.scrollIndexVisible(0);
							bookstl.selectedIndex=0;
							bookstl.selectCell();
							break;
						case 66://B
							bookstl.scrollIndexVisible(bookstl.dataProvider.length-1);
							bookstl.selectedIndex=bookstl.dataProvider.length-1;
							bookstl.selectCell();
							break;
						case 78://N
							bookstl.scrollPages(1, 0);
							bookstl.selectFirstCell();
							break;
						case 80://P
							bookstl.scrollPages(-1, 0);
							bookstl.selectFirstCell();
							break;
						case Keyboard.ENTER:
							if(bookstl.selectedIndex>=0){
								var e:ListEvent=new ListEvent(ListEvent.ITEM_CLICKED, bookstl.dataProvider.getItemAt(bookstl.selectedIndex), bookstl.selectedIndex, 0, 0);
								bookstl.dispatchEvent(e);
							}
							break;
						case 83://S
							var action:ActionBase=null;
							var total:int=actBar.numActions+actBar.numTabs;
							for(var i:int=0; i<total; i++){
								action=actBar.getActionAt(i);
								if(action.data==12){
									break;
								}
							}
							
							var ev:ActionEvent=new ActionEvent(ActionEvent.ACTION_SELECTED, action);
							actionSelected(ev);
							break;
						case Keyboard.BACKSPACE:
							trace("BACKSPACE "+this.collectionParent);
							if(this.collectionParent!="0"){
								goBackCollection(null);
							}
							break;
					}
*/

