function Epub(path){
	this.title="";
	this.author="";
	this.cover="";
	this.size=0;
	this.files=[];
	
	this.path=path;
	this.identifier=null;
	this.bookdir=null;
	this.tocPointer=0;
	this.toc=[];
	this.spine=[];
	this.opf=null;
	
	this.UnzipPunt=0;
	this.ZipExtracted=0;
	this.EntriesToUnzip=[];
	this.container="";
	
	this.cancelled=false;
}

Epub.prototype.onComplete=function(){};
Epub.prototype.onProgress=function(status, current, total){};
Epub.prototype.onError=function(error){};
Epub.prototype.onExistingBook=function(){};


Epub.prototype.extract=function(){
	filesystem.root.getFile(this.path, {}, 
		function(fileEntry) {
		console.log(fileEntry);
			fileEntry.file(function(file) {
				console.log(file);
				fileEntry.getMetadata(function(metadata){ 
				    console.log(metadata);
				    this.size=metadata.size;
					this.identifier=getFileIdentifier(fileEntry.name)+this.size;
					var book=localStorage.getObject(this.identifier);
					if(book){
						//book already opened
						this.onExistingBook();
					}else{
						console.log("Identifier: "+this.identifier);
						booksFolder.getDirectory(this.identifier, {create: true}, 
								function(dirEntry) {
									this.bookdir=dirEntry;
									this.readZip(file);
								}.bind(this), this.onError);
					}
				}.bind(this), this.onError);
		    }.bind(this), this.onError);
	  }.bind(this), 
	  this.onError);
	
};

Epub.prototype.readZip=function(blob){
	console.log("readZip");
	zip.createReader(new zip.BlobReader(blob), function(reader) {
		console.log("reader creaes");
		
		reader.getEntries(function(entries) {
			console.log("getentries");
			if (entries.length) {
				this.onProgress("Extracting book", 0, 100);
				
				this.UnzipPunt=0;
				this.ZipExtracted=0;
				this.EntriesToUnzip=entries;
				this.container="";
				this.doUnzipNext();
			}
		}.bind(this));
	}.bind(this), this.onError);
};

Epub.prototype.doUnzipNext=function(){
	if(this.cancelled){
		return;
	}
	if(this.UnzipPunt<this.EntriesToUnzip.length){
		var entry=this.EntriesToUnzip[this.UnzipPunt];
		
		if(entry.directory){
			this.bookdir.getDirectory(entry.filename, {create:true}, function(file) {
				this.doUnzipNext();
			}.bind(this), this.onError);
		}else{
			var folders=entry.filename.split('/');
			folders.pop();
			if(folders.length>0)
				this.createDir(this.bookdir, entry, folders);
			else
				this.createFile(entry);
		}
		this.UnzipPunt++;
	}else{
		if(this.container!=""){
			opfPath=this.getOpfPathFromContainer();
			console.log(opfPath);
			this.bookdir.getFile(opfPath, {create:false}, function(file) { 
				file.file(function(file) {
			        var reader = new FileReader();
			        reader.onloadend = function(e) {
			          this.opf = reader.result;
			          this.readOpf(this.opf);
			        }.bind(this);
			        reader.readAsText(file);
			     }.bind(this), this.onError);
			}.bind(this), this.onError);
		}else{
			this.onError("There was an error opening descriptor");
		}
	}
};

Epub.prototype.createDir=function(rootFolder, entry, folders) {
	rootFolder.getDirectory(folders[0], {create: true}, function(dirEntry) {
		folders=folders.slice(1);
	    if (folders.length>0) {
	    	this.createDir(dirEntry, entry, folders);
	    }else{
	    	this.createFile(entry);
	    }
	  }.bind(this), this.onError);
};

Epub.prototype.createFile=function(entry){
	this.bookdir.getFile(entry.filename, {create:true}, function(file) { 
		entry.getData(new zip.FileWriter(file), function(e) {
			console.log(entry.filename);
			if(entry.filename === "META-INF/container.xml") {
				file.file(function(file) {
			        var reader = new FileReader();
			        reader.onloadend = function(e) {
			        	console.log(reader.result);
			        	this.container = reader.result;
						this.ZipExtracted+=entry.compressedSize;
						this.files.push({src: entry.filename, size: entry.uncompressedSize});//para calcular el tamaño total
						this.doUnzipNext();
			        }.bind(this);
			        reader.readAsText(file);
			     }.bind(this), this.onError);
			}else{
				this.ZipExtracted+=entry.compressedSize;
				this.files.push({src: entry.filename, size: entry.uncompressedSize});//para calcular el tamaño total
				this.doUnzipNext();
			}
		}.bind(this), function(current, total) {
			this.onProgress("Extracting files", (this.ZipExtracted+current), this.size);
		}.bind(this)); 
	}.bind(this), this.onError);
};


Epub.prototype.readOpf=function(j) {
	this.opf=j;
	var o = this.xmlDocument(j);
	var m = {
		metadata : {},
		manifest : {},
		spine : []
	};
	var l = o.getElementsByTagName("metadata")[0].childNodes;
	console.log(l);
	for (var h = 0, n = l.length; h < n; h++) {
		var f = l[h];
		if (f.nodeType === 3 || f.nodeType === 8) {//text and comments
			continue;
		}
		var p = {};
		for (var g = 0, c = f.attributes.length; g < c; g++) {
			var k = f.attributes[g];
			p[k.name] = k.value;
		}
		p._text = f.textContent;
		//si es meta
		if(f.nodeName=="meta"){
			if(p['name'] && p['content']){
				m.metadata[p['name']] = p['content'];
			}
		}else{
			if(f.textContent!="")
				m.metadata[f.nodeName] = p;
		}
	}
	var d = o.getElementsByTagName("manifest")[0].getElementsByTagName("item");
	for (var h = 0, n = d.length; h < n; h++) {
		var f = d[h];
		if (f.nodeType === 8) {//comments
			continue;
		}
		m.manifest[f.getAttribute("id")] = {
			href : this.resolvePath(f.getAttribute("href"), opfPath),
			"media-type" : f.getAttribute("media-type")
		};
	}
	
	//si hay toc
	var toc=undefined;
	try{
		toc=o.getElementsByTagName("spine")[0].getAttribute("toc");
		toc=m.manifest[toc].href;
		console.log("TOC: "+toc);
	}catch(e){
		console.log("NO HAY TOC");
	}
	
	var e = o.getElementsByTagName("spine")[0].getElementsByTagName("itemref");
	for (var h = 0, n = e.length; h < n; h++) {
		if (f.nodeType === 8) {//comments
			continue;
		}
		var f = e[h];
		m.spine.push(f.getAttribute("idref"));
	}
	opf = m;
	console.log(opf);

	//process spine
	for(var i=0; i<m.spine.length; i++){
		var tag=m.spine[i];
		var item=m.manifest[tag];
		console.log(tag, item);
		if(item){
		  	var temp={};
			temp.src=item.href;
			temp.label=i+".";
			temp.playOrder=i;
			temp.size=this.getFileSize(item.href);
			this.spine.push(temp);
		}
	}
	
	var title="";
	var autor="";
	
	if(opf.metadata['dc:title'])
		title=opf.metadata['dc:title']._text;
	if(opf.metadata['dc:creator'])
		autor=opf.metadata['dc:creator']._text;
	
	var cover="";
	var mediajpeg="image/jpeg";
	var mediapng="image/png";
	
	if(opf.metadata['cover']){
		var mycover=opf.metadata['cover'];
		if(opf.manifest[mycover]){
			cover=opf.manifest[mycover].href;
		}
	}

	if(cover==""){
		if(opf.manifest['cover'] && (opf.manifest['cover']['media-type']==mediajpeg || opf.manifest['cover']['media-type']==mediapng)){
			cover=opf.manifest['cover'].href;
		}
	}
	if(cover==""){
		var firstmedia="";
		for(var item in opf.manifest){
			var it=opf.manifest[item];
			if(it['media-type']==mediajpeg || it['media-type']==mediapng){
				if(firstmedia=="")
					firstmedia=it.href;
				if(item.indexOf('cover')>=0 || it.href.indexOf('cover')>=0){
					cover=it.href;
					break;
				}
			}
		}
		if(cover==""){
			cover=firstmedia;
		}
	}
	
	if(cover!=""){
		cover="file://"+blackberry.io.home+"/books/"+this.identifier+"/"+cover;
	}
	this.title=title;
	this.author=autor;
	this.cover=cover;
	this.onProgress("Extracting files", 98, 100);
	
	if(toc){
		this.loadNcx(toc);
	}else{
		this.saveBook();
	}
};
Epub.prototype.getFileSize=function(src){
	for(var i=0; i<this.files.length; i++){
		var item=this.files[i];
		if(item.src==src){
			return item.size;
		}
	}
	return 0;
};
Epub.prototype.getTotalSize=function(){
	this.size=0;
	for(var i=0; i<this.files.length; i++){
		var item=this.files[i];
		var folders=item.src.split("/");
		var filename=folders.pop();
		var temp=filename.split(".");
		var ext=temp.pop();
		if(ext=="html" || ext=="htm" || ext=="xhtml" || ext=="xml"){
			this.size+=item.size;
		}
	}
};
Epub.prototype.saveBook=function(){
	if(this.cancelled){
		return;
	}
	this.getTotalSize();
	if(this.toc.length==0)
		this.toc=this.spine;
	
	var b=new Book();
	b.identifier=this.identifier;
	b.bookfolder=this.bookdir.fullPath;
	b.title=this.title;
	b.autor=this.author;
	b.cover=this.cover;
	b.lastdate=0;
	b.isCollection=false;
	b.size=this.size;
	b.format="epub";
	b.spine=this.spine;
	b.toc=this.toc;
	
	console.log(b);
	b.saveBook();
	this.onComplete();
};
Epub.prototype.loadNcx=function(href){
	this.bookdir.getFile(href, {create:false}, function(file) { 
		file.file(function(file) {
	        var reader = new FileReader();
	        reader.onloadend = function(e) {
	        	try{
		        	this.tocPointer=0;
		            var nfc = this.xmlDocument(reader.result);
		            var navPoints=nfc.getElementsByTagName("navMap")[0].getElementsByTagName("navPoint");
		            navPoints = Array.prototype.slice.call(navPoints, 0);
		            
		            navPoints = navPoints.filter(function(v, i){
		                return v.parentElement === nfc.getElementsByTagName("navMap")[0]; 
		            });
		            navPoints.sort(function(a, b){
		        		if(a.getAttribute("playOrder") < a.getAttribute("playOrder"))
		        			return -1;
		        		else if(a.getAttribute("playOrder")>a.getAttribute("playOrder"))
		        			return 1;
		        		return 0;
		            	
		            });
		            this.onProgress("Extracting files", 99, 100);
			  		if (navPoints.length>0) {
			  			for(var a=0; a<navPoints.length; a++) {
			  				this.loadNcxItems(navPoints[a], "");
			  			}
			  		}
			  		this.saveBook();
	        	}catch(e){
	        		console.log(e);
	        		this.onError("error with toc");
	        	}
	        }.bind(this);
	        reader.readAsText(file);
	     }.bind(this), this.onError);
	}.bind(this), this.onError);
};

Epub.prototype.loadNcxItems=function(a, indent){
	var temp={};
	temp.id=a.getAttribute("id");
	temp.playOrder=this.tocPointer;
	temp.label=indent+a.getElementsByTagName("navLabel")[0].getElementsByTagName("text")[0].textContent;
	temp.src=a.getElementsByTagName("content")[0].getAttribute("src");
	this.tocPointer++;
	this.toc.push(temp);

	//recursivo
	var navPoints=a.getElementsByTagName("navPoint");
	navPoints = Array.prototype.slice.call(navPoints, 0);
    navPoints.sort(function(a, b){
		if(a.getAttribute("playOrder") < a.getAttribute("playOrder"))
			return -1;
		else if(a.getAttribute("playOrder")>a.getAttribute("playOrder"))
			return 1;
		return 0;
    	
    });
	if (navPoints.length>0) {
		for(var b=0; b<navPoints.length; b++) {
			this.loadNcxItems(navPoints[b], indent+"          ");
		}
	}
};


Epub.prototype.resolvePath=function(g, c) {
	var k = g.split("/");
	var j = k.pop();
	var h = c.split("/");
	h.pop();
	for (var f = 0, e = k.length; f < e; f++) {
		var d = k[f];
		if (d === "..") {
			h.pop();
		} else {
			h.push(d);
		}
	}
	h.push(j);
	return h.join("/");
};
Epub.prototype.getOpfPathFromContainer=function() {
	var c = this.xmlDocument(this.container);
	return c.getElementsByTagName("rootfile")[0].getAttribute("full-path");
};

Epub.prototype.xmlDocument=function(c) {
	var d = new DOMParser().parseFromString(c, "text/xml");
	if (d.childNodes[1] && d.childNodes[1].nodeName === "parsererror") {
		//throw d.childNodes[1].childNodes[0].nodeValue;
		this.onError("error reading book container");
	}
	return d;
};

Epub.prototype.cancel=function() {
	this.cancelled=true;
};