function Fb2(path){
	this.title="";
	this.author="";
	this.cover="";
	
	this.fileToRead=null;
	this.path=path;
	this.identifier=null;
	this.size=0;
	this.bookdir=null;
	this.content=null;
	this.encoding="utf-8";
	this.encodingSecond=false;
	this.dom=null;
	
	this.numImages=0;
	this.images=null;

	this.numbodis=0;
	this.puntnumbodis=0;
	this.bodis=null;
	this.persection=0;
	this.section=null;
	this.numsections=0;
	this.puntsections=0;
	this.filesectioname="";
	
	this.percentage=0;
	this.persection=0;
	this.perbodis=0;
	this.imageper=0;
	
	this.description = new Object();
	this.body = "";
	this.contents = new Object();
	this.parsed = new Object();
	this.tocpointer=0;
	
	this.newbook=new NewBook();
	this.totalFiles=0;
	this.currentFiles=0;
	
	this.cancelled=false;
	this.createFilesPunt=0;
	this.toc=[];
	this.spine=[];
}

Fb2.prototype.onComplete=function(){};
Fb2.prototype.onProgress=function(status, current, total){};
Fb2.prototype.onError=function(error){};

Fb2.prototype.extract=function(){
	console.log("extract");
	filesystem.root.getFile(this.path, {}, 
			function(fileEntry) {
				fileEntry.file(function(file) {
					fileEntry.getMetadata(function(metadata){ 
					    console.log(metadata);
					    this.size=metadata.size;
						this.identifier=getFileIdentifier(fileEntry.name)+this.size;
						var book=localStorage.getObject(this.identifier);
						if(book){
							//book already opened
							this.onError({code: 1, msg: "Book already opened", path: this.path});
						}else{
							console.log("Identifier: "+this.identifier);
							booksFolder.getDirectory(this.identifier, {create: true}, 
									function(dirEntry) {
										this.bookdir=dirEntry;
										this.fileToRead=file;
										this.readfile(this.fileToRead, "utf-8");
									}.bind(this), this.onError);
						}
					}.bind(this), this.onError);
			    }.bind(this), this.onError);
		  }.bind(this), 
		  this.onError);
};

Fb2.prototype.readfile=function(file, encoding){
	console.log("readfile");
    var reader = new FileReader();
    reader.onloadend = function(e) {
      this.content = reader.result.trim();
      var pos=this.content.lastIndexOf(">");
      console.log(pos);
      this.content=this.content.substring(0, pos+1);
      this.processContent();
    }.bind(this);
    reader.readAsText(file, encoding);
};
Fb2.prototype.processContent=function(){
	console.log("processContent");
	//ver como meterla en el replace text
	this.content=this.content.replace(/<\s*?title\s*?>([\s\S]*?)<\/\s*?title\s*?>/gi, "<h1>$1</h1>");
	this.content=this.content.replace(/<image\s*\w*:href=[\"']#(.+?)[\"'].*?/gi, "<img src=\"$1\"");
	
	try{
		var domi=$.parseXML(this.content);
		this.dom=$(domi);
		
		this.encoding=this.dom[0].xmlEncoding;
		if(!this.encodingSecond && this.encoding.toLowerCase()!="utf-8"){
			this.encodingSecond=true;
			this.readfile(this.fileToRead, this.encoding);
		}else{
			this.encoding="utf-8";
			this.parseDescription();
			this.title=this.description.titleinfo.booktitle;
			this.author=this.description.titleinfo.author.firstname;
			if(this.description.titleinfo.author.middlename)
				this.author+=" "+this.description.titleinfo.author.middlename;
			if(this.description.titleinfo.author.lastname)
				this.author+=" "+this.description.titleinfo.author.lastname;
			this.doImagenes();
			if(this.cover!=""){
				this.newCoverPage();
			}
		
			this.totalFiles=this.dom.find("binary").length+this.dom.find("body").length;
		}
	}catch(e){
		console.log(e);
		this.onError(e);
	}
};
Fb2.prototype.newCoverPage=function(){
	var htmlTemplate="<html><head><meta charset=\""+this.encoding+"\"/><title>" + this.description.titleinfo.booktitle + "</title><link rel=\"stylesheet\" href=\"local:///css/defaultstyles.css\" /></head><body><img src=\"" + this.cover + "\" style=\"width:auto !important; height:90% !important; margin-left: auto !important; margin-right: auto !important;\"/></body></html>";
	var file={};
	file.title="Cover page";
	file.url="";
	file.html=htmlTemplate;
	file.id="cover.html";
	file.contentType="text/html";
	this.newbook.addFile(file);
	
	this.addToToc("cover.html", "Cover page", file.html.length);
};

Fb2.prototype.parseDescription=function(){
    console.log("Parse description");
    var este=this;
    
    this.dom.find("description").each(function () {
      var titleinfo = $(this).find("title-info");
      este.description.titleinfo = new Object();

      este.description.titleinfo.author = new Object();
      este.description.titleinfo.author.firstname = $(titleinfo).find("author").find("first-name").text();
      este.description.titleinfo.author.middlename = $(titleinfo).find("author").find("middle-name").text();
      este.description.titleinfo.author.lastname = $(titleinfo).find("author").find("last-name").text();

      este.description.titleinfo.booktitle = $(titleinfo).find("book-title").text();

      este.description.titleinfo.annotation = $(titleinfo).find("annotation");
      //este.description.titleinfo.annotation = $(titleinfo).find("annotation").text();
      
      este.description.titleinfo.keywords = $.map($(titleinfo).find("keywords").text().split(","), $.trim);
      este.description.titleinfo.date = {value:$(titleinfo).find("date").attr("value"), date:$(titleinfo).find("date").text()};


	  este.description.titleinfo.coverpage="";
	  este.cover="";
	  try{
	      este.description.titleinfo.coverpage = $(titleinfo).find("coverpage").children("img").attr("src");
	      if(este.description.titleinfo.coverpage)
	    	  este.cover=este.description.titleinfo.coverpage;
	  }catch(e){
		  console.log(e);
      }
      
      este.description.titleinfo.lang = $(titleinfo).find("lang").text();

      var documentinfo = $(this).find("document-info");
      este.description.documentinfo = new Object();
      este.description.documentinfo.author = new Object();
      este.description.documentinfo.author.firstname = $(documentinfo).find("author").find("first-name").text();
      este.description.documentinfo.author.middlename = $(documentinfo).find("author").find("middle-name").text();
      este.description.documentinfo.author.lastname = $(documentinfo).find("author").find("last-name").text();
      var publishinfo = $(this).find("publish-info");
      este.description.publishinfo = new Object();
      este.description.publishinfo.bookname = $(publishinfo).find("book-name").text();;
      este.description.publishinfo.publisher = $(publishinfo).find("publisher").text();;
    }).bind(this);
};

Fb2.prototype.cargaPaginas=function(){
    this.bodis = this.dom.find("body");
    this.numbodis=this.bodis.length;
    this.puntnumbodis=0;
    this.perbodis=50/this.numbodis;//para el % cargado
    this.percentage=20;
	console.log("BODIES: "+this.numbodis);
	this.processBodi();
};

Fb2.prototype.processBodi=function(){
	if(this.cancelled){
		return;
	}

	if(this.puntnumbodis<this.numbodis){
		var mybodi=$(this.bodis[this.puntnumbodis]);
		this.puntnumbodis++;
		this.procesaElementoBody(mybodi);
		this.currentFiles++;
	}else{
		console.log("END PROCESSING BODIES ");
		this.createFilesPunt=0;
		this.createAllfiles();
	}
};


Fb2.prototype.procesaElementoBody=function(body){
	this.addAnnotationPage();
    var filename = null;
	this.filesectioname = body.attr('name') ? (body.attr('name')) : ("");
    if (this.filesectioname.length == 0){
		this.filesectioname = "file"+this.puntnumbodis;
    }
    console.log("procesaElementoBody "+this.filesectioname);
	filename = this.filesectioname + ".html";
    this.newCuerpoPage(body, filename);
	this.section = body.children('section');
	this.numsections=this.section.length;
	this.puntsections=0;
	this.persection=this.perbodis/this.numsections;//para el % cargado
	
	console.log("PROCESING SECTIONS: "+this.numsections);
	
	this.procesaElementoBodyEvent();
};
Fb2.prototype.addAnnotationPage=function(){
	console.log("addAnnotationPage");
	if (!this.description.titleinfo.annotation || this.description.titleinfo.annotation=="" || this.description.titleinfo.annotation.length==0){
		return;
	}
	var htmlTemplate = $($.parseXML("<html><head><meta charset=\""+this.encoding+"\"/><title>" + this.description.titleinfo.booktitle + "</title><link rel=\"stylesheet\" href=\"local:///css/defaultstyles.css\" /></head><body></body></html>"));
	htmlTemplate.find('body').append(this.description.titleinfo.annotation.children());
	console.log(htmlTemplate);
	var file={};
	file.title="Annotation";
	file.url="";
	file.html=this.xmlToText(htmlTemplate).replace(/xmlns="http:\/\/www.gribuser.ru\/xml\/fictionbook\/2.0"/gi, "");
	file.id="annotation.html";
	file.contentType="text/html";
	this.newbook.addFile(file);

	this.addToToc("annotation.html", "Annotation", file.html.length);
};

Fb2.prototype.procesaElementoBodyEvent=function(){
	if(this.cancelled){
		return;
	}
	if (this.puntsections < this.numsections){
		var mysection=$(this.section[this.puntsections]);
		this.puntsections++;
		this.procesaElementoSeccion(mysection, this.puntsections, this.filesectioname, 0);
		this.percentage+=this.persection;
		this.onProgress("Extracting book", this.percentage, 100);
		
	}else{
		console.log("END PROCESSING SECTIONS");
		setTimeout(function(){
			this.processBodi();
		}.bind(this), 50);
	}
};
Fb2.prototype.procesaElementoSeccion=function(section, idx, prefix, indent){
	var wasmain=(indent==0);
    var sectionName;
    var sectionTitleFile;
    var i=0;
    var sectionFile;
    var title="";
    var htmlTemplate = $($.parseXML("<html><head><meta charset=\""+this.encoding+"\"/><title>" + this.description.titleinfo.booktitle + "</title><link rel=\"stylesheet\" href=\"local:///css/defaultstyles.css\" /></head><body></body></html>"));
    var sectionList = section.children('section');
    var sectionId = section.attr('id');
    
    if (sectionId && sectionId.length > 0){
        sectionName = prefix + "_" + sectionId;
    }else{
        sectionName = prefix + "_" + idx;
    }
    if (sectionList.length > 0){
        sectionTitleFile = sectionName + ".html";
        this.newSectionPage(section, sectionTitleFile);
        
		indent++;
        while (i < sectionList.length){
            this.procesaElementoSeccion($(sectionList[i]), (i + 1), sectionName, indent);
            this.onProgress("Extracting book", Math.floor(this.percentage+(this.persection/sectionList.length)), 100);
            i++;
        }
    }else{
        htmlTemplate.find('body').append(section.children());
        sectionFile = sectionName + ".html";
        section.find("h1").each(function(){title=$(this).text();});
    	
		var file={};
		file.title=title;
		file.url="";
		file.html=this.xmlToText(htmlTemplate).replace(/xmlns="http:\/\/www.gribuser.ru\/xml\/fictionbook\/2.0"/gi, "");
		file.id=sectionFile;
		file.contentType="text/html";
		this.newbook.addFile(file);
		
        if (!title || title.length == 0){
            this.addToToc(sectionFile, sectionName, file.html.length);
        }else{
            this.addToToc(sectionFile, title, file.html.length, indent);
        }
    }
    //si he acabado el bodi
    if(wasmain){
		setTimeout(function(){
			this.procesaElementoBodyEvent();
		}.bind(this), 50);
    }
};
Fb2.prototype.xmlToText=function(xmlData){
	//var foo = xmlData.find("html").get(0);
	var oSerializer = new XMLSerializer(); 
	var str=oSerializer.serializeToString(xmlData.get(0));
	
	str=str.replace(/empty-line(\s*)?/gi, "br");
	str=str.replace(/<image\s*\w*:href=[\"']#(.+?)[\"'].*?/gi, "<img src=\"$1\"");
	//str=str.replace(/<\s*?title\s*?>([\s\S]*?)<\/\s*?title\s*?>/gi, "<h1>$1</h1>");
	str=str.replace(/<\s*?subtitle\s*?>([\s\S]*?)<\/\s*?subtitle\s*?>/gi, "<h2>$1</h2>");
	str=str.replace("==", "=");

	
	return this.replaceLinks(str);
};

Fb2.prototype.replaceLinks=function(str){
	var  img_index_pattern = /<\s*?a [^>]*?>/gi;
	var match;
	while ((match=img_index_pattern.exec(str)) !=null) {
	    var _loc_5 = null;
	    var _loc_6 = null;
	    var tester = /href=["|']#([^"|^']*)["|']/i;
	    var _loc_3 = /type=["|']([^"|^']*)["|']/i;
	    var _loc_4 = /\w*:href/i;
	    if(match[0]){
	        _loc_5 = tester.exec(match[0]);
	        _loc_6 = _loc_3.exec(match[0]);
	        if (_loc_5 && _loc_6 && _loc_5.length > 1 && _loc_6.length > 1){
	        	str=str.replace(match[0], "<a " + "class=\"footnote\"" + " href=\"" + _loc_6[1] + "s_" + _loc_5[1] + ".html" + "\">");
	        }else{
	        	var rep=match[0].replace(_loc_4, "href");
	        	str=str.replace(match[0], rep);
	        }
	    }
	}
	return str;
};
Fb2.prototype.newSectionPage=function(section, sectionTitleFile){
    var index=0;
    var htmlTemplate = $($.parseXML("<html><head><meta charset=\""+this.encoding+"\"/><title>" + this.description.titleinfo.booktitle + "</title><link rel=\"stylesheet\" href=\"local:///css/defaultstyles.css\" /></head><body></body></html>"));
    var bodyParts = section.children();
	var title="";
	section.find("h1").each(function(){title=$(this).text();});
    
	var name=$(bodyParts[index])[0];
	
	while ((index<bodyParts.length) && name.tagName != "section"){
        htmlTemplate.find('body').append(bodyParts[index]);
        index = (index + 1);
		name=$(bodyParts[index])[0];
    }
	var file={};
	file.title=title;
	file.url="";
	file.html=this.xmlToText(htmlTemplate).replace(/xmlns="http:\/\/www.gribuser.ru\/xml\/fictionbook\/2.0"/gi, "");
	file.id=sectionTitleFile;
	file.contentType="text/html";
	this.newbook.addFile(file);
	
	this.addToToc(sectionTitleFile, title, file.html.length);
};

Fb2.prototype.newCuerpoPage=function(body, bodyTitleFile){
	console.log("procesing newCuerpoPage "+ bodyTitleFile);
    var index=0;
    var htmlTemplate = $($.parseXML("<html><head><meta charset=\""+this.encoding+"\"/><title>" + this.description.titleinfo.booktitle + "</title><link rel=\"stylesheet\" href=\"local:///css/defaultstyles.css\" /></head><body></body></html>"));
    var bodyParts = body.children();
	var name=$(bodyParts[index])[0];
	var concontenido=false;
	var title="";
	body.find("h1").each(function(){title=$(this).text();});
	
	while ((index<bodyParts.length) && name.tagName != "section"){
        htmlTemplate.find('body').append(name);
        index = (index + 1);
		name=$(bodyParts[index])[0];
		concontenido=true;
    }
	if(concontenido){
		var file={};
		file.title=bodyTitleFile;
		file.url="";
		file.html=this.xmlToText(htmlTemplate).replace(/xmlns="http:\/\/www.gribuser.ru\/xml\/fictionbook\/2.0"/gi, "");
		file.id=bodyTitleFile;
		file.contentType="text/html";
		this.newbook.addFile(file);
		
		this.addToToc(bodyTitleFile, title, file.html.length);
	}
};
Fb2.prototype.doImagenes=function(){
	this.images=this.dom.find("binary");
    if (this.images.length>0){
		console.log("NUM IMAGES: "+ this.images.length);
		this.numImages=this.images.length;
		this.imageper=20/this.numImages;
		this.processImage();
    }else{
		this.cargaPaginas();
	}
    return;
};

Fb2.prototype.processImage=function(){
	if(this.cancelled){
		return;
	}
	if(this.numImages>0){
		this.percentage+=this.imageper;
		this.numImages=this.numImages-1;
		this.guardaImagen($(this.images[this.numImages]).attr('id'), $(this.images[this.numImages]).text(), $(this.images[this.numImages]).attr('content-type'));
		
		this.onProgress("Extracting book", this.percentage, 100);
	}else{
		this.onProgress("Extracting book", 20, 100);
		this.cargaPaginas();
	}
};

Fb2.prototype.decode64=function(input) {
	var _keyStr= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
	
	//get last chars to see if are valid
	var lkey1 = _keyStr.indexOf(input.charAt(input.length-1));	
	var lkey2 = _keyStr.indexOf(input.charAt(input.length-2));	
	var bytes = (input.length/4) * 3;
	if (lkey1 == 64) bytes--; //padding chars, so skip
	if (lkey2 == 64) bytes--; //padding chars, so skip
	var uarray;
	var chr1, chr2, chr3;
	var enc1, enc2, enc3, enc4;
	var i = 0;
	var j = 0;

	uarray = new Uint8Array(bytes);
	
	input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
	for (i=0; i<bytes; i+=3) {	
	//get the 3 octects in 4 ascii chars
	enc1 = _keyStr.indexOf(input.charAt(j++));
	enc2 = _keyStr.indexOf(input.charAt(j++));
	enc3 = _keyStr.indexOf(input.charAt(j++));
	enc4 = _keyStr.indexOf(input.charAt(j++));
	chr1 = (enc1 << 2) | (enc2 >> 4);
	chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
	chr3 = ((enc3 & 3) << 6) | enc4;
	uarray[i] = chr1;	
	if (enc3 != 64) uarray[i+1] = chr2;
	if (enc4 != 64) uarray[i+2] = chr3;
	}
	return uarray;	
};

Fb2.prototype.guardaImagen=function(fileName, encodedImage, ctype){
	if(this.cover=="" && fileName.toLowerCase().indexOf("cover")>=0){
		this.cover=fileName;
	}
	encodedImage=encodedImage.trim();
	encodedImage = encodedImage.replace(/\s/g, '');
	
	var file={};
	file.title=fileName;
	file.url="";
	file.html=this.decode64(encodedImage);
	file.id=fileName;
	file.contentType=ctype;
	this.newbook.addFile(file);
	this.currentFiles++;
	this.onProgress("Extracting image", this.currentFiles, this.totalFiles);
	//this.processImage();//con delay para dar visibilidad
	setTimeout(function(){
		this.processImage();
	}.bind(this), 50);
};
  

Fb2.prototype.addToToc=function(filename, param2, size, indent){
    var _loc_5 = null;
    var _loc_6 = null;
    var _loc_7 = null;
    var _loc_8 = 0;
    var _loc_9 = 0;
    var _loc_3 = /"""""/g;
	var title="";
	
	if(!indent)
		indent=0;
    if (!param2){
		title = "";
    }else if (typeof param2 == 'string' || param2 instanceof String){
		title = param2;
    }else{//es xml
        if (param2.length > 0){
            _loc_5 = "";
            _loc_6 = param2.find("p");
            if (_loc_6 && _loc_6.length > 0){
                _loc_8 = 0;
                while (_loc_8 < _loc_6.length){
                    _loc_7 = _loc_6[_loc_8].text();
                    _loc_9 = 0;
                    while (_loc_9 < _loc_7.length){
                        _loc_5 = _loc_5 + (_loc_7[_loc_9].toString() + " ");
                        _loc_9++;
                    }
                    _loc_8++;
                }
            }else {
				title = "";
            }
            if (!_loc_5){
                _loc_5 = "";
            }
			title = String(_loc_5).replace(_loc_3, "\'");
        }else{
			title = "";
        }
    }
	if(title=="")
		title=this.tocpointer.toString(10);
	
	var indentstr="";
	for(var i=0; i<indent; i++){
		indentstr+="          ";
	}
	var temp={};
	temp.src=filename;
	temp.label=indentstr+title;
	temp.playOrder=this.tocpointer;
	temp.size=size;
	this.spine.push(temp);
	//var per:String=Math.floor(tocpointer*percenLoaderInit/spines.length()).toString();
	//per++;
	//this.dispatchEvent(new EpubEvent(EpubEvent.Loading, per.toString(10)));
	this.tocpointer++;
};
Fb2.prototype.getTotalSize=function(){
	this.size=0;
	for(var i=0; i<this.spine.length; i++){
		var item=this.spine[i];
		this.size+=item.size;
	}
};
Fb2.prototype.saveBook=function(){
	//%:20 images, 50 content, 30 save files 
	if(this.cancelled){
		return;
	}
	this.onProgress("Saving book", 100, 100);
	this.getTotalSize();
	if(this.toc.length==0)
		this.toc=this.spine;
	if(this.cover!="")
		this.cover="file://"+blackberry.io.home+"/books/"+this.identifier+"/"+this.cover;
	else
		this.cover="local://assets/cover.png";

	var b=new Book();
	b.identifier=this.identifier;
	b.bookfolder=this.bookdir.fullPath;
	b.title=this.title;
	if(b.title=="")
		b.title="Unknown";
	b.autor=this.author;
	b.cover=this.cover;
	b.lastdate=0;
	b.isCollection=false;
	b.size=this.size;
	b.format="fb2";
	b.spine=this.spine;
	b.toc=this.toc;
	
	console.log(b);
	b.saveBook();
	this.onComplete();
};

Fb2.prototype.createAllfiles=function(){
	//this.bookdir
	if(this.createFilesPunt<this.newbook.files.length){
		//for(var i=0; i<this.newbook.files.length; i++){
		this.percentage+=(30/this.newbook.files.length);
		this.onProgress("Saving book", Math.floor(this.percentage), 100);
		var file=this.newbook.files[this.createFilesPunt];
		this.createFilesPunt++;
		var folders=file.id.split('/');
		folders.pop();
		if(folders.length>0)
			this.createDir(this.bookdir, file, folders);
		else
			this.createFile(file);
	}else{
		this.saveBook();
	}
};
Fb2.prototype.createDir=function(rootFolder, file, folders) {
	rootFolder.getDirectory(folders[0], {create: true}, function(dirEntry) {
		folders=folders.slice(1);
	    if (folders.length>0) {
	    	this.createDir(dirEntry, file, folders);
	    }else{
	    	this.createFile(file);
	    }
	  }.bind(this), function(e){
		  	this.creationError(e);
			setTimeout(function(){
				this.createAllfiles();
			}.bind(this), 50);
	  }.bind(this));
};
Fb2.prototype.createFile=function(entry){
	this.bookdir.getFile(entry.id, {create:true}, function(fileEntry) {
	    fileEntry.createWriter(function(fileWriter) {
	      fileWriter.onwriteend = function(e) {
			setTimeout(function(){
				this.createAllfiles();
			}.bind(this), 50);
	      }.bind(this);
	      fileWriter.onerror = function(e) {
	        console.log('Write failed: ' + e.toString());
			setTimeout(function(){
				this.createAllfiles();
			}.bind(this), 50);
	      }.bind(this);

	      // Create a new Blob and write it to log.txt.
	      //var bb = new BlobBuilder();
	      var aFileParts = [entry.html];
	      var bb = new Blob(aFileParts, {type : entry.contentType});
	      fileWriter.write(bb);
	    }.bind(this), function(e){
			  	this.creationError(e);
				setTimeout(function(){
					this.createAllfiles();
				}.bind(this), 50);
		}.bind(this));
	}.bind(this), function(e){
		  	this.creationError(e);
			setTimeout(function(){
				this.createAllfiles();
			}.bind(this), 50);
	}.bind(this));
};

Fb2.prototype.creationError = function(e){
	console.log("CREATION Error");
	console.log(e);
};

Fb2.prototype.xmlDocument=function(c) {
	var d = new DOMParser().parseFromString(c, "text/xml");
	if (d.childNodes[1] && d.childNodes[1].nodeName === "parsererror") {
		//throw d.childNodes[1].childNodes[0].nodeValue;
		this.onError("error reading book container");
	}
	return d;
};
Fb2.prototype.cancel=function() {
	this.cancelled=true;
};