DataView.prototype.readUTFBytes=function(off, len){
	var kk=new DataView(this.buffer, off, len);
	return TextDecoder("utf-8").decode(kk);
};
DataView.prototype.readUTFBytesToEncoding=function(off, len, encoding){
	var kk=new DataView(this.buffer, off, len);
	try{
		return TextDecoder(encoding).decode(kk);
	}catch(e){
		return TextDecoder("utf-8").decode(kk);
	}
};
DataView.prototype.readBytes=function(off, len){
	var buffer = new ArrayBuffer(len);
	var uint8 = new Uint8Array(buffer);
	
	var original = new Uint8Array(this.buffer);
	var neworig=original.subarray(off, off+len);
	
	uint8.set( neworig);
	var dv=new DataView(buffer);
	return dv;
};
DataView.prototype.writeByte=function(pos, data){
	var l=this.byteLength;
	var total=pos+1;//1 byte
	if(total>=l){
		var buffer = new ArrayBuffer(total);
		var uint8 = new Int8Array(buffer);
		uint8.set( new Int8Array( this.buffer ), 0 );///
		
		var dv=new DataView(buffer);
		dv.setInt8(pos, data);
		return dv;
	}else{
		this.setInt8(pos, data);
		return this;
	}
};
DataView.prototype.writeBytes=function(writeposition, origbuffer, pos, length){
	var l=this.byteLength;
	var total=writeposition+length;
	if(total>=l){
		//buffer del tamaño final
		var buffer = new ArrayBuffer(total);
		var uint8 = new Uint8Array(buffer);
		
		uint8.set( new Uint8Array( this.buffer ), 0 );
		//cojo el trozo a copiar
		var original = new Uint8Array(origbuffer);
		var neworig=original.subarray(pos, pos+length);

		uint8.set( neworig, writeposition);
		var dv=new DataView(buffer);
		return dv;
	}else{
		var position=writeposition;
    	//leo el trozo a un auxiliar y pinto luego en el original
        var temp=new DataView(origbuffer, pos, length);//origin, offset, size
        
        for(var i=0; i<temp.byteLength; i++){
        	this.setUint8(position, temp.getUint8(i));
        	position++;
        }

		return this;
	}
};


DataView.prototype.writeBytes2=function(writeposition, origbuffer, pos, length){
	var l=this.byteLength;
	var offset=this.byteOffset;
	var total=writeposition+length;
	if(total>=l){
		//buffer del tamaño final
		var buffer = new ArrayBuffer(total);
		var uint8 = new Uint8Array(buffer);
		
		uint8.set( new Uint8Array( this.buffer, offset, l ) );
		//cojo el trozo a copiar
		var original = new Uint8Array(origbuffer);
		var neworig=original.subarray(pos, pos+length);

		uint8.set( neworig, writeposition);
		var dv=new DataView(buffer);
		return dv;
	}else{
		var position=writeposition;
    	//leo el trozo a un auxiliar y pinto luego en el original
        var temp=new DataView(origbuffer, pos, length);//origin, offset, size
        
        for(var i=0; i<temp.byteLength; i++){
        	this.setUint8(position, temp.getUint8(i));
        	position++;
        }

		return this;
	}
};

function Mobi(path){
	this.MOBI_BOOK_TYPE="BOOKMOBI";
	this.PALM_BOOK_TYPE="TEXtREAd";//
	this.MOBI_REC_TYPE="MOBI";//
	this.EXTH_REC_TYPE="EXTH";//
	this.NO_COMPRESSION=1;
	this.PALMDOC_COMPRESSION=2;
	this.HUFFCDIC_COMPRESSION=17480;
	this.HUFF_REC_TYPE="HUFF";
	this.SRCS_REC_TYPE="SRCS";
	this.FLIS_REC_TYPE="FLIS";
	this.FCIS_REC_TYPE="FCIS";
	this.FDST_REC_TYPE="FDST";
	this.DATP_REC_TYPE="DATP";
	this.CDIC_REC_TYPE="CDIC";
	this.NO_ENCRYPTION=0; //0 == no encryption, 1 = Old Mobipocket Encryption, 2 = Mobipocket Encryption
	
	this.dataRecords=[];
	this.compressionType=0;
	this._huffEncInfo;
	this._isAdvancedMobiParser = true;
	this.bookType;
	this.textRecordCount;
	this.textRecordSize;
	this.encryptionType;
	this.codePage;
	this.imageRecordIdx;		
	this.isMultibyteRecord;
	this.coverIdx=-1;
	this.thumbIdx=-1;
	this.publisher;
	this.description;
	this.isbn;
	this.creatorSoftware;
	this.isRawDataAvailable=false;
	this.trailerRecordNumber=0;
	this.imageRecords=[];
	this.htmlFileName="file.html";
	this.tocpointer=0;
	this.cover=null;
	this.thumb=null;
	this.per=0;
	this.kf8_header=0;

	
	this.title="";
	this.author="";
	this.cover="";
	
	this.content=null;
	this._bookStream;
	this._bookStreamPosition=0;
	this.rawData="";
    this.rawDataArrBuf=new ArrayBuffer(1);
	this.rawDataArr= new DataView(this.rawDataArrBuf);
	this.pointsSpine=[];
	this.totalSize=0;
	
	this.path=path;
	this.identifier=null;
	this.size=0;
	this.bookdir=null;

	this.book=new NewBook();
	this.filesystem=null;
	this.booksFolder=null;
}

Mobi.prototype.onComplete=function(){};
Mobi.prototype.onProgress=function(status, current, total){};
Mobi.prototype.onError=function(error){};
Mobi.prototype.onExistingBook=function(){};
Mobi.prototype.logConsole=function(message){};

Mobi.prototype.extract=function(worker, home){
	this.filesystem = worker.requestFileSystemSync(PERSISTENT, 1024*1024);
	this.logConsole("onInitFs");
	this.booksFolder=this.filesystem.root.getDirectory(home+"/books/", {create:true});
	var fileEntry=this.filesystem.root.getFile(this.path, {});
	var file=fileEntry.file();
	var metadata=fileEntry.getMetadata();
    this.logConsole(metadata.size);
    this.size=metadata.size;
	this.identifier=getFileIdentifier(fileEntry.name)+this.size;
	this.setIdentifier(this.identifier);
	//var book=localStorage.getObject(this.identifier);
	this.logConsole("Identifier: "+this.identifier);
	this.bookdir=this.booksFolder.getDirectory(this.identifier, {create: true});
	
	this.logConsole("readfile");
    var reader = new FileReaderSync();
    this.content=reader.readAsArrayBuffer(file);
    this.readPDBHeader();
};
Mobi.prototype.setIdentifier=function(){};

Mobi.prototype.readPDBHeader=function(){
	this.logConsole(this.content);
	this._bookStream=new DataView(this.content);
	this.logConsole(this._bookStream);

	
	this._bookStreamPosition = 0;
	var dbName=this._bookStream.readUTFBytes(0, 32);
	this.logConsole(dbName);
	if (dbName.substring(0, 3) == "TPZ"){
		this.onError("Not valid file");
	}else{
		var titulo= dbName;
		var version = this._bookStream.getUint16(34);
		this.bookType = this._bookStream.readUTFBytes(60, 8);
		this.logConsole(titulo, version, this.bookType);
	
		this.title=new TextDecoder("windows-1252").decode(this._bookStream.readBytes(0, 32));//for palmdoc
		var _loc_1 = this._bookStream.getUint16(76);
		this.logConsole("_loc_1: "+_loc_1);
		this._bookStreamPosition=78;
	
		this.dataRecords = new Array(_loc_1);
		for(var i=0; i<_loc_1; i++){
			this.dataRecords[i] = {offset:this._bookStream.getUint32(this._bookStreamPosition), size:0};
			if (i > 0){
				this.dataRecords[(i - 1)].size = this.dataRecords[i].offset - this.dataRecords[(i - 1)].offset;
			}
			this._bookStreamPosition = this._bookStreamPosition + 8;
		}
		this.logConsole("this.dataRecords: ", this.dataRecords);
		this.onProgress("Extracting book", 1, 100);
		this.readMobiRecord();
	}
};

Mobi.prototype.readMobiRecord=function(){
	var _loc_2 = 0;
	var _loc_3 = 0;
	var _loc_4 = 0;
	var _loc_5 = false;
	var _loc_6 = 0;
	var _loc_7 = 0;
	var _loc_8 = 0;
	var _loc_9 = 0;
	var _loc_10 = null;
	var _loc_11 = 0;
	if (!this.dataRecords || this.dataRecords.length == 0){
		this.onError("Not valid file");
	}else{
		this._bookStreamPosition = this.dataRecords[0].offset;
		this.compressionType = this._bookStream.getUint16(this._bookStreamPosition);
		this.logConsole("compressionType: "+this.compressionType);
		this._bookStreamPosition = this._bookStreamPosition + 6 + 2;
		this.textRecordCount = this._bookStream.getUint16(this._bookStreamPosition);
		this._bookStreamPosition = this._bookStreamPosition + 2;
		this.textRecordSize = this._bookStream.getUint16(this._bookStreamPosition);
		this._bookStreamPosition = this._bookStreamPosition + 2;
		this.encryptionType = this._bookStream.getUint16(this._bookStreamPosition);
		this._bookStreamPosition = this.dataRecords[0].offset + 16;
		
		var recType = this._bookStream.readUTFBytes(this._bookStreamPosition, 4);
		this._bookStreamPosition=this._bookStreamPosition+4;
	this.logConsole("MOBI_REC_TYPE: "+recType);
		
		if (recType == this.MOBI_REC_TYPE){
			_loc_2 = this._bookStream.getUint32(this._bookStreamPosition);
			this._bookStreamPosition = this.dataRecords[0].offset + 28;
			this.codePage = this.getCodePageById(this._bookStream.getUint32(this._bookStreamPosition));
	this.logConsole("codePage: "+this.codePage);
	
			this._bookStreamPosition = this.dataRecords[0].offset + 36;
			this.version = this._bookStream.getUint32(this._bookStreamPosition);
	this.logConsole("version: "+this.version);
	
			this._bookStreamPosition = this.dataRecords[0].offset + 84;
			_loc_3 = this._bookStream.getUint32(this._bookStreamPosition);
			this.logConsole("_loc_3: "+_loc_3);
			this._bookStreamPosition = this._bookStreamPosition+4;
			_loc_4 = this._bookStream.getUint32(this._bookStreamPosition);
			this._bookStreamPosition = this.dataRecords[0].offset + 108;
			this.imageRecordIdx = this._bookStream.getUint32(this._bookStreamPosition);
			this.logConsole("compressionType: "+this.compressionType);
			this.logConsole("imageRecordIdx: "+this.imageRecordIdx);
			
			if (this.compressionType == this.HUFFCDIC_COMPRESSION){
				this.onProgress("HUFF", 0, 0);
				this._huffEncInfo = new HUFFCDICInfo();
				this._bookStreamPosition = this.dataRecords[0].offset + 112;
				this._huffEncInfo.huffRecordOfs = this._bookStream.getUint32(this._bookStreamPosition);
				this._bookStreamPosition=this._bookStreamPosition+4;
				this._huffEncInfo.huffRecordCount = this._bookStream.getUint32(this._bookStreamPosition);
				this._bookStreamPosition=this._bookStreamPosition+4;
				this._huffEncInfo.huffTableOfs = this._bookStream.getUint32(this._bookStreamPosition);
				this._bookStreamPosition=this._bookStreamPosition+4;
				this._huffEncInfo.huffTableLen = this._bookStream.getUint32(this._bookStreamPosition);
			}
			
			this._bookStreamPosition = this.dataRecords[0].offset + 128;
			_loc_5 = false;
			if (this._bookStream.getUint32(this._bookStreamPosition) & 64){
				_loc_5 = true;
			}
			this.logConsole("_loc_5: "+_loc_5);
			if (_loc_2 >= 228){
				this._bookStreamPosition = this.dataRecords[0].offset + 242;
				_loc_6 = this._bookStream.getUint16(this._bookStreamPosition);
				if (_loc_6 & 1){
					this.isMultibyteRecord = true;
				}
				this.logConsole("isMultibyteRecord: "+this.isMultibyteRecord);
				while (_loc_6 > 1){
					if (_loc_6 & 2){
						this.trailerRecordNumber = this.trailerRecordNumber+1;
					}
					_loc_6 = _loc_6 >> 1;
				}
			}

			this._bookStreamPosition = this.dataRecords[0].offset + _loc_3;
			this.title = this._bookStream.readUTFBytes(this._bookStreamPosition, _loc_4);
this.logConsole("title: "+this.title);
			if (_loc_5){
				this._bookStreamPosition = this.dataRecords[0].offset + _loc_2 + 16;
				if (this._bookStream.readUTFBytes(this._bookStreamPosition, 4) == this.EXTH_REC_TYPE){
					this.logConsole("ES EXTH_REC_TYPE");
					this._bookStreamPosition = this._bookStreamPosition + 4 + 4;
					_loc_7 = this._bookStream.getUint32(this._bookStreamPosition);
					_loc_11 = 0;
					this._bookStreamPosition = this._bookStreamPosition + 4;
					while (_loc_11 < _loc_7){
						_loc_8 = this._bookStream.getUint32(this._bookStreamPosition);
						this._bookStreamPosition = this._bookStreamPosition + 4;
						_loc_9 = this._bookStream.getUint32(this._bookStreamPosition) - 8;
						this._bookStreamPosition = this._bookStreamPosition + 4;
						if (_loc_8 == 201){
							this.coverIdx = this._bookStream.getUint32(this._bookStreamPosition);
							this._bookStreamPosition = this._bookStreamPosition + 4;
this.logConsole("coverIdx: "+this.coverIdx);
						}else if (_loc_8 == 121){
							kf8_header = this._bookStream.getUint32(this._bookStreamPosition);
							this._bookStreamPosition = this._bookStreamPosition + 4;
						}else if (_loc_8 == 202){
							this.thumbIdx = this._bookStream.getUint32(this._bookStreamPosition);
							this._bookStreamPosition = this._bookStreamPosition + 4;
this.logConsole("thumbIdx: "+this.thumbIdx);
						}else{
							_loc_10 = this._bookStream.readUTFBytes(this._bookStreamPosition, _loc_9);
							this._bookStreamPosition = this._bookStreamPosition + _loc_9;
this.logConsole("values: "+_loc_8+" => "+_loc_10);
							switch(_loc_8){
								case 100:this.author = _loc_10;break;
								case 101:this.publisher = _loc_10;break;
								case 103:this.description = _loc_10;break;
								case 104:this.isbn = _loc_10;break;
								case 204:this.creatorSoftware = _loc_10;break;
								//503 title
							}
						}
						_loc_11++;
					}
				}
			}
		}else if (this.bookType == this.PALM_BOOK_TYPE){
			this.imageRecordIdx = this.textRecordCount + 1;
		}
	}
	
	this.onProgress("Extracting book", 2, 100);
	this.logConsole("this.encryptionType: "+this.encryptionType);
	this.logConsole("this.bookType: "+this.bookType);
    if (this.encryptionType != this.NO_ENCRYPTION){
		this.onError("");
    }else if (this.bookType != this.MOBI_BOOK_TYPE && this.bookType != this.PALM_BOOK_TYPE){
    	this.onError("");
    }else{
        this.onProgress("Extracting book", 4, 100);
        if (this.compressionType == this.HUFFCDIC_COMPRESSION && this._huffEncInfo){
            this.readHUFFCDICRecord();
        }
       	this.decodeDataRecords();
       	delete this.decodeDataRecords;
       	
       	this.logConsole("FIN decodeDataRecords");
        if (this.isRawDataAvailable){
        	this.onError("");
        	return;
		}
		this.decodeImageRecords();
		this.logConsole(this.book);
		this.processDecodedData();
		this.saveBook();
    }
};


Mobi.prototype.decodeZippedData=function(){
	this.logConsole("DECODE ZIP");
	/*
    var _loc_5:EPubBookReader = null;
    var _loc_1:* = ebookdir.resolvePath(epub + ".zip");
    _bookStream.position = dataRecords[dataRecords.length - 2].offset + 16;
    var _loc_2:* = new FileStream();
    _loc_2.open(_loc_1, FileMode.WRITE);
    var _loc_3:* = new ByteArray();
    var _loc_4:* = dataRecords[dataRecords.length - 2].size - 16;
    _bookStream.readBytes(_loc_3, 0, _loc_4);
    _loc_2.writeBytes(_loc_3);
    _loc_2.close();
    _loc_2 = null;
    bookUnpack(_loc_1);
    _loc_1.deleteFile();
    if (_opfFileName){
        _loc_5 = new EPubBookReader();
        metadata = _loc_5.processContentFromMobi(bookFile, new File(_opfFileName), metadata);
    }
    else
    {
        createMetaData();
    }
    */
};

Mobi.prototype.decodeDataRecords=function(){
	this.logConsole("decodeDataRecords");
	var writeposition=0;
    var _loc_1 = null;
    this._bookStreamPosition = this.dataRecords[this.dataRecords.length - 2].offset;
	
    if (this._bookStream.readUTFBytes(this._bookStreamPosition, 4) == this.SRCS_REC_TYPE){
        if (!this._isAdvancedMobiParser){
        	this._bookStreamPosition = this.dataRecords[this.dataRecords.length - 2].offset + 16;
            if (this._bookStream.readUTFBytes(this._bookStreamPosition, 2) == "PK"){
                this.decodeZippedData();
                this.isRawDataAvailable = true;
                return;
            }
        }
    }
	var currentprogress=6;
    var maxprogres=69;
    if (this.compressionType == this.NO_COMPRESSION){
        _loc_1 = new UncompressedStreamDecoder();
    }else if (this.compressionType == this.PALMDOC_COMPRESSION){
        _loc_1 = new PalmDocDecoder();
    }else if (this.compressionType == this.HUFFCDIC_COMPRESSION){
    	currentprogress=21;
    	maxprogres=54;
        _loc_1 = new HuffCdicDecoder(this._huffEncInfo);
    }
    var _loc_3 = 1;

    while(_loc_3 < (this.textRecordCount + 1)){
		var pg=currentprogress+Math.ceil((_loc_3*maxprogres)/this.textRecordCount);
    	this.onProgress("Extracting book", pg, 100);
		this.adjustRecordSize(_loc_3);
		//this.logConsole("decoded start before ");
		var sba=_loc_1.decodeDataRecord(this._bookStream, this.dataRecords[_loc_3].offset, this.dataRecords[_loc_3].size, this.logConsole);
		this.logConsole("decoded start 2 "+writeposition +" "+ sba.byteLength);

		//this.logConsole("decodeDataRecords "+sba.readUTFBytesToEncoding(0, sba.byteLength, this.codePage));
		this.rawDataArr=this.rawDataArr.writeBytes(writeposition, sba.buffer, 0, sba.byteLength);
		writeposition=writeposition+sba.byteLength;
		this.rawData+=sba.readUTFBytesToEncoding(0, sba.byteLength, this.codePage);
		sba=undefined;
		delete sba;
		//this.logConsole(this.rawData);
		//this.logConsole(this.rawData);
		_loc_3++;
    }
    this.logConsole("FIN");
    _loc_1=null;
    //this.logConsole(this.rawDataArr);
    //this.logConsole(this.rawData);
};

Mobi.prototype.adjustRecordSize=function(param1){
    var _loc_4 = 0;
    var _loc_2;
    var _loc_3 = 0;
    var _loc_5 = 0;
    while (_loc_5 < this.trailerRecordNumber){
        this._bookStreamPosition = this.dataRecords[param1].offset + this.dataRecords[param1].size - 4;
        //this.logConsole("this._bookStreamPosition: "+this._bookStreamPosition+" param1: "+param1+" offset:"+this.dataRecords[param1].offset+" size: "+this.dataRecords[param1].size);
        _loc_2=new DataView(this._bookStream.buffer, this._bookStreamPosition, 4);
        
        _loc_3 = 0;
        var loc2Position=0;
        while (loc2Position<4){
            _loc_4 = _loc_2.getUint8(loc2Position);
            loc2Position++;
            
            if (_loc_4 & 128){
                _loc_3 = 0;
            }
            _loc_3 = _loc_3 << 7 | _loc_4 & 127;
        }
        //this.logConsole("adjustRecordSize: "+this.dataRecords[param1].size+" ==> "+(this.dataRecords[param1].size - _loc_3));
        this.dataRecords[param1].size = this.dataRecords[param1].size - _loc_3;
        _loc_2=undefined;
        _loc_5++;
    }
    if (this.isMultibyteRecord){
    	this._bookStreamPosition = this.dataRecords[param1].offset + this.dataRecords[param1].size - 1;
        _loc_4 = this._bookStream.getUint8(this._bookStreamPosition);
        _loc_3 = (_loc_4 & 3) + 1;
        //this.logConsole("isMultibyteRecord: "+this.dataRecords[param1].size+" ==> "+(this.dataRecords[param1].size - _loc_3));
        this.dataRecords[param1].size = this.dataRecords[param1].size - _loc_3;
    }
};



Mobi.prototype.decodeImageRecords=function(){
    var rectype = null;
    var imgtype = null;
    var filename = null;
    var auxdata = null;
    var perimgtot=15;//% de progress en imagenes
    
    var maxsize = this.dataRecords.length - 1;
	this.logConsole("maxsize: "+maxsize+" imageRecordIdx:"+this.imageRecordIdx);
	while(this.imageRecordIdx < maxsize){
		this._bookStreamPosition = this.dataRecords[this.imageRecordIdx].offset;
		rectype = this._bookStream.readUTFBytes(this._bookStreamPosition, 4);
		if (rectype != this.FLIS_REC_TYPE && rectype != this.FCIS_REC_TYPE && rectype != this.FDST_REC_TYPE && rectype != this.DATP_REC_TYPE && rectype != this.SRCS_REC_TYPE){
			auxdata=this._bookStream.readBytes(this._bookStreamPosition, 10);
			imgtype = this.getImageType(auxdata);
			auxdata=undefined;
			//this._bookStreamPosition = this.dataRecords[this.imageRecordIdx].offset;
			filename = "images/img" + (this.imageRecordIdx - this.textRecordCount - 1) + imgtype;
			this.imageRecords.push(filename);
		
			auxdata=this._bookStream.readBytes(this._bookStreamPosition, this.dataRecords[this.imageRecordIdx].size);
			
			var file={};
			file.title="";
			file.url="";
			file.html=auxdata;
			file.id=filename;
			file.contentType="image/"+(imgtype.replace(".", ""));
			this.book.addFile(file);
			
			this.logConsole("SAVING IMAGE "+filename+" "+auxdata.byteLength);
		}
		this.imageRecordIdx++;
		var pg=69+Math.floor(perimgtot/maxsize*this.imageRecordIdx);
		this.onProgress("Extracting book", pg, 100);
	}
	
	if (this.coverIdx < 0 && this.thumbIdx >= 0){
		this.coverIdx = this.thumbIdx;
	}else if(this.coverIdx < 0){
		//this.coverIdx=0;
	}
	if (this.coverIdx >= 0 && this.coverIdx < this.imageRecords.length){
		this.cover = this.imageRecords[this.coverIdx];
	}
	if (this.thumbIdx > -1){
		//cover = imageRecords[thumbIdx];
	}
};


Mobi.prototype.processDecodedData=function(){
    //try
    //{
		//var re:RegExp=/<\s*?a(.+?)filepos=['"\s]*([^>\s]*)['"\s]*([^>]*?)>/gis;
		//var s:String=rawData.readUTFBytes(rawData.bytesAvailable);
		//myTrace("MATCHS: "+s.match(re).length);
		//s=s.replace(re, "<a $1 filepos=\"$2\" $3>");
		//rawData=new ByteArray();
		//rawData.writeUTFBytes(s);
        if (this._isAdvancedMobiParser){
        	this.logConsole("_isAdvancedMobiParser");
            if (!this.processChapters(this.getToc())){
            	this.logConsole("ERROR WITH PROCESS CHAPTERS");
                this.writeCompleteBook();
            }
        }else{
        	this.logConsole("NOT _isAdvancedMobiParser");
            writeCompleteBook();
        }
    //}catch (err){
	//	this.logConsole("ERROR PROCESSING DECODED DATA "+err.toString());
	//}
    this.logConsole("END processDecodedData");
};

Mobi.prototype.writeCompleteBook=function(){
	this.logConsole("writeCompleteBook");
    
	var text=this.rawData;
	this.rawData=null;
	this.rawDataArr=null;
	
	var bodypos=text.indexOf("<body");
	var bodyend=text.indexOf(">", bodypos)+1;
	var mybodi=text.substring(0, bodyend);
	text=text.substring(bodyend);
	tex=text.replace("</body>", "");
	tex=text.replace("</html>", "");
	
	var guidepos=mybodi.indexOf("<guide");
	if(guidepos>=0){
		var guideend=mybodi.indexOf("/guide>");
		var prev=mybodi.substring(0, guidepos);
		var post=mybodi.substring(guideend+7);
		mybodi=prev+post;
	}
	var breaks = /<\s*?mbp:pagebreak[^>]*?>/gi;
	var pages=tex.split(breaks);
	var len=pages.length;
	
	for(var i=0; i<len; i++){
		var file={};
		file.title="";
		file.url="";
		file.html=mybodi+this.applyFilter(pages[i])+"</body></html>";
		file.id="chapter_" + i + ".html";
		file.contentType="text/plain";
		this.book.addFile(file);

		this.addComponent(file.id, "Chapter "+i, 0, file.html.length);
		
		var pg=89+Math.ceil((i*3)/len);
		this.onProgress("Extracting book", pg, 100);
	}
	this.onProgress("Extracting book", 92, 100);
};
Mobi.prototype.applyFilter=function(param1){
    //var _loc_2:* = /<\s*?font [^>]*?>|<\/\s*?font\s*?>|<\s*?h2 [^>]*?\/>|<\s*?div [^>]*?\/>|mbp:/gis;
	//var _loc_2:* = /<font [^>]*?>|<\/font>|<h2 [^>]*?\/>|<\s*?div [^>]*?\/>:/gis;
	var _loc_2 = /<font [^>]*?>|<\/font>/gi;
    //var _loc_3 = /<\s*?h2 [^>]*?\/>/gi;
	var breaks = /<\s*?mbp:pagebreak[^>]*?>/gi;
	param1=param1.replace(breaks, "<div class='break'></div>");
	param1=param1.replace(_loc_2, "");
	param1=this.replaceImgRefs(param1);
	return param1;
};

Mobi.prototype.replaceImgRefs=function(param1){
	//<img recindex="00002" align="baseline" height="100%" width="100%"/>
	this.logConsole("this.version: "+this.version);
	if(this.version==8){
		var  img_index_pattern = /['"]kindle:embed:([0-9|A-V]+)[^'"]*['"]/gi;
		var match;
		while ((match=img_index_pattern.exec(param1)) !=null) {
			this.logConsole(match);
			var _loc_5 = parseInt(match[1], 32);
			trace("REPLACING IMAGE "+" => "+match[1]);
			if (isNaN(_loc_5)){
				_loc_5 = 1;
			}
		    param1.replace(match[0], "\"" + imageRecords[(_loc_5 - 1)] + "\"");
		}
		
		var flow_pattern = /['"]kindle:flow:([0-9|A-V]+)\?mime=([^'"]+)['"]/gi;
		while ((match=flow_pattern.exec(param1)) !=null) {
			this.logConsole(match);
			var _loc_5 = parseInt(match[1], 32);
			trace("REPLACING FLOW "+" => "+match[1]);
			if (isNaN(_loc_5)){
				_loc_5 = 1;
			}
			param1.replace(match[0], "\"" + imageRecords[(_loc_5 - 1)] + "\"");
		}
		
		var aid_pattern = /\said\s*=['"][^'"]*['"]/gi;
		param1=param1.replace(aid_pattern, "");
		
		return param1;
	}
	//version distinta de 8
	var _loc_2 = / recindex=['"]{0,1}([0-9]+)['"]{0,1}/gi;
	this.logConsole("REPLACING IMAGES");
	while ((match=_loc_2.exec(param1)) !=null) {
	    var _loc_5 = parseInt(match[1]);
	    if (isNaN(_loc_5)){
	        _loc_5 = 1;
	    }
	    this.logConsole("REPLACING IMAGES: "+match[0]+" "+this.imageRecords[(_loc_5 - 1)]);    
	    param1=param1.replace(match[0], " src=\"" + this.imageRecords[(_loc_5 - 1)] + "\"");
	}
	
	return param1;
};

Mobi.prototype.processChapters=function(toc){
    var _loc_3 = 0;
    var _loc_4 = 0;
    var len = this.rawData.byteLength;
    var _loc_6 = 0;
    //var breaks = /<\s*?mbp:pagebreak[^>]*?>/gi;
    if (!toc || toc.length < 1){
		return false;
    }else{
        //createTitlePage();
        var i = 0;
        while (i < toc.length){
            _loc_3 = toc[i].pos;
            if (len > _loc_3){
            	len = _loc_3;
            }
            if (i < (toc.length - 1)){
                _loc_4 = toc[(i + 1)].pos;
            }else{
                _loc_4 = this.rawData.byteLength;
            }
            if (_loc_6 < _loc_4){
                _loc_6 = _loc_4;
            }
			
            this.createChapter(toc[i].title, this.rawDataArr.readUTFBytesToEncoding(_loc_3, (_loc_4 - _loc_3), this.codePage), (i + 1));
            i++;
            var pg=89+Math.ceil((i*3)/toc.length);
            this.onProgress("Extracting book", pg, 100);
        }
	}
    return true;
};
Mobi.prototype.createChapter=function(chapterTitle, chapterData, idx){
    var exp = /<\s*?a .*?filepos=["']*(.*?)["'\s>][^>]*?>[ ]*(.*?)[ ]*<\/a>/gi;
    chapterData=chapterData.replace(exp, "$2");
    
    var chapterFileName = "chapter_" + idx + ".html";
	var file={};
	file.title=chapterTitle;
	file.url="";
	file.html="<html><head><meta charset=\"utf-8\"/><title>" + chapterTitle + "</title></head><body>" + this.applyFilter(chapterData) + "</body></html>";
	file.id=chapterFileName;
	file.contentType="text/plain";
	this.book.addFile(file);
	
	this.logConsole(file);
    this.addComponent(chapterFileName, chapterTitle, idx, file.html.length);
};
Mobi.prototype.addComponent=function(chapterFileName, chapterTitle, idx, size){
	var title="";
    var _loc_5 = /"/g;
    if (!chapterTitle){
        title = "";
    }else{
        title = chapterTitle.replace(_loc_5, "\'");
    }
	
	if(title=="")
		title=this.tocpointer.toString(10);
	var temp={};
	temp.src=chapterFileName;
	temp.label=title;
	temp.playOrder=this.tocpointer;
	temp.size=size;
	this.totalSize+=temp.size;
	this.pointsSpine.push(temp);
	this.tocpointer++;
};
Mobi.prototype.getTocPos=function(){
	var len = 1024 * 5;
	if (len > this.rawData.length){
		len = this.rawData.length;
	}
	var text = this.rawData.substring(0, len);
	var exp = /<\s*?guide\s*?>.*?(<reference[^>]*?type\s*?=\s*?["']*toc["' \/>]*[^>]*?filepos\s*?=\s*?["']*(\d*)["']*[^>]*>).*?<\/\s*?guide\s*?>/i;
	while ((match=exp.exec(text)) !=null) {
		var _loc_5 = parseInt(match[2]);
		if (!isNaN(_loc_5)){
			return _loc_5;
		}
	}
	return 0;
};

Mobi.prototype.getToc=function(){
    var _loc_4 = null;
    var _loc_5 = 0;
    var _loc_6 = null;
    var _loc_7 = null;
    var _loc_8 = null;
    var _loc_10 = null;
    var _loc_11 = null;
    var _loc_12 = null;
    var _loc_13 = NaN;
    var _loc_2 = this.getTocPos();
    var position=0;

    if (_loc_2 > 0){
        _loc_4 = [];
        _loc_5 = 1024 * 100;
        position = _loc_2;
        if (_loc_5 > (this.rawDataArr.byteLength-position)){
            _loc_5 = this.rawDataArr.byteLength-position;
        }
        _loc_6 = this.rawDataArr.readUTFBytesToEncoding(position, _loc_5-1, this.codePage);
        
        position = 0;
        _loc_7 = /<\s*?mbp:pagebreak[^>]*?>/gi;
        _loc_8 = _loc_7.exec(_loc_6);
        _loc_9 = 0;
        if (_loc_8){
            _loc_9 = _loc_8.index;
        }else{
            _loc_9 = this.rawDataArr.byteLength;//param1.length;
        }
        _loc_10 = /<\s*?a .*?filepos=["']*(.*?)["'\s>][^>]*?>[ ]*(.*?)[ ]*<\/a>/gi;
        _loc_11 = [];
        
    	while ((_loc_12=_loc_10.exec(_loc_6)) !=null) {// && _loc_12.index < _loc_9
            _loc_13 = parseInt(_loc_12[1]);
            if (isNaN(_loc_13)){
                if (_loc_12[1] && _loc_12[1] == "XXXXXXXXXX"){
                    continue;
                }else{
                    return null;
                }
            }
            if (_loc_4.indexOf(_loc_13) > -1){
                continue;
            }else{
                _loc_4.push(_loc_13);
            }
            _loc_11.push({pos:_loc_13, title: this.getTitle(_loc_12[2])});
        }
    }else{
        return null;
    }
    if (_loc_11.length > 0 && _loc_4.indexOf(_loc_2) < 0){
        _loc_11.push({pos:_loc_2, title:"Table of Content"});
    }
    
    _loc_11.sort(function(a, b){
		if(a.pos < b.pos)
			return -1;
		else if(a.pos>b.pos)
			return 1;
		return 0;
	});

	this.logConsole(_loc_11);
    return _loc_11;
};

Mobi.prototype.getTitle=function(param1){
    var _loc_2 = /\n|\r/g;
    var _loc_3 = /<\s*?.*?>|<\/\s*?.*?\s*?>/gi;
    return param1.replace(_loc_2, "").replace(_loc_3, "");
};

Mobi.prototype.getImageType=function(param1){
	var position=0;
    var _loc_2 = param1.readUTFBytes(position, 4);
    if (_loc_2 == "GIF8"){
        return ".gif";
    }
    position = 6;
    _loc_2 = param1.readUTFBytes(position,4);
    if (_loc_2 == "JFIF"){
        return ".jpg";
    }
    position = 1;
    _loc_2 = param1.readUTFBytes(position,3);
    if (_loc_2 == "PNG"){
        return ".png";
    }
    position = 0;
    _loc_2 = param1.readUTFBytes(position,2);
    if (_loc_2 == "BM"){
        return ".bmp";
    }
	return ".jpg";
};

Mobi.prototype.saveBook=function(){
	this.rawData=null;
	this.rawDataArr=null;
	
	this.logConsole("saveBook");
	this.createAllfiles();
	var b=new Book();
	b.identifier=this.identifier;
	b.bookfolder=this.bookdir.fullPath;
	b.title=this.title;
	b.autor=this.author;
	b.cover="file://"+this.bookdir.fullPath+"/"+this.cover;
	b.lastdate=0;
	b.isCollection=false;
	b.size=this.totalSize;
	b.format="mobi";
	
	
	this.pointsSpine.sort(function(a, b){
		if(a.playOrder < b.playOrder)
			return -1;
		else if(a.playOrder>b.playOrder)
			return 1;
		return 0;
	});

	b.spine=this.pointsSpine;
	b.toc=this.pointsSpine;
	//b.saveBook();
	
	this.logConsole(JSON.stringify(this.book));
	//this.logConsole(JSON.stringify(b));
	this.doSaveBook(JSON.stringify(b));
	this.onComplete();
	/*
	saveManager.setProperty(identifier+"_info", dirroot+"|"+autor+"|"+titulo+"|"+cover+"|"+epub+"|"+stamp.toString());
	saveManager.setProperty(identifier, "0|0|0|true");
	*/
};
Mobi.prototype.createAllfiles=function(){
	//this.bookdir
	for(var i=0; i<this.book.files.length; i++){
		this.onProgress("Saving files", 92+(i*100/this.book.files.length), 100);
		var file=this.book.files[i];
		var folders=file.id.split('/');
		folders.pop();
		if(folders.length>0)
			this.createDir(this.bookdir, file, folders);
		else
			this.createFile(file);
	}
};
Mobi.prototype.createDir=function(rootFolder, file, folders) {
	var dirEntry=rootFolder.getDirectory(folders[0], {create: true});
	folders=folders.slice(1);
    if (folders.length>0) {
    	this.createDir(dirEntry, file, folders);
    }else{
    	this.createFile(file);
    }
};
Mobi.prototype.createFile=function(entry){
	var fileEntry=this.bookdir.getFile(entry.id, {create:true});
	fileWriter=fileEntry.createWriter();
      // Create a new Blob and write it to log.txt.
      //var bb = new BlobBuilder();
    var aFileParts = [entry.html];
    var bb = new Blob(aFileParts, {type : entry.contentType});
    fileWriter.write(bb);
};

Mobi.prototype.getCodePageById=function(param1){
	switch(param1){
		case 1252:return "windows-1252";
		case 65001:return "utf-8";
		case 28591:return "ISO-8859-1";
		case 28605:return "ISO-8859-15";
		case 850:return "IBM850";
		case 10000:return "MacRoman";
		case 20127:return "US-ASCII";
		case 28604:return "ISO-8859-14";
		case 28597:return "ISO-8859-7";
		case 10006:return "MacGreek";
		case 1253:return "windows-1253";
		case 10079:return "MacIcelandic";
		case 28600:return "ISO-8859-10";
		case 28593:return "ISO-8859-3";
		case 28594:return "ISO-8859-4";
		case 28603:return "ISO-8859-13";
		case 1257:return "windows-1257";
		case 852:return "IBM852";
		case 28592:return "ISO-8859-2";
		case 10029:return "MacCE";
		case 1250:return "windows-1250";
		case 10082:return "MacCroatian";
		case 855:return "IBM855";
		case 28595:return "ISO-8859-5";
		case 20866:return "KOI8-R";
		case 10007:return "MacCyrillic";
		case 1251:return "windows-1251";
		case 866:return "IBM866";
		case 21866:return "KOI8-U";
		case 10017:return "MacUkrainian";
		case 28606:return "ISO-8859-16";
		case 10010:return "MacRomanian";
		case 936:return "GB2312";
		case 54936:return "GB18030";
		case 950:return "Big5";
		case 51932:return "EUC-JP";
		case 50222:return "ISO-2022-JP";
		case 932:return "Shift_JIS";
		case 51949:return "EUC-KR";
		case 50225:return "ISO-2022-KR";
		case 1361:return "JOHAB";
		case 874:return "IBM874";
		case 28601:return "ISO-8859-11";
		case 857:return "IBM857";
		case 28599:return "ISO-8859-9";
		case 10081:return "MacTurkish";
		case 1254:return "windows-1254";
		case 1258:return "windows-1258";
		case 57002:return "ISCII Devanagari";
		case 57010:return "ISCII Gujarati";
		case 28596:return "ISO-8859-6";
		case 864:return "IBM864";
		case 1256:return "windows-1256";
		case 10004:return "MacArabic";
		case 862:return "IBM862";
		case 28598:return "ISO-8859-8";
		case 38598:return "ISO-8859-8-I";
		case 10005:return "MacHebrew";
		case 1255:return "windows-1255";
	}
	return "utf-8";
};


Mobi.prototype.readHUFFCDICRecord=function(){
	var maxprogresss=15;
	
	var off1 = 0;
	var off2 = 0;
	var _loc_5 = BigInteger.ZERO;
	var codelen = BigInteger.ZERO;
	var term = BigInteger.ZERO;
	var maxcode = BigInteger.ZERO;
	var phrases = 0;
	var bits = 0;
	var n = 0;
	var blen = 0;
	var _loc_19 = 0;
	var off = 0;
	var _loc_21 = 0;
	var _loc_2 = this.dataRecords[this._huffEncInfo.huffRecordOfs].offset;
	var uno=BigInteger.ONE;
	
	this.logConsole("start PARSE HUFF");
	
	this._bookStreamPosition = _loc_2;
	if (this._bookStream.readUTFBytes(this._bookStreamPosition, 4) !== this.HUFF_REC_TYPE){
		throw new Error("Found irregular e-Book structure - wrong record type (expected HUFF).");
	}
	
	this._bookStreamPosition = _loc_2 + 8;
	off1 = this._bookStream.getUint32(this._bookStreamPosition);
	this._bookStreamPosition=this._bookStreamPosition+4;
	off2 = this._bookStream.getUint32(this._bookStreamPosition);
	this._bookStreamPosition = _loc_2 + off1;
	var _loc_10 = 0;
	
	this.logConsole("entra en while");
	while (_loc_10 < this._huffEncInfo.dict1.length){
		//nbv new big integer from int
		_loc_5 = nbv(this._bookStream.getUint32(this._bookStreamPosition));
		this._bookStreamPosition=this._bookStreamPosition+4;
		
		codelen = _loc_5.and(nbv(0x1f));
		term = _loc_5.and(nbv(0x80));
		var codelenint=parseInt("0x"+codelen.toString(16), 16);
		maxcode =_loc_5.shiftRight(8).add(uno).shiftLeft((32-codelenint)).subtract(uno);
		this._huffEncInfo.dict1[_loc_10] = {codelen:codelen, term:term, maxcode:maxcode};
		//this.logConsole("dict1["+_loc_10+"]=> codelen:: "+codelen.toString(16)+", term: "+term.toString(16)+", maxcode: "+maxcode.toString(16));
		_loc_10++;
	}
	this.onProgress("Extracting book", 3, 100);
	this._bookStreamPosition = _loc_2 + off2;
	this._huffEncInfo.mincode.push(BigInteger.ZERO);
	this._huffEncInfo.maxcode.push(nbv(0xFFFFFFFF));
	var _loc_11 = 1;
	var _loc_12 = 1;
	_loc_10 = 0;
	this.logConsole("entra en while 2");
	while (_loc_10 < 64){
		_loc_5 = nbv(this._bookStream.getUint32(this._bookStreamPosition));
		this._bookStreamPosition=this._bookStreamPosition+4;
		
		if (_loc_10==0 || _loc_10 % 2 == 0){
			this._huffEncInfo.mincode.push(_loc_5.shiftLeft(32 - _loc_11));
			//this.logConsole("mincode["+_loc_11+"]=> "+this._huffEncInfo.mincode[this._huffEncInfo.mincode.length-1].toString(16));
			_loc_11++;
		}else{
			this._huffEncInfo.maxcode.push(_loc_5.add(uno).shiftLeft((32 - _loc_12)).subtract(uno));
			//this.logConsole("maxcode["+_loc_12+"]=> "+this._huffEncInfo.maxcode[this._huffEncInfo.maxcode.length-1].toString(16));
			_loc_12++;
		}
		_loc_10++;
	}
	//var h = new DataView();
	_loc_10 = 1;
	while (_loc_10 < this._huffEncInfo.huffRecordCount){
		_loc_19 = this.dataRecords[this._huffEncInfo.huffRecordOfs + _loc_10].offset;
		this._bookStreamPosition = _loc_19;
		if (this._bookStream.readUTFBytes(this._bookStreamPosition, 4) !== this.CDIC_REC_TYPE){
			throw new Error("Found irregular e-Book structure - wrong record type (expected CDIC).");
		}
		this._bookStreamPosition = _loc_19 + 8;
		phrases = this._bookStream.getUint32(this._bookStreamPosition);
		this._bookStreamPosition =this._bookStreamPosition+4;
		bits = this._bookStream.getUint32(this._bookStreamPosition);
		n = Math.min(1 << bits, phrases - this._huffEncInfo.dictionary.length);
		
		this._bookStreamPosition = _loc_19 + 16;
		_loc_21 = 0;
		while (_loc_21 < n){
			this._bookStreamPosition = _loc_19 + 16+2*_loc_21;
			off = this._bookStream.getUint16(this._bookStreamPosition);
			this._bookStreamPosition = _loc_19 + 16 + off;
			blen = this._bookStream.getUint16(this._bookStreamPosition);
			this._bookStreamPosition=this._bookStreamPosition+2;
			
		    //var babuf=new ArrayBuffer(1);
		    //var ba = new DataView(babuf);
		    var ba=this._bookStream.readBytes(this._bookStreamPosition, blen & 0x7FFF);
			this._huffEncInfo.dictionary.push({blen:(blen & 0x8000), sliceba:ba });
			//this.logConsole("dictionary["+_loc_21+"]=> blen: "+this._huffEncInfo.dictionary[this._huffEncInfo.dictionary.length-1].blen.toString(16)+", sliceba: "+ba.length);
			
			//diuvido el progress entre el while anterior y este, huffRecordCount y n
			//paso while1: 
			var current=(maxprogresss/this._huffEncInfo.huffRecordCount*(_loc_10-1));
			//en un ciclo
			current+=(maxprogresss/this._huffEncInfo.huffRecordCount)/n*_loc_21;
			this.onProgress("Extracting book", 4+current, 100);//el 4 que llevamos ya
			
			_loc_21++;
		}
		//h.clear();
		_loc_10++;
	}
	this.logConsole("END OF PARSE HUFF");
	//trace(ObjectUtil.toString(_huffEncInfo.dictionary));
	this.logConsole(JSON.stringify(this._huffEncInfo));
};


/****
 * Umcompressed Decoder!!!
 */
function UncompressedStreamDecoder(){
};
UncompressedStreamDecoder.prototype.decodeDataRecord=function(_bookStream, offset, size){
	var _loc_4=new DataView(_bookStream.buffer, offset, size);
	return _loc_4;
};


/****
 * PalmDecoder Decoder!!!
 */

function PalmDocDecoder(){
};


PalmDocDecoder.prototype.decodeDataRecord=function(_bookStream, offset, size, logger){
    var _loc_8 = 0;
    var _loc_9 = 0;
    var _loc_10 = 0;
    var _loc_11 = 0;
    var _loc_12 = 0;
    var _loc_13 = 0;
    var arrbuf=new ArrayBuffer(1);
    var _loc_4 = new DataView(arrbuf);

    var _loc_5;
    var _loc_6 = 0;
    
    _loc_5=new DataView(_bookStream.buffer, offset, size);
    var position=0;
    var writeposition=0;
    
   
    
    while (position<size){
        _loc_8 = _loc_5.getInt8(position);
        position++;
        
        if (_loc_8 >= 1 && _loc_8 <= 8){
            _loc_4=_loc_4.writeBytes(writeposition, _loc_5.buffer, offset+position, _loc_8);
            position+=_loc_8;
            writeposition+=_loc_8;
            continue;
        }
        if (_loc_8 >= -64 && _loc_8 <= -1){
        	//pinto un espacio
        	_loc_4=_loc_4.writeByte(writeposition, 32);
            writeposition++;
            
            _loc_4=_loc_4.writeByte(writeposition, (_loc_8 ^ 128));
            writeposition++;
            continue;
        }
        if (_loc_8 >= -128 && _loc_8 <= -65){
            _loc_11 = _loc_5.getUint8(position);
            position++;
            
            _loc_12 = ((_loc_8 & 63) << 8) + (_loc_11 & 255);
            _loc_13 = (_loc_12 & 7) + 3;
            _loc_6 = writeposition - (_loc_12 >> 3);
            
            if (writeposition >= (_loc_6 + _loc_13)){
            	_loc_4=_loc_4.writeBytes(writeposition, _loc_4.buffer, _loc_6, _loc_13);
            	writeposition=writeposition+_loc_13;
            }else{
                while ((_loc_13--) > 0){
                    _loc_4=_loc_4.writeByte(writeposition, (_loc_4.getUint8(_loc_6)));
                    writeposition++;
                    _loc_6++;
                }
            }
            continue;
        }
        _loc_4=_loc_4.writeByte(writeposition, _loc_8);
        writeposition++;
    }
    _loc_5=undefined;
    delete _loc_5;
    return _loc_4;
};


/****
 * HUFFCDICInfo!!!
 */
function HUFFCDICInfo()
{
    this.huffRecordOfs;//uint
	this.huffRecordCount;//uint
	this.huffTableOfs;//uint
	this.huffTableLen;//uint
	this.dict1=new Array(256);
	this.mincode=[];
	this.maxcode=[];
	this.dictionary=[];
};

/****
 * HuffCdicDecoder !!!
 */
function HuffCdicDecoder(data){
    this._huffInfo = data;//HUFFCDICInfo
}

HuffCdicDecoder.prototype.decodeDataRecord=function(data, position, size){
	return this.huffcdicDecode(new DataView(data.buffer, position, size));
};

HuffCdicDecoder.prototype.huffcdicDecode=function(data){
    var x=BigInteger(null);
	var code = BigInteger.ZERO;
    var codelen = BigInteger.ZERO;
    var term = BigInteger.ZERO;
    var maxcode = BigInteger.ZERO;
    var r = BigInteger.ZERO;
    
    var sliceba;
    
    var flag = 0;
    var bitsleft = data.byteLength * 8;

	var zeros = new Uint8Array(8);
	data=data.writeBytes2(data.byteLength, zeros, 0, 8);
	
    var pos = 0;
    var position = pos ;
    var n = 32;
	var uno=BigInteger.ONE;

	var ba=data.readBytes(position, 8);
	var view = new Uint8Array(ba.buffer);
	x=new BigInteger(null);
	x.fromArray(Array.apply( [], view ), 8);
	
	var babuf=new ArrayBuffer(1);
    var s = new DataView(babuf);
    var writeposition=0;
    
    while (true){
        if (n <= 0){
            pos  = pos  + 4;
            n = n + 32;
			position = pos ;
			ba=data.readBytes(position, 8);
			view = new Uint8Array(ba.buffer);
			x=new BigInteger(null);
			x.fromArray(Array.apply( [], view ), 8);
        }

		code=x.shiftRight(n).and(uno.shiftLeft(32).subtract(uno));
		var codeint=parseInt("0x"+code.shiftRight(24).toString(16), 16);
		
		codelen = this._huffInfo.dict1[codeint].codelen;
        term = this._huffInfo.dict1[codeint].term;
        maxcode = this._huffInfo.dict1[codeint].maxcode;

        if (term.compareTo(BigInteger.ZERO) <= 0){
            while (code.compareTo(this._huffInfo.mincode[parseInt("0x"+codelen.toString(16), 16)]) < 0){
                codelen = codelen.add(uno);
			}
            maxcode = this._huffInfo.maxcode[parseInt("0x"+codelen.toString(16), 16)];
        }
        n = n - parseInt("0x"+codelen.toString(16), 16);
        bitsleft = bitsleft - parseInt("0x"+codelen.toString(16), 16);
        if (bitsleft < 0){
            break;
        }
		
		var t32=nbv(32);
		t32=t32.subtract(codelen);
		var t32int=parseInt("0x"+t32.toString(16), 16);
		r=maxcode.subtract(code).shiftRight(t32int);
		var ere=parseInt("0x"+r.toString(16), 16);
		
		sliceba = this._huffInfo.dictionary[ere].sliceba;
		flag = this._huffInfo.dictionary[ere].blen;
        if (flag <= 0){
			sliceba = this.huffcdicDecode(sliceba);
            this._huffInfo.dictionary[ere] = {blen:1, sliceba:sliceba};
        }
        s=s.writeBytes2(writeposition, sliceba.buffer, 0, sliceba.byteLength);
        writeposition=writeposition+sliceba.byteLength;
    }
    return s;
};