importScripts('../utils.js');
importScripts('Mobi.js');
importScripts('../NewBook.js');
importScripts('../Book.js');
importScripts('../lib/encoding-indexes.js');
importScripts('../lib/encoding.js');
importScripts('../lib/jsbn.js');
importScripts('../lib/jsbn2.js');

self.addEventListener('message', function(e) {
	  var msg=e.data;
	  if(msg.action=="extract"){
		  self.requestFileSystemSync = self.webkitRequestFileSystemSync || self.requestFileSystemSync;
		
		  var ep=new Mobi(msg.file);
		  ep.onComplete=onComplete;
		  ep.onError =onError;
		  ep.onProgress=onProgress;
		  ep.onExistingBook=onExistingBook;
		  ep.doSaveBook=doSaveBook;
		  ep.setIdentifier=setIdentifier;
		  ep.logConsole=function(m) {
			  try{
				var o=JSON.parse(m);
				self.postMessage(o);
			  }catch(e){
				self.postMessage(m);
			  }
		  }.bind(this);
		  try{
			  ep.extract(self, msg.home);
		  }catch(e){
			  self.postMessage("exception ctched "+e.message);
			  onError(e);
		  }
	  }
}, false);
function setIdentifier(id){
	self.postMessage({action: "onSetIdentifier", object: id});
}
function doSaveBook(json){
	self.postMessage({action: "doSaveBook", object: json});
}
function onExistingBook(json){
	self.postMessage({action: "onExistingBook"});
}
function onComplete(){
	self.postMessage({action: "onComplete"});
}
function onError(error){
	self.postMessage({action: "onError"});
}
function onProgress(status, current, total){
	self.postMessage({action: "onProgress", status: status, current: current, total:total});
}
