window.frameworkModules = ['lib/config.js', 'lib/controllerWebView.js', 'lib/event.js', 'lib/exception.js', 'lib/framework.js', 'lib/jnext.js', 'lib/overlayWebView.js', 'lib/PluginResult.js', 'lib/server.js', 'lib/utils.js', 'lib/webkitEvent.js', 'lib/webview.js', 'lib/config/default.js', 'lib/config/user.js', 'lib/events/applicationEvents.js', 'lib/events/deviceEvents.js', 'lib/plugins/default.js', 'lib/plugins/event.js', 'lib/policy/folderAccess.js', 'lib/policy/webkitOriginAccess.js', 'lib/policy/whitelist.js', 'lib/webkitHandlers/networkResourceRequested.js', 'plugin/com.blackberry.display/index.js', 'plugin/cordova-plugin-bb-app/index.js', 'plugin/cordova-plugin-bb-card/index.js', 'plugin/cordova-plugin-bb-connection/index.js', 'plugin/cordova-plugin-bb-cover/index.js', 'plugin/cordova-plugin-bb-ctxmenu/index.js', 'plugin/cordova-plugin-bb-dialog/index.js', 'plugin/cordova-plugin-bb-identity/index.js', 'plugin/cordova-plugin-bb-invoke/index.js', 'plugin/cordova-plugin-bb-invoke/invocationEvents.js', 'plugin/cordova-plugin-bb-invoked/index.js', 'plugin/cordova-plugin-bb-invoked/invocationEvents.js', 'plugin/cordova-plugin-bb-io/index.js', 'plugin/cordova-plugin-bb-notification/index.js', 'plugin/cordova-plugin-bb-payment/index.js', 'plugin/cordova-plugin-bb-push/index.js', 'plugin/cordova-plugin-bb-system/index.js', 'plugin/cordova-plugin-bbm/BBMEvents.js', 'plugin/cordova-plugin-bbm/BBMJNEXT.js', 'plugin/cordova-plugin-bbm/index.js', 'plugin/cordova-plugin-clipboard/index.js', 'plugin/cordova-plugin-mediakeys/index.js', 'plugin/cordova-plugin-screenshot/index.js', 'plugin/cordova-plugin-toast/index.js', 'plugin/cordova-plugin-touch-keyboard/index.js', 'plugin/File/index.js'];
(function () { define('lib/config.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var defaults = require('./config/default'),
    user = require('./config/user'),
    utils = require('./utils');

module.exports = utils.mixin(user,
                 utils.mixin(defaults, {}));

});
define('lib/controllerWebView.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var controllerWebView,
    overlayWebView = require("./overlayWebView"),
    controller,
    invocation,
    utils;

controllerWebView = {
    init: function (config) {
        controller = window.qnx.webplatform.getController();
        invocation = window.qnx.webplatform.getApplication().invocation;
        utils = require('./utils');
        controller.enableWebInspector = config.debugEnabled;
        controller.enableCrossSiteXHR = true;
        controller.visible = false;
        controller.active = false;
        controller.setGeometry(0, 0, screen.width, screen.height);
        controller.setFileSystemSandbox = false;

        /* Remote functions that are published to allow communication with
         * the overlay webview, they are called via the RPC bridge
         */
        controller.publishRemoteFunction('webview.setSensitivity', function (args) {
            var sensitivityType = args[0];
            overlayWebView.setSensitivity(sensitivityType);
        });

        controller.publishRemoteFunction('webview.notifyContextMenuCancelled', function () {
            overlayWebView.notifyContextMenuCancelled();
        });
    },

    setGeometry: function (x, y, width, height) {
        controller.setGeometry(x, y, width, height);
    },

    setApplicationOrientation: function (angle) {
        controller.setApplicationOrientation(angle);
    },

    notifyApplicationOrientationDone: function () {
        controller.notifyApplicationOrientationDone();
    },

    dispatchEvent: function (eventType, args) {
        controller.dispatchEvent(eventType, args);
    }
};

controllerWebView.__defineGetter__('id', function () {
    return controller.id;
});

controllerWebView.__defineSetter__('onChildWebViewCreated', function (input) {
    controller.onChildWebViewCreated = input;
});
module.exports = controllerWebView;

});
define('lib/event.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var _handlers = {},
    _webview = require("./webview");

module.exports = {
    trigger: function (actionEvent) {
        var args = Array.prototype.slice.call(arguments),
            executeString = "webworks.event.trigger('" + actionEvent + "', '" + escape(encodeURIComponent(JSON.stringify(args.slice(1)))) + "')";

        if (_handlers.hasOwnProperty(actionEvent)) {
            _handlers[actionEvent].forEach(function (webview) {
                webview.executeJavaScript(executeString);
            });
        } else {
            //Just dump it in the content webview for consistency
            _webview.executeJavascript(executeString);
        }
    },

    add: function (action, webview) {
        var triggerEvent;

        if (action) {
            //Use action.event for old extensions that may not have triggerEvent defined
            triggerEvent = action.triggerEvent || action.event;

            if (!action.once) {
                action.context.addEventListener(action.event, action.trigger || this.trigger);
            }

            //If there are no registered listeners for this event, create an array to hold them
            if (!_handlers.hasOwnProperty(triggerEvent)) {
                _handlers[triggerEvent] = [];
            }
            //If the webview is not in the list of webviews listening to this action then add it
            if (!_handlers[triggerEvent].some(function (handlerWebView) {
                    return handlerWebView.id === webview.id;
                })) {
                _handlers[triggerEvent].push(webview);
            }

        } else {
            throw "Action is null or undefined";
        }
    },

    remove: function (action, webview) {
        if (action) {
            action.context.removeEventListener(action.event, action.trigger || this.trigger);

            //Remove the webview from the _handlers
            if (_handlers.hasOwnProperty(action.event)) {

                _handlers[action.event] = _handlers[action.event].filter(function (sourceWebview) {
                    return sourceWebview.id !== webview.id;
                });

                //If the array is empty delete it
                if (_handlers[action.event].length === 0) {
                    delete _handlers[action.event];
                }
            }

        } else {
            throw "Action is null or undefined";
        }

    }
};

});
define('lib/exception.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

module.exports = {

    types: {
        Application: "Application",
        ArgumentLength: "ArgumentLength",
        ArgumentType: "ArgumentType",
        Argument: "Argument",
        NotificationType: "NotificationType",
        NotificationStateType: "NotificationStateType",
        DomObjectNotFound: "DomObjectNotFound",
        MethodNotImplemented: "MethodNotImplemented",
        InvalidState: "InvalidState",
        ApplicationState: "ApplicationState"
    },

    handle: function handle(exception, reThrow) {
        reThrow = reThrow || false;

        var eMsg = exception.message || "exception caught!",
        msg = eMsg + "\n\n" + (exception.stack || "*no stack provided*") + "\n\n";

        console.error(msg);

        if (reThrow) {
            throw exception;
        }
    },

    raise: function raise(exceptionType, message, customExceptionObject) {
        var obj = customExceptionObject || {
                type: "",
                message: "",

                toString: function () {
                    var result = this.name + ': "' + this.message + '"';

                    if (this.stack) {
                        result += "\n" + this.stack;
                    }
                    return result;
                }
            };

        message = message || "";

        obj.name = exceptionType;
        obj.type = exceptionType;
        // TODO: include the exception objects original message if exists
        obj.message = message;

        throw obj;
    }
};

});
define('lib/framework.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var utils = require('./utils'),
    controllerWebView = require('./controllerWebView'),
    webview = require('./webview'),
    overlayWebView = require('./overlayWebView'),
    config = require("./config"),
    appEvents = require("./events/applicationEvents"),
    actionMap = {
        pause: {
            event: "inactive",
            trigger: function () {
                webview.executeJavascript("if (typeof cordova !== 'undefined') cordova.fireDocumentEvent('pause')");
            }
        },
        resume: {
            event: "active",
            trigger: function () {
                webview.executeJavascript("if (typeof cordova !== 'undefined') cordova.fireDocumentEvent('resume')");
            }
        }
    };

function addEvents() {
    for (var action in actionMap) {
        if (actionMap.hasOwnProperty(action)) {
            appEvents.addEventListener(actionMap[action].event, actionMap[action].trigger);
        }
    }
}

function removeEvents() {
    for (var action in actionMap) {
        if (actionMap.hasOwnProperty(action)) {
            appEvents.removeEventListener(actionMap[action].event, actionMap[action].trigger);
        }
    }
}

function showWebInspectorInfo() {
    var port = window.qnx.webplatform.getApplication().webInspectorPort,
        message = "WebInspector Address\n";

    qnx.webplatform.device.getNetworkInterfaces(function (networkInfo) {
        var connectedInterface;

        utils.forEach(networkInfo, function (info) {
            if (info && !connectedInterface) {
                connectedInterface = info;
            }
        }, this);

        if (connectedInterface) {
            message +=  connectedInterface.ipv4Address + ":" + port;
        } else {
            message += "Connect to the simulator's IP on port: " + port;
        }

        overlayWebView.showToast(message, {buttonText: "dismiss", timeout: 30000}); // 30 seconds with a dismiss button
    });
}

var _self = {
    start: function (url) {
        var callback,
            showUrlCallback;

        // log Cordova framework version (which should match JS version)
        console.log('Apache Cordova native platform version ' + config.cordovaVersion + ' is starting.');

        // Set up the controller WebView
        controllerWebView.init(config);

        webview.create(function () {
            if (config.enableFlash) {
                //Set webview plugin directory [required for flash]
                webview.setExtraPluginDirectory('/usr/lib/browser/plugins');

                //Enable plugins for the webview [required for flash]
                webview.setEnablePlugins(true);

                //Enable flash for the childWebViews
                controllerWebView.onChildWebViewCreated = function (child) {
                    //Set webview plugin directory [required for flash]
                    child.setExtraPluginDirectory('/usr/lib/browser/plugins');

                    //Enable plugins for the webview [required for flash]
                    child.pluginsEnabled = true;
                };
            }

            if (!config.enableWebSecurity) {
                webview.enableCrossSiteXHR = true;
            }

            if (!config.enablePopupBlocker) {
                qnx.webplatform.nativeCall('webview.setBlockPopups', webview.id, false);
            }

            if (config.enableDiskCache) {
                qnx.webplatform.nativeCall('webview.setEnableDiskCache', webview.id, 'true');
            }

            if (config.useSpatialNavigation) {
                var _webview = webview.getWebViewObj();
                if ("spatialNavigation" in _webview) {
                    _webview.spatialNavigation = true;
                    _webview.pointerInteractionMode = false;
                }
            }

            // Workaround for executeJavascript doing nothing for the first time
            webview.executeJavascript("1 + 1");

            url = url || config.content;

            showUrlCallback = function () {
                overlayWebView.removeEventListener("DocumentLoadFinished", showUrlCallback);
                showUrlCallback = null;

                // Start page
                if (url) {
                    webview.setURL(url);
                }
            };

            overlayWebView.create(function () {
                overlayWebView.addEventListener("DocumentLoadFinished", showUrlCallback);

                overlayWebView.setURL("local:///chrome/ui.html");
                overlayWebView.renderContextMenuFor(webview);
                overlayWebView.handleDialogFor(webview);
                controllerWebView.dispatchEvent('ui.init', null);
                webview.setUIWebViewObj(overlayWebView.getWebViewObj());
                if (config.enableChildWebView) {
                    overlayWebView.bindAppWebViewToChildWebViewControls(webview);
                } else {
                    webview.onChildWindowOpen = function (data) {
                        var parsedData = JSON.parse(data);
                        utils.invokeInBrowser(parsedData.url);
                    };
                }
                if (config.enableFormControl) {
                    overlayWebView.getWebViewObj().formcontrol.subscribeTo(webview);
                }
            });
        },
        {
            debugEnabled : config.debugEnabled
        });

        addEvents();

        //if debugging is enabled, show the IP and port for webinspector
        if (config.debugEnabled) {
            callback = function () {
                showWebInspectorInfo();

                //Remove listener. Alert should only be shown once.
                webview.removeEventListener("DocumentLoadFinished", callback);
            };

            webview.addEventListener("DocumentLoadFinished", callback);
        }
    },
    stop: function () {
        removeEvents();
        webview.destroy();
    }
};

module.exports = _self;

});
define('lib/jnext.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*global objJSExt */

function JNEXT_() {
    var self = this;
    var m_bFirstRequire = true;

    self.m_arEvents = {};

    self.onPageLoad = function() {
    };

    self.attachToDOM = function() {
        // Make sure JNEXT onPageLoad is called when page load
        //  completes without damaging existing onLoad handlers
        var prevOnLoad = window.onload;
        if( typeof window.onload != 'function') {
            window.onload = self.onPageLoad;
        } else {
            window.onload = function() {
                if(prevOnLoad) {
                    prevOnLoad();
                }

                self.onPageLoad();
            };
        }

        // Unobtrusively add the JNEXT plugin or ActiveX to the DOM
        var objBody = document.getElementsByTagName("body")[0];
        var objDiv = document.createElement('div');
        var strHTML;

        if(window.ActiveXObject) {
            strHTML = '<object id="objJSExt" width="0" height="0" classid="CLSID:C802F39D-BF85-427a-A334-77E501DB62E9" codebase="jnext.ocx"></object>';
            strHTML += '<script language="JavaScript" for="objJSExt" EVENT="Js2nEvent( strEvent )">JNEXT.processEvent(strEvent)</script>';
        } else {
            var strAddSrc = "";
            if(navigator.userAgent.indexOf("Safari") != -1 && navigator.userAgent.indexOf("Windows") != -1) {
                // This hack required on Safari for Windows
                strAddSrc = 'src="./jnext/safari.foo"';
            }
            strHTML = '<embed id="objJSExt" ' + strAddSrc + ' type="application/jnext-scriptable-plugin" width="0" height="0">';
        }

        objDiv.innerHTML = strHTML;
        objBody.appendChild(objDiv);
    };

    self.getosname = function() {
        return objJSExt.sendCmd("osname");
    };

    self.require = function(strLibrary) {
        // Load a required JNEXT plugin
        var strCmd;
        var strVal;
        var arParams;

        if(m_bFirstRequire) {
            strCmd = "userAgent " + navigator.userAgent;
            strVal = objJSExt.sendCmd(strCmd);
            arParams = strVal.split(" ");
            if(arParams[0] != "Ok") {
                alert("userAgent " + strVal);
                return false;
            }
            self.m_bFirstRequire = false;
        }
        strCmd = "Require " + strLibrary;
        strVal = objJSExt.sendCmd(strCmd);
        arParams = strVal.split(" ");
        if(arParams[0] != "Ok") {
            alert("Require " + strVal);
            return false;
        }

        return true;
    };

    self.createObject = function(strObjName) {
        // Create an instance of a native object
        var strCmd;
        var strVal;
        var arParams;
        strVal = objJSExt.sendCmd("CreateObject " + strObjName);
        arParams = strVal.split(" ");
        if(arParams[0] != "Ok") {
            alert("CreateObject: " + strVal);
            return "";
        }
        return arParams[1];
    };

    self.invoke = function(strObjId, strMethod, strParams) {
        // Invoke a method of a given instance of a native object
        var strCmd = "InvokeMethod " + strObjId + " " + strMethod;

        if( typeof (strParams) != "undefined") {
            strCmd += " " + strParams;
        }

        return objJSExt.sendCmd(strCmd);
    };

    self.registerEvents = function(objNotify) {
        var strId = objNotify.getId();
        self.m_arEvents[strId] = objNotify;
    };

    self.unregisterEvents = function(objNotify) {
        var strId = objNotify.getId();
        delete self.m_arEvents[strId];
    };

    self.processEvent = function(strNativeEvt) {
        // Process an event received from native code. The event
        // contains the target JavaScript object id and the
        // relevant parameters.

        var arParams = strNativeEvt.split(" ");
        var strObjId = arParams[0];
        var strEvent = strNativeEvt.substring(strObjId.length + 1);

        var objNotify = self.m_arEvents[strObjId];
        if( typeof (objNotify) == 'undefined') {
            alert("Warning: No object with Id " + strId + " found for event " + strEvent);
            return;
        }

        // This will now be handled by the appropriate JavaScript
        // JNEXT extension object
        objNotify.onEvent(strEvent);
    };

    self.ajaxGet = function(strUrl, id) {
        var req = false;
        if(window.ActiveXObject) {
            try {
                req = new ActiveXObject("Msxml2.XMLHTTP");
            } catch (e) {
                try {
                    req = new ActiveXObject("Microsoft.XMLHTTP");
                } catch (ex) {
                }
            }
        } else if(window.XMLHttpRequest) {
            req = new XMLHttpRequest();
        } else {
            return false;
        }

        req.onreadystatechange = function() {
            if(req.readyState == 4 && (req.status == 200 || window.location.href.indexOf("http") == -1)) {
                self.onAjaxRecv(req.responseText);
            }
        };

        req.open('GET', strUrl, true);
        req.send(null);
    };

    self.onAjaxRecv = function(strContent) {
        alert(strContent);
    };

    self.attachToDOM();
}

window.JNEXT = new JNEXT_();
module.exports = JNEXT;

});
define('lib/overlayWebView.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var CHROME_HEIGHT = 0,
    webview,
    _webviewObj;

webview =
    {

    create: function (ready, configSettings) {
        _webviewObj = window.qnx.webplatform.createUIWebView(function () {

            _webviewObj.visible = true;
            _webviewObj.active = true;
            _webviewObj.zOrder = 2;
            _webviewObj.enableCrossSiteXHR = true;
            _webviewObj.setGeometry(0, 0, screen.width, screen.height);
            _webviewObj.addEventListener("DocumentLoadFinished", function () {
                _webviewObj.default.setDefaultFont();
                _webviewObj.visible = true;
            });

            _webviewObj.allowRpc = true;
            _webviewObj.backgroundColor = 0x00FFFFFF;
            _webviewObj.sensitivity = "SensitivityTest";
            _webviewObj.devicePixelRatio = 1;
            _webviewObj.allowQnxObject = true;

            if (ready && typeof ready === 'function') {
                ready();
            }

            window.qnx.webplatform.getController().dispatchEvent("overlayWebView.initialized", [_webviewObj]);

        });
    },

    destroy: function () {
        _webviewObj.destroy();
    },

    setURL: function (url) {
        _webviewObj.url = url;
    },

    setGeometry: function (x, y, width, height) {
        _webviewObj.setGeometry(x, y, width, height);
    },

    setSensitivity : function (sensitivity) {
        _webviewObj.sensitivity = sensitivity;
    },

    setApplicationOrientation: function (angle) {
        _webviewObj.setApplicationOrientation(angle);
    },

    notifyApplicationOrientationDone: function () {
        _webviewObj.notifyApplicationOrientationDone();
    },

    executeJavascript: function (js) {
        _webviewObj.executeJavaScript(js);
    },

    windowGroup: function () {
        return _webviewObj.windowGroup;
    },

    notifyContextMenuCancelled: function () {
        _webviewObj.notifyContextMenuCancelled();
    },

    bindAppWebViewToChildWebViewControls: function (appWebView) {
        if (_webviewObj && _webviewObj.childwebviewcontrols) {
            _webviewObj.childwebviewcontrols.subscribeTo(appWebView);
        }
    },

    renderContextMenuFor: function (targetWebView) {
        return _webviewObj.contextMenu.subscribeTo(targetWebView);
    },

    handleDialogFor: function (targetWebView) {
        return _webviewObj.dialog.subscribeTo(targetWebView);
    },

    showDialog: function (description, callback) {
        return _webviewObj.dialog.show(description, callback);
    },

    getWebViewObj: function (webview) {
        return _webviewObj;
    },

    addEventListener: function (eventName, callback) {
        _webviewObj.addEventListener(eventName, callback);
    },

    removeEventListener: function (eventName, callback) {
        _webviewObj.removeEventListener(eventName, callback);
    },

    showToast : function (message, options) {
        return _webviewObj.toast.show(message, options);
    },

    showInvocationList: function (request, title, success, error) {
        _webviewObj.invocationlist.show(request, title, success, error);
    }
};

webview.__defineGetter__('id', function () {
    if (_webviewObj) {
        return _webviewObj.id;
    }
});

webview.__defineGetter__('zOrder', function () {
    return _webviewObj.zOrder;
});

webview.__defineGetter__('contextMenu', function () {
    if (_webviewObj) {
        return _webviewObj.contextMenu;
    }
});

module.exports = webview;

});
define('lib/PluginResult.js', function (require, exports, module) {
/*
 * Copyright 2013 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

function PluginResult(args, env) {

    var CALLBACK_STATUS_NO_RESULT = 0,
        CALLBACK_STATUS_OK = 1,
        CALLBACK_STATUS_ERROR = 9,
        callbackId = JSON.parse(decodeURIComponent(args.callbackId)),
        send = function (data) {
            env.response.send(200, encodeURIComponent(JSON.stringify(data)));
        },
        callback = function (success, status, data, keepCallback) {
            var executeString = "cordova.callbackFromNative('" + callbackId  + "', " +
                !!success + ", " + status + ", [" + data + "], " + !!keepCallback + ");";
            env.webview.executeJavaScript(executeString);
        };

    Object.defineProperty(this, "callbackId", {enumerable: true, value: callbackId});

    this.noResult = function (keepCallback) {
        send({ code: CALLBACK_STATUS_NO_RESULT, keepCallback: !!keepCallback });
    };

    this.error = function (msg, keepCallback) {
        send({ code: CALLBACK_STATUS_ERROR, msg: msg, keepCallback: !!keepCallback });
    };

    this.ok = function (data, keepCallback) {
        send({ code: CALLBACK_STATUS_OK, data: data, keepCallback: !!keepCallback });
    };

    this.callbackOk = function (data, keepCallback) {
        callback(true, CALLBACK_STATUS_OK, JSON.stringify(data), keepCallback);
    };

    this.callbackError = function (msg, keepCallback) {
        callback(false, CALLBACK_STATUS_ERROR, JSON.stringify(msg), keepCallback);
    };
}

window.PluginResult = PluginResult;

});
define('lib/server.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var DEFAULT_SERVICE = "default",
    DEFAULT_ACTION = "exec";

function rebuildRequest(req) {
    var originalURL = req.params.service + "/" +
            req.params.action +
            (req.params.ext ? "/" + req.params.ext  : "") +
            (req.params.method ? "/" + req.params.method : "") +
            (req.params.args ? "?" + req.params.args : ""),
        tokens = originalURL.split('/'),
        //Handle the case where the method is multi-level
        finalToken = (tokens[1] && tokens.length > 2) ? tokens.slice(1).join('/') : tokens[1],
        args = null;

    // set args
    if (finalToken && finalToken.indexOf("?") >= 0) {
        // Re-split args
        args = finalToken.split("?")[1];
    }

    return {
        params : {
            service : DEFAULT_SERVICE,
            action : DEFAULT_ACTION,
            ext : tokens[0],
            method : (finalToken && finalToken.indexOf("?") >= 0) ? finalToken.split("?")[0] : finalToken,
            args : args
        },
        body : req.body,
        origin : req.origin
    };
}

function parseArgs(req) {
    var args = null,
        params;
    // set args
    if (req.params.args && typeof req.params.args === "string") {
        // GET querystring to json
        params = req.params.args.split("&");
        if (params) {
            args = {};
            params.forEach(function (param) {
                var parts = param.split("=");
                args[parts[0]] = parts[1];
            });
        }
    } else {
        // POST body to json
        if (req.body) {
            args = JSON.parse(req.body);
        }
    }
    req.params.args = args;
}

module.exports = {
    handle: function (req, res, sourceWebview, config) {
        try {
            var pluginName = "lib/plugins/" + req.params.service,
                plugin;

            if (frameworkModules.indexOf(pluginName + ".js") === -1) {
                pluginName = "lib/plugins/" + DEFAULT_SERVICE;
                req = rebuildRequest(req);
            }

            parseArgs(req);

            //Updating because some versions of node only work with relative paths
            pluginName = pluginName.replace('lib', '.');

            plugin = require("./utils").loadModule(pluginName);

            plugin[req.params.action](req,
            function (result) {
                res.send(200, encodeURIComponent(JSON.stringify({
                    code: 1,
                    data: result,
                    keepCallback: false
                })));
            },
            function (error) {
                res.send(200, encodeURIComponent(JSON.stringify({
                    code: 9,
                    data: error,
                    keepCallback: false
                })));
            },
            req.params.args,
            {
                "request": req,
                "response": res,
                "webview": sourceWebview,
                "config": config
            });
        } catch (e) {
            console.error(e);
            res.send(404, "can't find the stuff");
        }
    }
};

});
define('lib/utils.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var self,
    exception = require('./exception');

function S4() {
    return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
}

self = module.exports = {
    validateNumberOfArguments: function (lowerBound, upperBound, numberOfArguments, customExceptionType, customExceptionMessage, customExceptionObject) {

        customExceptionMessage = customExceptionMessage || "";

        if (arguments.length < 3 || arguments.length > 6) {
            exception.raise(exception.types.Argument, "Wrong number of arguments when calling: validateNumberOfArguments()");
        }

        if (isNaN(lowerBound) && isNaN(upperBound) && isNaN(numberOfArguments)) {
            exception.raise(exception.types.ArgumentType, "(validateNumberOfArguments) Arguments are not numbers");
        }

        lowerBound = parseInt(lowerBound, 10);
        upperBound = parseInt(upperBound, 10);
        numberOfArguments = parseInt(numberOfArguments, 10);

        if (numberOfArguments < lowerBound || numberOfArguments > upperBound) {
            exception.raise((customExceptionType || exception.types.ArgumentLength), (customExceptionMessage + "\n\nWrong number of arguments"), customExceptionObject);
        }

    },

    validateArgumentType: function (arg, argType, customExceptionType, customExceptionMessage, customExceptionObject) {
        var invalidArg = false,
            msg;

        switch (argType) {
        case "array":
            if (!(arg instanceof Array)) {
                invalidArg = true;
            }
            break;
        case "date":
            if (!(arg instanceof Date)) {
                invalidArg = true;
            }
            break;
        case "integer":
            if (typeof arg === "number") {
                if (arg !== Math.floor(arg)) {
                    invalidArg = true;
                }
            }
            else {
                invalidArg = true;
            }
            break;
        default:
            if (typeof arg !== argType) {
                invalidArg = true;
            }
            break;
        }

        if (invalidArg) {
            msg = customExceptionMessage +  ("\n\nInvalid Argument type. argument: " + arg + " ==> was expected to be of type: " + argType);
            exception.raise((customExceptionType || exception.types.ArgumentType), msg, customExceptionObject);
        }
    },

    validateMultipleArgumentTypes: function (argArray, argTypeArray, customExceptionType, customExceptionMessage, customExceptionObject) {
        for (var i = 0; i < argArray.length; i++) {
            this.validateArgumentType(argArray[i], argTypeArray[i], customExceptionType, customExceptionMessage, customExceptionObject);
        }
    },

    arrayContains: function (array, obj) {
        var i = array.length;
        while (i--) {
            if (array[i] === obj) {
                return true;
            }
        }
        return false;
    },

    some: function (obj, predicate, scope) {
        if (obj instanceof Array) {
            return obj.some(predicate, scope);
        }
        else {
            var values = self.map(obj, predicate, scope);

            return self.reduce(values, function (some, value) {
                return value ? value : some;
            }, false);
        }
    },

    count: function (obj) {
        return self.sum(obj, function (total) {
            return 1;
        });
    },

    sum: function (obj, selector, scope) {
        var values = self.map(obj, selector, scope);
        return self.reduce(values, function (total, value) {
            return total + value;
        });
    },

    max: function (obj, selector, scope) {
        var values = self.map(obj, selector, scope);
        return self.reduce(values, function (max, value) {
            return max < value ? value : max;
        }, Number.MIN_VALUE);
    },

    min: function (obj, selector, scope) {
        var values = self.map(obj, selector, scope);
        return self.reduce(values, function (min, value) {
            return min > value ? value : min;
        }, Number.MAX_VALUE);
    },

    forEach: function (obj, action, scope) {
        if (obj instanceof Array) {
            return obj.forEach(action, scope);
        }
        else {
            self.map(obj, action, scope);
        }
    },

    filter: function (obj, predicate, scope) {
        if (obj instanceof Array) {
            return obj.filter(predicate, scope);
        }
        else {
            var result = [];
            self.forEach(obj, function (value, index) {
                if (predicate.apply(scope, [value, index])) {
                    result.push(value);
                }

            }, scope);

            return result;
        }
    },

    reduce: function (obj, func, init, scope) {
        var i,
            initial = init === undefined ? 0 : init,
            result = initial;


        if (obj instanceof Array) {
            return obj.reduce(func, initial);
        }
        else if (obj instanceof NamedNodeMap) {
            for (i = 0; i < obj.length; i++) {
                result = func.apply(scope, [result, obj[i], i]);
            }
        }
        else {
            for (i in obj) {
                if (obj.hasOwnProperty(i)) {
                    result = func.apply(scope, [result, obj[i], i]);
                }
            }
        }

        return result;

    },

    map: function (obj, func, scope) {
        var i,
            returnVal = null,
            result = [];

        if (obj instanceof Array) {
            return obj.map(func, scope);
        }
        else if (obj instanceof NamedNodeMap) {
            for (i = 0; i < obj.length; i++) {
                returnVal = func.apply(scope, [obj[i], i]);
                result.push(returnVal);
            }
        }
        else {
            for (i in obj) {
                if (obj.hasOwnProperty(i)) {
                    returnVal = func.apply(scope, [obj[i], i]);
                    result.push(returnVal);
                }
            }
        }

        return result;
    },

    series: function (tasks, callback) {

        var execute = function () {
            var args = [],
                task;

            if (tasks.length) {
                task = tasks.shift();
                args = args.concat(task.args).concat(execute);
                task.func.apply(this, args);
            }
            else {
                callback.func.apply(this, callback.args);
            }
        };

        execute();
    },

    regexSanitize: function (regexString) {
        return regexString.replace("^", "\\^")
                    .replace("$", "\\$")
                    .replace("(", "\\(")
                    .replace(")", "\\)")
                    .replace("<", "\\<")
                    .replace("[", "\\[")
                    .replace("{", "\\{")
                    .replace(/\\/, "\\\\")
                    .replace("|", "\\|")
                    .replace(">", "\\>")
                    .replace(".", "\\.")
                    .replace("*", "\\*")
                    .replace("+", "\\+")
                    .replace("?", "\\?");
    },

    find: function (comparison, collection, startInx, endInx, callback) {
        var results = [],
            compare = function (s, pattern) {

                if (typeof(s) !== "string" || pattern === null) {
                    return s === pattern;
                }

                var regex = pattern.replace(/\./g, "\\.")
                                   .replace(/\^/g, "\\^")
                                   .replace(/\*/g, ".*")
                                   .replace(/\\\.\*/g, "\\*");

                regex = "^".concat(regex, "$");

                return !!s.match(new RegExp(regex, "i"));
            };

        self.forEach(collection, function (c) {
            var match,
                fail = false;

            self.forEach(comparison, function (value, key) {
                if (!fail && value !== undefined) {

                    if (compare(c[key], value)) {
                        match = c;
                    }
                    else {
                        fail = true;
                        match = null;
                    }
                }
            });

            if (match) {
                results.push(match);
            }
        });

        if (callback) {
            if (startInx === undefined) {
                startInx = 0;
            }
            if (endInx === undefined) {
                endInx = results.length;
            }
            if (startInx === endInx) {
                endInx = startInx + 1;
            }

            callback.apply(null, [results.slice(startInx, endInx)]);
        }
    },

    mixin: function (mixin, to) {
        Object.getOwnPropertyNames(mixin).forEach(function (prop) {
            if (Object.hasOwnProperty.call(mixin, prop)) {
                Object.defineProperty(to, prop, Object.getOwnPropertyDescriptor(mixin, prop));
            }
        });
        return to;
    },

    copy: function (obj) {
        var i,
            newObj = (obj === null ? false : global.toString.call(obj) === "[object Array]") ? [] : {};

        if (typeof obj === 'number' ||
            typeof obj === 'string' ||
            typeof obj === 'boolean' ||
            obj === null ||
            obj === undefined) {
            return obj;
        }

        if (obj instanceof Date) {
            return new Date(obj);
        }

        if (obj instanceof RegExp) {
            return new RegExp(obj);
        }

        for (i in obj) {
            if (obj.hasOwnProperty(i)) {
                if (obj[i] && typeof obj[i] === "object") {
                    if (obj[i] instanceof Date) {
                        newObj[i] = obj[i];
                    }
                    else {
                        newObj[i] = self.copy(obj[i]);
                    }
                }
                else {
                    newObj[i] = obj[i];
                }
            }
        }

        return newObj;
    },

    startsWith : function (str, substr) {
        return str.indexOf(substr) === 0;
    },

    endsWith : function (str, substr) {
        return str.indexOf(substr, str.length - substr.length) !== -1;
    },

    parseUri : function (str) {
        var i, uri = {},
            key = [ "source", "scheme", "authority", "userInfo", "user", "password", "host", "port", "relative", "path", "directory", "file", "query", "anchor" ],
            matcher = /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@\/]*)(?::([^@\/]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/.exec(str);

        for (i = key.length - 1; i >= 0; i--) {
            uri[key[i]] = matcher[i] || "";
        }

        return uri;
    },

    // uri - output from parseUri
    isAbsoluteURI : function (uri) {
        if (uri && uri.source) {
            return uri.relative !== uri.source;
        }

        return false;
    },

    fileNameToImageMIME : function (fileName) {

        var extensionsToMIME = {},
            ext;

        extensionsToMIME.png = 'image/png';
        extensionsToMIME.jpg = 'image/jpeg';
        extensionsToMIME.jpe = 'image/jpeg';
        extensionsToMIME.jpeg = 'image/jpeg';
        extensionsToMIME.gif = 'image/gif';
        extensionsToMIME.bmp = 'image/bmp';
        extensionsToMIME.bm = 'image/bmp';
        extensionsToMIME.svg = 'image/svg+xml';
        extensionsToMIME.tif = 'image/tiff';
        extensionsToMIME.tiff = 'image/tiff';

        ext = fileName.split('.').pop();
        return extensionsToMIME[ext];
    },

    isLocalURI : function (uri) {
        return uri && uri.scheme && "local:///".indexOf(uri.scheme.toLowerCase()) !== -1;
    },

    isFileURI : function (uri) {
        return uri && uri.scheme && "file://".indexOf(uri.scheme.toLowerCase()) !== -1;
    },

    isHttpURI : function (uri) {
        return uri && uri.scheme && "http://".indexOf(uri.scheme.toLowerCase()) !== -1;
    },

    isHttpsURI : function (uri) {
        return uri && uri.scheme && "https://".indexOf(uri.scheme.toLowerCase()) !== -1;
    },

    // Checks if the specified uri starts with 'data:'
    isDataURI : function (uri) {
        return uri && uri.scheme && "data:".indexOf(uri.scheme.toLowerCase()) !== -1;
    },

    performExec : function (featureId, property, args) {
        var result;

        window.webworks.exec(function (data, response) {
            result = data;
        }, function (data, response) {
            throw data;
        }, featureId, property, args, true);

        return result;
    },

    inNode : function () {
        return !!require.resolve;
    },

    requireWebview : function () {
        return require("./webview");
    },
    convertDataToBinary : function (data, dataEncoding) {
        var rawData,
            uint8Array,
            i;

        if (data) {
            if (dataEncoding.toLowerCase() === "base64") {
                rawData = window.atob(data);
            }
            else {
                rawData = data;
            }

            uint8Array = new Uint8Array(new ArrayBuffer(rawData.length));

            for (i = 0; i < uint8Array.length; i++) {
                uint8Array[i] = rawData.charCodeAt(i);
            }

            return uint8Array.buffer;
        }
    },
    getBlobWithArrayBufferAsData : function (data, dataEncoding) {
        var rawData,
            blobBuilderObj = new window.WebKitBlobBuilder();
        rawData = this.convertDataToBinary(data, dataEncoding);
        blobBuilderObj.append(rawData);

        return blobBuilderObj.getBlob("arraybuffer");
    },
    loadModule: function (module) {
        return require(module);
    },
    loadExtensionModule: function (plugin, path) {
        if (plugin && path) {
            return require("../plugin/" + plugin + "/" + path);
        } else {
            return null;
        }
    },
    hasPermission: function (config, permission) {
        if (config && config.permissions && config.permissions.length) {
            return config.permissions.indexOf(permission) >= 0;
        }

        return false;
    },
    guid: function () {
        return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
    },
    getURIPrefix: function () {
        return "http://localhost:8472/";
    },
    translatePath: function (path) {
        if (path.indexOf("local:///") === 0) {
            var sourceDir = window.qnx.webplatform.getApplication().getEnv("HOME"); //leading slashes need to be removed
            path = "file:///" + sourceDir.replace(/^\/*/, '') + "/../app/native/" + path.replace(/local:\/\/\//, '');
        }
        return path;
    },
    invokeInBrowser: function (url) {
        var request = {
            uri: url,
            target: "sys.browser"
        };
        window.qnx.webplatform.getApplication().invocation.invoke(request);
    },
    isPersonal: function () {
        return window.qnx.webplatform.getApplication().getEnv("PERIMETER") === "personal";
    },
    deepclone: function (obj) {
        var newObj = obj instanceof Array ? [] : {},
            key;

        if (typeof obj === 'number' ||
                typeof obj === 'string' ||
                typeof obj === 'boolean' ||
                obj === null ||
                obj === undefined) {
            return obj;
        }

        if (obj instanceof Date) {
            return new Date(obj);
        }

        if (obj instanceof RegExp) {
            return new RegExp(obj);
        }

        for (key in obj) {
            if (obj.hasOwnProperty(key)) {
                if (obj[key] && typeof obj[key] === "object") {
                    newObj[key] = self.deepclone(obj[key]);
                } else {
                    newObj[key] = obj[key];
                }
            }
        }

        return newObj;
    }
};

});
define('lib/webkitEvent.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var utils = require('./utils'),
    exception = require('./exception'),
    _listeners = {};

function _on(eventType, listener, scope, once) {
    if (!eventType) {
        throw "eventType must be truthy";
    }
    _listeners[eventType] = _listeners[eventType] || [];
    _listeners[eventType].push({
        func: listener,
        scope: scope,
        once: !!once
    });
}

function _trigger(listener, args, sync) {
    try {
        if (sync) {
            listener.func.apply(listener.scope, args);
        }
        else {
            setTimeout(function () {
                listener.func.apply(listener.scope, args);
            }, 1);
        }
    }
    catch (e) {
        exception.handle(e);
    }
}

module.exports = {
    on: function (eventType, listener, scope) {
        _on(eventType, listener, scope, false);
    },

    once: function (eventType, listener, scope) {
        _on(eventType, listener, scope, true);
    },

    trigger: function (eventType, args, sync) {
        args = args || [];
        sync = sync || false;

        var listeners = _listeners[eventType];

        if (listeners) {
            listeners.forEach(function (listener) {
                _trigger(listener, args, sync);
            });

            _listeners[eventType] = listeners.filter(function (listener) {
                return !listener.once;
            });
        }
    },

    eventHasSubscriber: function (eventType) {
        return !!_listeners[eventType];
    },

    getEventSubscribers: function (eventType) {
        return utils.copy(_listeners[eventType]) || [];
    },

    clear: function (eventType) {
        if (eventType) {
            delete _listeners[eventType];
        }
    }
};

});
define('lib/webview.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var networkResourceRequested = require('./webkitHandlers/networkResourceRequested'),
    utils = require('./utils'),
    config = require('./config'),
    webkitOriginAccess = require("./policy/webkitOriginAccess"),
    CHROME_HEIGHT = 0,
    OUT_OF_PROCESS = 1,
    webview,
    _webviewObj;

webview =
    {
    create: function (ready) {
        _webviewObj = window.qnx.webplatform.createWebView({processId: OUT_OF_PROCESS, defaultSendEventHandlers: ['onChooseFile', 'onOpenWindow'], defaultWebEventHandlers: ['InvokeRequestEvent']}, function () {
            //Create webkit event handlers
            var requestObj =  networkResourceRequested.createHandler(_webviewObj);

            //Bind networkResourceRequested event so that everything works
            _webviewObj.onNetworkResourceRequested = requestObj.networkResourceRequestedHandler;

            webkitOriginAccess.addWebView(_webviewObj);

            _webviewObj.visible = true;
            _webviewObj.active = true;
            _webviewObj.zOrder = 0;
            _webviewObj.setGeometry(0, CHROME_HEIGHT, screen.width, screen.height - CHROME_HEIGHT);

            if (typeof config.backgroundColor !== 'undefined') {
                _webviewObj.backgroundColor = config.backgroundColor;
            }

            if (typeof config.customHeaders !== 'undefined') {
                _webviewObj.extraHttpHeaders = config.customHeaders;
            }

            if (typeof config.userAgent !== 'undefined') {
                _webviewObj.userAgent = config.userAgent;
            }

            _webviewObj.autoDeferNetworkingAndJavaScript = config.autoDeferNetworkingAndJavaScript;

            /* Catch and trigger our custom HTML dialog */
            _webviewObj.allowWebEvent("DialogRequested");

            _webviewObj.addEventListener("DocumentLoadFinished", function () {
                // show app window if auto hide splash screen is true, OR splash screen is not specified
                // if auto hide is set to false explicitly but no splash screen is specified, should still show app window
                // otherwise the app cannot be launched
                if (config.autoHideSplashScreen || !config["rim:splash"]) {
                    window.qnx.webplatform.getApplication().windowVisible = true;
                }
            });


            if (ready && typeof ready === 'function') {
                ready();
            }

            window.qnx.webplatform.getController().dispatchEvent("webview.initialized", [_webviewObj]);

            // If content is not loaded, too bad open the visibility up.
            setTimeout(function () {
                if (config.autoHideSplashScreen || !config["rim:splash"]) {
                    window.qnx.webplatform.getApplication().windowVisible = true;
                }
            }, 2500);
        });

    },

    destroy: function () {
        _webviewObj.destroy();
    },

    setURL: function (url) {
        _webviewObj.url = url;
    },

    reload: function () {
        _webviewObj.reload();
    },

    executeJavascript: function (js) {
        _webviewObj.executeJavaScript(js);
    },

    addEventListener: function (eventName, callback) {
        _webviewObj.addEventListener(eventName, callback);
    },

    removeEventListener: function (eventName, callback) {
        _webviewObj.removeEventListener(eventName, callback);
    },

    windowGroup: function () {
        return _webviewObj.windowGroup;
    },

    getGeometry: function () {
        return this.geometry;
    },

    setGeometry: function (x, y, width, height) {
        this.geometry = {x: x, y: y, w: width, h: height};
        _webviewObj.setGeometry(x, y, width, height);
    },

    setApplicationOrientation: function (angle) {
        _webviewObj.setApplicationOrientation(angle);
    },

    setExtraPluginDirectory: function (directory) {
        _webviewObj.setExtraPluginDirectory(directory);
    },

    setEnablePlugins: function (enablePlugins) {
        _webviewObj.pluginsEnabled = enablePlugins;
    },

    getEnablePlugins: function () {
        return _webviewObj.pluginsEnabled;
    },

    notifyApplicationOrientationDone: function () {
        _webviewObj.notifyApplicationOrientationDone();
    },

    setSandbox: function (sandbox) {
        _webviewObj.setFileSystemSandbox = sandbox;
    },

    getSandbox: function () {
        return _webviewObj.setFileSystemSandbox;
    },

    downloadURL: function (url) {
        _webviewObj.downloadURL(url);
    },

    handleContextMenuResponse: function (action) {
        _webviewObj.handleContextMenuResponse(action);
    },

    allowGeolocation : function (url) {
        _webviewObj.allowGeolocation(url);
    },

    disallowGeolocation : function (url) {
        _webviewObj.disallowGeolocation(url);

    },

    addKnownSSLCertificate: function (url, certificateInfo) {
        _webviewObj.addKnownSSLCertificate(url, certificateInfo);
    },

    continueSSLHandshaking: function (streamId, SSLAction) {
        _webviewObj.continueSSLHandshaking(streamId, SSLAction);
    },

    getSensitivity: function () {
        return _webviewObj.getSensitivity();
    },

    setSensitivity: function (sensitivity) {
        return _webviewObj.setSensitivity(sensitivity);
    },

    getBackgroundColor: function () {
        return _webviewObj.getBackgroundColor();
    },

    setBackgroundColor: function (backgroundColor) {
        return _webviewObj.setBackgroundColor(backgroundColor);
    },

    getWebViewObj: function (webview) {
        return _webviewObj;
    },

    setUIWebViewObj: function (webviewObj) {
        _webviewObj.uiWebView = webviewObj;
    },

    allowUserMedia: function (evtId, cameraName) {
        _webviewObj.allowUserMedia(evtId, cameraName);
    },

    disallowUserMedia: function (evtId) {
        _webviewObj.disallowUserMedia(evtId);
    }
};

webview.__defineGetter__('id', function () {
    if (_webviewObj) {
        return _webviewObj.id;
    }
});

webview.__defineGetter__('enableCrossSiteXHR', function () {
    return _webviewObj.enableCrossSiteXHR;
});

webview.__defineSetter__('enableCrossSiteXHR', function (shouldEnable) {
    _webviewObj.enableCrossSiteXHR = !!shouldEnable;
});

webview.__defineGetter__('processId', function () {
    return _webviewObj.processId;
});

webview.__defineSetter__('onOpenWindow', function (input) {
    _webviewObj.onOpenWindow = input;
});

webview.__defineSetter__('onCloseWindow', function (input) {
    _webviewObj.onCloseWindow = input;
});

webview.__defineSetter__('onDestroyWindow', function (input) {
    _webviewObj.onDestroyWindow = input;
});

webview.__defineSetter__('onDialogRequested', function (input) {
    _webviewObj.onDialogRequested = input;
});

webview.__defineSetter__('onGeolocationPermissionRequest', function (input) {
    _webviewObj.onGeolocationPermissionRequest = input;
});

webview.__defineSetter__('onSSLHandshakingFailed', function (input) {
    _webviewObj.onSSLHandshakingFailed = input;
});

webview.__defineSetter__('onPropertyCurrentContextEvent', function (input) {
    _webviewObj.onPropertyCurrentContextEvent = input;
});

webview.__defineSetter__('onContextMenuRequestEvent', function (input) {
    _webviewObj.onContextMenuRequestEvent = input;
});

webview.__defineSetter__('onContextMenuCancelEvent', function (input) {
    _webviewObj.onContextMenuCancelEvent = input;
});

webview.__defineSetter__('onUserMediaRequest', function (input) {
    _webviewObj.onUserMediaRequest = input;
});

webview.__defineSetter__('onChildWindowOpen', function (input) {
    _webviewObj.onChildWindowOpen = input;
});

module.exports = webview;

});
define('lib/config/default.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

module.exports = {
    configXML: "config.xml",
    configXMLDoc: null,

    cordovaVersion: "3.8.0",

    backButtonBehavior: "back",
    customHeaders: {},
    version: "1.0.0",

    author: "",
    authorURL: "",
    authorEmail: "",
    copyright: "",
    content: "local:///index.html",
    contentCharset: "",
    contentType: "",
    description: "",
    icon: "AIRApp_72.png",
    iconHover: "",
    id: "",
    license: "",
    licenseURL: "",
    name: "WebWorksAppTemplate",

    navigationMode: "pointer",

    preferredTransports: null,
    transportTimeout: 300000,

    hasMultiAccess: false,
    widgetExtensions: null,
    featureTable: null,
    accessList: null,
    permissions: null,

    loadingScreenColor: "#FFFFFF",
    backgroundImage: "",
    foregroundImage: "",
    onFirstLaunch: false,
    onLocalPageLoad: false,
    onRemotePageLoad: false,
    transitionType: -1,
    transitionDuration: 250,
    transitionDirection: 128,

    disableAllCache: false,
    aggressiveCacheAge: 2592000,
    maxCacheSizeTotal: 1024,
    maxCacheSizeItem: 128,
    maxStandardCacheAge: 2592000,

    runOnStartUp: false,
    allowInvokeParams: false,
    backgroundSource: "",
    foregroundSource: "index.html",
    debugEnabled: false,
    enableFormControl: true,
    enableChildWebView: true,
    enableWebSecurity: true,
    enableDiskCache: false,
    enablePopupBlocker: false
};

});
define('lib/config/user.js', function (require, exports, module) {
module.exports = {
    "version": "3.2.1",
    "id": "com.xplota.playepub",
    "hasMultiAccess": true,
    "accessList": [
        {
            "uri": "WIDGET_LOCAL",
            "allowSubDomain": true
        },
        {
            "uri": "file:///accounts/",
            "allowSubDomain": true
        },
        {
            "uri": "file:///accounts/1000/",
            "allowSubDomain": true
        },
        {
            "uri": "file:///accounts/1000/downloads/",
            "allowSubDomain": true
        },
        {
            "uri": "file:///apps/",
            "allowSubDomain": true
        },
        {
            "uri": "file:///",
            "allowSubDomain": true
        },
        {
            "uri": "https://pushapi.eval.blackberry.com",
            "allowSubDomain": true
        },
        {
            "uri": "https://sync.playepub.com",
            "allowSubDomain": true
        },
        {
            "uri": "https://www.instapaper.com",
            "allowSubDomain": true
        }
    ],
    "enableFlash": false,
    "autoOrientation": true,
    "autoDeferNetworkingAndJavaScript": false,
    "theme": "default",
    "autoHideSplashScreen": true,
    "useSpatialNavigation": true,
    "icon": [
        "www/assets/icon115.png"
    ],
    "author": "Jesus Iglesias",
    "authorURL": "http://xapps.es",
    "authorEmail": "osus@osusnet.com",
    "license": "",
    "licenseURL": "",
    "content": "local:///index.html",
    "foregroundSource": "index.html",
    "permissions": [
        "read_device_identifying_information",
        "access_shared",
        "bbm_connect",
        {
            "#": "_sys_use_consumer_push",
            "@": {
                "system": "true"
            }
        },
        "run_when_backgrounded",
        "post_notifications",
        "post_notification"
    ],
    "invoke-target": [
        {
            "@": {
                "id": "com.xplota.playepub.push"
            },
            "type": "APPLICATION",
            "filter": [
                {
                    "action": [
                        "bb.action.PUSH"
                    ],
                    "mime-type": [
                        "application/vnd.push"
                    ]
                }
            ]
        },
        {
            "@": {
                "id": "com.xplota.playepub.app"
            },
            "type": "APPLICATION",
            "filter": [
                {
                    "action": [
                        "bb.action.OPEN"
                    ],
                    "mime-type": [
                        "*"
                    ],
                    "property": [
                        {
                            "@": {
                                "value": "file://,http://,https://,ftp://",
                                "var": "uris"
                            }
                        },
                        {
                            "@": {
                                "value": "epub,mobi,fb2,prc,azw,pdb",
                                "var": "exts"
                            }
                        }
                    ]
                }
            ]
        }
    ],
    "rim:splash": [
        "assets/splash1280x720.jpg",
        "assets/splash720x1280.jpg",
        "assets/splash1280x768.jpg",
        "assets/splash768x1280.jpg",
        "assets/splash720x720.jpg",
        "assets/splash1440x1440.jpg"
    ],
    "name": {
        "default": "Playepub Book Reader"
    },
    "description": {},
    "packageCordovaJs": false,
    "enableChildWebView": true,
    "enablePopupBlocker": false,
    "enableWebSecurity": false,
    "enableDiskCache": true,
    "configXML": "config.xml",
    "configFileInjections": [],
    "debugEnabled": false
};
});
define('lib/events/applicationEvents.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

module.exports = {
    addEventListener: function (event, trigger) {
        if (event) {
            event = "application." + event;
            window.qnx.webplatform.getApplication().addEventListener(event, trigger);
        } else {
            console.warn("Attempting to register for 'falsey' event: " + event);
        }
    },
    removeEventListener: function (event, trigger) {
        if (event) {
            event = "application." + event;
            window.qnx.webplatform.getApplication().removeEventListener(event, trigger);
        } else {
            console.warn("Attempting to un-register for 'falsey' event: " + event);
        }
    }
};

});
define('lib/events/deviceEvents.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

module.exports = {
    addEventListener: function (event, trigger) {
        if (event) {
            event = "device." + event;
            window.qnx.webplatform.device.addEventListener(event, trigger);
        } else {
            console.warn("Attempting to register for 'falsey' event: " + event);
        }
    },
    removeEventListener: function (event, trigger) {
        if (event) {
            event = "device." + event;
            window.qnx.webplatform.device.removeEventListener(event, trigger);
        } else {
            console.warn("Attempting to un-register for 'falsey' event: " + event);
        }
    }
};

});
define('lib/plugins/default.js', function (require, exports, module) {
/*
 * Copyright 2010-2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var Whitelist = require("../policy/whitelist").Whitelist,
    whitelist = new Whitelist();

module.exports = {

    exec: function (request, succ, fail, args, env) {
        var extPath = "plugin/" + request.params.ext + "/index",
            requestObj = {
                extension: null,
                method: null,
                getExtension: function () {
                    if (frameworkModules.indexOf(extPath + ".js") !== -1) {
                        this.extension = require("../utils").loadModule("../" + extPath);
                        return requestObj;
                    } else {
                        throw {code: 404, msg: "Extension " + request.params.ext + " not found"};
                    }
                },
                getMethod: function () {
                    var methodParts = request.params.method ? request.params.method.split('/') : [request.params.method],
                        extMethod;

                    try {
                        extMethod = this.extension[methodParts.shift()];
                        extMethod = methodParts.reduce(function (previous, current) {
                            if (previous[current]) {
                                return previous[current];
                            } else {
                                throw {code: 404, msg: "Method " + request.params.method + " for " + request.params.ext + " not found"};
                            }
                        }, extMethod);

                        if (extMethod && typeof extMethod === "function") {
                            this.method = extMethod;
                            return requestObj;
                        } else {
                            throw {code: 404, msg: "Method " + request.params.method + " for " + request.params.ext + " not found"};
                        }
                    } catch (e) {
                        throw {code: 404, msg: "Method " + request.params.method + " for " + request.params.ext + " not found"};
                    }
                },
                exec: function () {
                    this.method(succ, fail, args, env);
                }
            };

        try {
            requestObj.getExtension().getMethod().exec();
        } catch (e) {
            console.warn(e.msg);
            fail(-1, e.msg, e.code);
        }
    }
};

});
define('lib/plugins/event.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

var _event = require("../../lib/event"),
    ONCE_EVENT_ERROR = "Error occurred while adding once event listener.",
    ERROR_ID = -1;

module.exports = {
    once: function (request, success, fail, args, env) {
        try {
            var eventName = decodeURIComponent(args.eventName).replace(/\"/g, ""),
                action = {
                    once: true,
                    event: eventName
                };

            _event.add(action, env.webview);

            if (success) {
                success();
            }
        }
        catch (e) {
            if (fail) {
                fail(ERROR_ID, ONCE_EVENT_ERROR);
            }
        }
    }
};

});
define('lib/policy/folderAccess.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

var util = require("../utils");

// Removes the start and end slashes from the path
function _trimSurroundingSlashes(path) {
    // Trim starting slash
    if (util.startsWith(path, "/")) {
        path = path.substr(1);
    }

    // Trim ending slash
    if (util.endsWith(path, "/")) {
        path = path.substr(0, path.length - 1);
    }

    return path;
}

// Determines the depth of the given path
// Folder path must not include the scheme or the host
function _determineDepth(folderPath) {
    var depthCount = 0;

    // Replace all backslashes with forward slash
    folderPath = folderPath.replace("\\", "/");

    // Special case: "/" is the given path
    if (folderPath === "/") {
        return 0;
    }

    folderPath = _trimSurroundingSlashes(folderPath);

    // Count slashes remaining
    while (folderPath.indexOf("/") !== -1) {
        depthCount = depthCount + 1;

        // Add 1 to skip the slash
        folderPath = folderPath.substring(folderPath.indexOf("/") + 1);
    }

    // Add one more for the remaining folder
    depthCount += 1;

    return depthCount;
}

// Parse a folder path up to the desired depth
function _getPath(folderPath, desiredDepth) {
    var depthCount = 0, builtPath = "";

    // Special case: Desired depth is 0
    if (desiredDepth === 0) {
        return "/";
    }

    // Replace all backslashes with forward slash
    folderPath = folderPath.replace("\\", "/");

    folderPath = _trimSurroundingSlashes(folderPath);

    // Count slashes remaining
    while (depthCount < desiredDepth) {
        depthCount += 1;

        // Add 1 to skip the slash
        builtPath += "/" + folderPath.substring(0, folderPath.indexOf('/'));
        folderPath = folderPath.substring(folderPath.indexOf('/') + 1);
    }

    return builtPath;
}

function WebFolderAccessManager() {
    this._pathCollection = {};
    this._maxPathLength = 0;
}

WebFolderAccessManager.prototype.addAccess = function (folderPath, access) {
    if (!folderPath) {
        folderPath = "/";
    }

    // Trim surrounding slashes for consistency
    // The root "/" is a special case that does not need this trimming
    if (folderPath !== "/") {
        folderPath = "/" + _trimSurroundingSlashes(folderPath);
    }

    folderPath = folderPath.toLowerCase();

    this._pathCollection[folderPath] = access;

    // Determine the depth of the path
    this._maxPathLength = Math.max(this._maxPathLength, _determineDepth(folderPath));
};

WebFolderAccessManager.prototype.getAccess = function (folderPath) {
    var depth = _determineDepth(folderPath);
    return this.getAccessRecursively(folderPath, depth);
};

WebFolderAccessManager.prototype.fetchAccess = function (folderPath) {
    var queryIndex, folderPathWildcard;

    if (!this._pathCollection.hasOwnProperty(folderPath)) {
        // If there isn't an exact match and folderPath contains query string,
        // check if the path collection contains an access with the same folderPath
        // but with wildcard query
        if ((queryIndex = folderPath.indexOf("?")) > -1) {
            folderPathWildcard = folderPath.slice(0, queryIndex + 1) + "*";

            if (this._pathCollection.hasOwnProperty(folderPathWildcard)) {
                return this._pathCollection[folderPathWildcard];
            }
        }

        return null;
    } else {
        return this._pathCollection[folderPath];
    }
};

WebFolderAccessManager.prototype.getAccessRecursively = function (folderPath, pathLength) {
    var fetchedAccess,
        newPathLength,
        newPath;

    if (!folderPath) {
        return null;
    }

    folderPath = folderPath.toLowerCase();

    if (!!(fetchedAccess = this.fetchAccess(folderPath))) {
        return fetchedAccess;
    } else {
        // Truncate the end portion of the path and try again
        newPathLength = Math.min(this._maxPathLength, pathLength - 1);
        newPath = _getPath(folderPath, newPathLength);

        return this.getAccessRecursively(newPath, newPathLength);
    }
};

function WebFolderAccess() {
    this._mgr = new WebFolderAccessManager();
}

// folderPath - folder path must not include the scheme or the host
WebFolderAccess.prototype.addAccess = function (folderPath, access) {
    this._mgr.addAccess(folderPath, access);
};

// folderPath - folder path must not include the scheme or the host
WebFolderAccess.prototype.getAccess = function (folderPath) {
    return this._mgr.getAccess(folderPath);
};

exports.WebFolderAccess = WebFolderAccess;

});
define('lib/policy/webkitOriginAccess.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var config = require('./../config'),
    utils = require('./../utils'),
    Whitelist = require('./whitelist').Whitelist,
    LOCAL_URI = "local://",
    FILE_URI = "file://",
    WW_URI = utils.getURIPrefix(),
    _domains = [
        {
            url: LOCAL_URI,
            allowSubDomains: true
        }
    ],
    _webviews = [],
    _isInitialized = false,
    _whitelist = new Whitelist();

function addOriginAccessWhitelistEntry(webview, source, destination, allowSubDomains) {
    webview.addOriginAccessWhitelistEntry(source, destination, !!allowSubDomains);
}

function addDomain(url, allowSubDomains) {
    var parsedUri = utils.parseUri(url);

    allowSubDomains = !!allowSubDomains;

    if (utils.isLocalURI(parsedUri)) {
        url = LOCAL_URI;
    } else if (utils.isFileURI(parsedUri)) {
        url = FILE_URI;
    } else {
        url = parsedUri.source;
    }

    if (_whitelist.isAccessAllowed(url) && !_domains.some(function (domain) {
        return domain.url === url;
    })) {
        _webviews.forEach(function (webview) {
            addOriginAccessWhitelistEntry(webview, url, WW_URI, true);

            _domains.forEach(function (domain) {
                addOriginAccessWhitelistEntry(webview, domain.url, url, allowSubDomains);
                addOriginAccessWhitelistEntry(webview, url, domain.url, domain.allowSubDomains);
            });

        });

        _domains.push({
            url: url,
            allowSubDomains: allowSubDomains
        });
    }
}

function initializeDomains() {
    var accessElements = config.accessList;

    accessElements.forEach(function (element, index, array) {
        var uri = (element.uri === 'WIDGET_LOCAL' ? LOCAL_URI : element.uri);
        addDomain(uri, !!element.allowSubDomain);
    });
}

function initializeWebview(webview) {
    //Always allow file access from local and let the OS deal with permissions
    addOriginAccessWhitelistEntry(webview, LOCAL_URI, FILE_URI, true);
    addOriginAccessWhitelistEntry(webview, FILE_URI, LOCAL_URI, true);
    //Always allow LOCAL access to URIs
    addOriginAccessWhitelistEntry(webview, LOCAL_URI, WW_URI, true);

    _domains.forEach(function (domain, domainIndex, domainArray) {
        var i,
            nextDomain;

        if (domain.uri !== LOCAL_URI) {
            addOriginAccessWhitelistEntry(webview, domain.url, WW_URI, true);
        }

        for (i = domainIndex + 1; i < domainArray.length; i++) {
            nextDomain = domainArray[i];
            addOriginAccessWhitelistEntry(webview, domain.url, nextDomain.url, nextDomain.allowSubDomains);
            addOriginAccessWhitelistEntry(webview, nextDomain.url, domain.url, domain.allowSubDomains);
        }
    });

}

module.exports = {

    addWebView: function (webview) {
        if (_webviews.indexOf(webview) === -1) {
            _webviews.push(webview);
            initializeWebview(webview);
            if (!_isInitialized) {
                initializeDomains();
                _isInitialized = true;
            }
        }
    },

    addOriginAccess: function (origin, allowSubDomains) {
        if (!_isInitialized) {
            initializeDomains();
            _isInitialized = true;
        }
        addDomain(origin, allowSubDomains);
    }
};

});
define('lib/policy/whitelist.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/

var WebFolderAccess = require("./folderAccess").WebFolderAccess,
    util = require("../utils");

function _isLocalAccess(access) {
    return access && access.uri === "WIDGET_LOCAL";
}

function _isMatch(access, requestURI) {
    // Look for local first
    if (_isLocalAccess(access)) {
        // Local access always allowed
        //THIS USED TO RETURN TRUE FOR FILE ACCESS
        //I HAVE TURNED IT OFF BECAUSE IT MAKES NO SENSE THAT LOCAL ACCESS ALWAYS MATCHES FILE ACCESS
        return (util.isLocalURI(requestURI));
    } else if (util.isDataURI(requestURI)) {
        // Check for data url
        // data urls are allowed
        return true;
    }

    // Based on widgets 1.0 (access control)
    // http://www.w3.org/TR/2009/WD-widgets-access-20090618/#rfc3987
    var refURI = util.parseUri(access.uri),
        allowSub = access.allowSubDomain;

    if (!requestURI.path) {
        requestURI.path = "/";
    }

    // Start comparison based on widget spec.
    // 1. Compare scheme
    if (refURI.scheme.toLowerCase() !== requestURI.scheme.toLowerCase()) {
        return false;
    }

    // 2. Compare host - if subdomain is false, host must match exactly
    // (referenceURI MUST HAVE host specified - not null.)
    // Special Case: Ignore this condition if we are dealing with file://
    if (!requestURI.authority && !util.isFileURI(requestURI)) {
        return false;
    }

    if (!allowSub && refURI.host.toLowerCase() !== requestURI.host.toLowerCase()) {
        return false;
    }

    // 3. Compare host - if subdomain is true, check for subdomain or match
    if (allowSub && !util.endsWith(requestURI.host.toLowerCase(), "." + refURI.host.toLowerCase()) &&
        requestURI.host.toLowerCase() !== refURI.host.toLowerCase()) {
        return false;
    }

    // 4. Compare port
    if (refURI.port && refURI.port !== requestURI.port) {
        return false;
    }

    // 5.  Compare path+query
    if (!util.startsWith(requestURI.path.toLowerCase(), refURI.path.toLowerCase()) && refURI.query !== "*") {
        return false;
    }

    return true;
}

function _getAccessForPathAndQuery(folderAccess, path, query) {
    if (folderAccess) {
        if (!query) {
            return folderAccess.getAccess(path);
        } else {
            return folderAccess.getAccess(path + "?" + query);
        }
    }

    return null;
}

function AccessManager(config) {
    config = config || require("../config");

    this._accessList = config.accessList;
    this._hasGlobalAccess = config.hasMultiAccess;
    this._authorityCollection = null;
    this._localAccess = null;
}

AccessManager.prototype.getFolderAccess = function (scheme, authority) {
    var key = scheme + "://" + authority;
    key = key.toLowerCase();

    if (this._authorityCollection.hasOwnProperty(key)) {
        return this._authorityCollection[key];
    }

    return null;
};

AccessManager.prototype.putFolderAccess = function (scheme, authority, folderAccess) {
    var key = scheme + "://" + authority;
    key = key.toLowerCase();
    this._authorityCollection[key] = folderAccess;
};

AccessManager.prototype.initializeAuthCollection = function () {
    var folderAccess, currentURI, that = this;

    if (!this._authorityCollection) {
        this._authorityCollection = {};

        if (this._accessList) {
            this._accessList.forEach(function (access) {
                if (_isLocalAccess(access)) {
                    that._localAccess = access;
                } else {
                    currentURI = util.parseUri(access.uri);

                    // Check the authority collection to see if the authority item
                    // we want already exists
                    folderAccess = that.getFolderAccess(currentURI.scheme, currentURI.authority) || new WebFolderAccess();

                    // Add folder path access to the authority item
                    if (!currentURI.query) {
                        folderAccess.addAccess(currentURI.path, access);
                    } else {
                        folderAccess.addAccess(currentURI.path + "?" + currentURI.query, access);
                    }

                    that.putFolderAccess(currentURI.scheme, currentURI.authority, folderAccess);
                }
            });
        }
    }
};

AccessManager.prototype.authorityCheck = function (port, scheme, authority) {
    var originalAuthority = authority;

    if (port) {
        // If authority has a specific port, and the collection does not have an access matches
        // the exact authority, strip port from authority to see if there is a match
        if (!this.getFolderAccess(scheme, authority)) {
            authority = authority.slice(0, authority.lastIndexOf(":"));
            authority = this.authorityCheck("", scheme, authority);
        }

        //If no successful match was found without the port, reset the authority and try with it
        if (!this.getFolderAccess(scheme, authority)) {
            authority = originalAuthority;
        }
    }

    if (authority.indexOf(".") === -1) {
        // If authority is computer name, must have exact match in collection
        if (!this.getFolderAccess(scheme, authority)) {
            return "";
        }

        return authority;
    }

    while (authority && !this.getFolderAccess(scheme, authority)) {
        if (authority.indexOf(".") === -1) {
            return "";
        }
        authority = authority.substring(authority.indexOf(".") + 1);
    }

    return authority;
};

AccessManager.prototype.getFromFolderAccess = function (folderAccess, requestURI) {
    var fetchedAccess = null,
        scheme = requestURI.scheme,
        authority = requestURI.authority,
        path = requestURI.path,
        query = requestURI.query,
        prevAuthority;

    if (!path) {
        fetchedAccess = folderAccess.getAccess("/");
    } else {
        fetchedAccess = _getAccessForPathAndQuery(folderAccess, path, query);
    }

    // Make sure we've got the right one
    while (!fetchedAccess || !_isMatch(fetchedAccess, requestURI)) {
        // There was an auth url that matched, but didnt match the folder structure
        // Try the next level up
        prevAuthority = authority;
        authority = authority.substring(authority.indexOf(".") + 1);
        //If authority hasn't changed, then this loop will continue endlessly because nothing else has changed
        //This will happen when an element has the same authority but no folder access.
        if (prevAuthority === authority) {
            return null;
        }

        // Check for an authority string that has an existing key
        authority = this.authorityCheck(requestURI.port, scheme, authority);
        if (!authority) {
            return null;
        }

        // Retrieve access set for the specified authority
        folderAccess = this.getFolderAccess(scheme, authority);

        // Special case: no access element was found for a file protocol request.
        // This is added since file protocol was allowed through the above check
        if (scheme === "file" && !folderAccess) {
            return null;
        }

        fetchedAccess = _getAccessForPathAndQuery(folderAccess, path, query);
    }

    return fetchedAccess;
};

AccessManager.prototype.getAccessByUrl = function (url) {
    var requestURI = util.parseUri(url),
        authority = requestURI.authority,
        scheme = requestURI.scheme,
        folderAccess,
        fetchedAccess;

    if (util.isAbsoluteURI(requestURI)) {
        // Initialize authority collection if it does not yet exist
        this.initializeAuthCollection();

        // Start with the full authority path and check if an access exists for that path
        // If it does not exist, remove the first section of the authority path and try again

        // Check for an authority string that has an existing key
        // Special case: Allow file, and local protocol to proceed without an authority
        authority = this.authorityCheck(requestURI.port, scheme, authority);
        if (!authority && !(scheme === "file" || scheme === "local" || scheme === "data")) {
            return null;
        }
        // Retrieve access set for the specified authority
        folderAccess = this.getFolderAccess(scheme, authority);

        // Special case: no access was found for a file protocol request
        // This is added since file protocol was allowed through the above check
        if (scheme === "file" && !folderAccess) {
            return null;
        } else if (scheme === "local" && !folderAccess) {
            // If no access element is found with local URI, use local access for this request
            return this._localAccess;
        } else if (scheme === "data") {
            // Always allow data-uris
            return true;
        }

        fetchedAccess = this.getFromFolderAccess(folderAccess, requestURI);

        if (fetchedAccess) {
            return fetchedAccess;
        } else if (this._localAccess && _isMatch(this._localAccess, requestURI)) {
            // If we cannot find a more specific access for this local URI, use local access
            return this._localAccess;
        } else if (folderAccess && _isMatch(folderAccess, requestURI)) {
            return folderAccess;
        }
    }

    return null;
};

AccessManager.prototype.hasGlobalAccess = function () {
    return this._hasGlobalAccess;
};

function Whitelist(config) {
    this._mgr = new AccessManager(config);
}

Whitelist.prototype.getFeaturesForUrl = function (url) {
    var access = this._mgr.getAccessByUrl(url),
        featureIds = [];

    if (access && access.features) {
        access.features.forEach(function (elem) {
            featureIds.push(elem.id);
        });
    }

    return featureIds;
};

Whitelist.prototype.isFeatureAllowed = function (url, feature) {
    var features = this.getFeaturesForUrl(url);

    return !!features && features.reduce(function (found, current) {
        return found || current === feature;
    }, false);
};

Whitelist.prototype.isAccessAllowed = function (url, isXHR) {
    return (this._mgr.hasGlobalAccess() && !isXHR) || !!this._mgr.getAccessByUrl(url);
};

exports.Whitelist = Whitelist;

});
define('lib/webkitHandlers/networkResourceRequested.js', function (require, exports, module) {
/*
 *  Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Whitelist = require('../policy/whitelist').Whitelist,
    ACCEPT_RESPONSE = {setAction: "ACCEPT"},
    DENY_RESPONSE = {setAction: "DENY"},
    SUBSTITUTE_RESPONSE = {setAction: "SUBSTITUTE"},
    utils = require('../utils');

function _formMessage(url, origin, sid, body, securityOrigin, webview) {
    var tokens = url.split(utils.getURIPrefix())[1].split("/"),
        //Handle the case where the method is multi-level
        finalToken = (tokens[3] && tokens.length > 4) ? tokens.slice(3).join('/') : tokens[3];

    return {
        request : {
            params : {
                service : tokens[0],
                action : tokens[1],
                ext : tokens[2],
                method : (finalToken && finalToken.indexOf("?") >= 0) ? finalToken.split("?")[0] : finalToken,
                args : (finalToken && finalToken.indexOf("?") >= 0) ? finalToken.split("?")[1] : null
            },
            body : body,
            origin : origin,
            securityOrigin: securityOrigin

        },
        response : {
            send : function (code, data) {
                var responseText;
                if (typeof(data) === 'string') {
                    responseText = data;
                } else {
                    responseText =  JSON.stringify(data);
                }

                webview.notifyOpen(sid, code, "OK");
                webview.notifyHeaderReceived(sid, "Access-Control-Allow-Origin", "*");
                webview.notifyHeaderReceived(sid, "Access-Control-Allow-Origin", securityOrigin);
                webview.notifyHeaderReceived(sid, "Access-Control-Allow-Headers", "Content-Type");
                webview.notifyDataReceived(sid, responseText, responseText.length);
                webview.notifyDone(sid);
            }
        }
    };
}

function networkResourceRequestedHandler(value) {
    var config = require("./../config"),
        obj = JSON.parse(value),
        response,
        url = obj.url,
        body = obj.body,
        whitelist = new Whitelist(),
        server,
        message,
        sid = obj.streamId,
        origin = obj.referrer,
        securityOrigin = obj.securityOrigin,
        isXHR = obj.targetType === "TargetIsXMLHTTPRequest",
        //Assumes its a navigation request if the target is the main frame
        isNav = obj.targetType === "TargetIsMainFrame",
        hasAccess = whitelist.isAccessAllowed(url, isXHR),
        deniedMsg;

    //If the URL starts with the prefix then its a request from an API
    //In this case we will hijack and give our own response
    //Otherwise follow whitelisting rules
    if (url.match("^" + utils.getURIPrefix())) {
        server = require("../server");
        message = _formMessage(url, origin, sid, body, securityOrigin, this.webview, config);
        response = SUBSTITUTE_RESPONSE;
        server.handle(message.request, message.response, this.webview);
    } else {
        //Whitelisting will not prevent navigation, ONLY we will
        //Except when they've disabled web security
        if (hasAccess || !config.enableWebSecurity) {
            response = ACCEPT_RESPONSE;
        } else {
            response = DENY_RESPONSE;
            url = utils.parseUri(url);
            deniedMsg = "Access to \"" + url.source + "\" not allowed";

            console.warn(deniedMsg);

            //Denied navigation requests are sent to the inApp browser rather than an alert
            if (isNav) {
                if (config.enableChildWebView) {
                    this.webview.uiWebView.childwebviewcontrols.open(url.source);
                } else {
                    utils.invokeInBrowser(url.source);
                }
            } else {
                this.webview.executeJavaScript("alert('" + deniedMsg + "')");
            }
        }
    }

    if (response) {
        return JSON.stringify(response);
    }
}

function NetworkResourceRequestHandler(webview) {
    this.webview = webview;
    this.networkResourceRequestedHandler = networkResourceRequestedHandler.bind(this);
}

module.exports = {
    createHandler: function (webview) {
        return new NetworkResourceRequestHandler(webview);
    }
};

});
define('plugin/com.blackberry.display/index.js', function (require, exports, module) {
/*
 * Copyright (c) 2014 BlackBerry Limited
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var preventSleep,
    resultObjs = {},
    threadCallback = null;

module.exports = {

    // Code can be declared and used outside the module.exports object,
    // but any functions to be called by client.js need to be declared
    // here in this object.

    setPreventSleep: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            views = qnx.webplatform.getWebViews(),
            handle = null,
            z = -1,
            i,
            values;

        args = JSON.parse(decodeURIComponent(args["input"]));
        for (i = 0; i < views.length; i++) {
            if (views[i].visible && views[i].zOrder > z) {
                z = views[i].zOrder;
                handle = views[i].jsScreenWindowHandle;
            }
        }
        if (handle !== null) {
            values = { value: args, handle: handle };
            result.ok(preventSleep.getInstance().setPreventSleep(result.callbackId, values), false);
        } else {
            result.error("Unable to get window handle", false);
        }
    },
    isSleepPrevented: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        result.ok(preventSleep.getInstance().isSleepPrevented() === "1", false);
    }
};

///////////////////////////////////////////////////////////////////
// JavaScript wrapper for JNEXT plugin for connection
///////////////////////////////////////////////////////////////////

JNEXT.PreventSleep = function () {
    var self = this,
        hasInstance = false;

    self.getId = function () {
        return self.m_id;
    };

    self.init = function () {
        if (!JNEXT.require("libdisplay")) {
            return false;
        }

        self.m_id = JNEXT.createObject("libdisplay.PreventSleepJS");

        if (self.m_id === "") {
            return false;
        }

        JNEXT.registerEvents(self);
    };

    self.setPreventSleep = function (callbackId, input) {
        return JNEXT.invoke(self.m_id, "setPreventSleep " + callbackId + " " + JSON.stringify(input));
    };
    self.isSleepPrevented = function () {
        return JNEXT.invoke(self.m_id, "isSleepPrevented");
    };
    // Fired by the Event framework (used by asynchronous callbacks)
    self.onEvent = function (strData) {
        var arData = strData.split(" "),
            callbackId = arData[0],
            result = resultObjs[callbackId],
            data = arData.slice(1, arData.length).join(" ");

        if (result) {
            result.callbackOk(data, false);
            delete resultObjs[callbackId];
        }
    };

    self.m_id = "";
    self.getInstance = function () {
        if (!hasInstance) {
            hasInstance = true;
            self.init();
        }
        return self;
    };

};

preventSleep = new JNEXT.PreventSleep();

});
define('plugin/cordova-plugin-bb-app/index.js', function (require, exports, module) {
/*
 * Copyright 2010-2011 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _config = require("./../../lib/config"),
    _utils = require("./../../lib/utils"),
    _appEvents = require("./../../lib/events/applicationEvents"),
    _orientation,
    _listeners = {},
    _actionMap = {
        swipedown: {
            event: "swipedown",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        },
        orientationchange : {
            //special case, handled in add
            event: "rotate",
            trigger: function () {}
        },
        keyboardopening: {
            event: "keyboardOpening",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        },
        keyboardopened: {
            event: "keyboardOpened",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        },
        keyboardclosing: {
            event: "keyboardClosing",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        },
        keyboardclosed: {
            event: "keyboardClosed",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        },
        keyboardposition: {
            event: "keyboardPosition",
            trigger: function (pluginResult, obj) {
                pluginResult.callbackOk(JSON.parse(obj), true);
            }
        },
        windowstatechanged: {
            event: "stateChange",
            trigger: function (pluginResult, obj) {
                pluginResult.callbackOk(obj, true);
            }
        },
        backbutton: {
            event: "systemKeyPress-Back",
            trigger: function (pluginResult, obj) {
                pluginResult.callbackOk({type: "backbutton"}, true);
            }
        },
        menubutton: {
            event: "UnhandledKeyInput",
            trigger: function (pluginResult, obj) {
                var e = JSON.parse(obj);
                if (e.character === 61543 && !e.keyDown) {
                    pluginResult.callbackOk({type: "menubutton"}, true);
                }
            }
        },
        unhandledkeyinput: {
            event: "UnhandledKeyInput",
            trigger: function (pluginResult, obj) {
                pluginResult.callbackOk(JSON.parse(obj), true);
            }
        }
    };

function angleToOrientation(angle) {
    var orientation;

    switch (angle) {
    case 0:
        orientation = 'portrait-primary';
        break;
    case 90:
        orientation = 'landscape-secondary';
        break;
    case 180:
        orientation = 'portrait-secondary';
        break;
    case -90:
    case 270:
        orientation = 'landscape-primary';
        break;
    default:
        orientation = "unknown";
        break;
    }

    return orientation;
}

function edgeToOrientation(edge) {
    switch (edge) {
    case "left_up":
        return "landscape-primary";
    case "top_up":
        return "portrait-primary";
    case "bottom_up":
        return "portrait-secondary";
    case "right_up":
        return "landscape-secondary";
    default:
        return "unknown";
    }
}

function translateToDeviceOrientation(orientation) {
    // Convert HTML5 orientation syntax into device syntax
    switch (orientation) {
    case 'portrait':
    case 'portrait-primary':
        return 'top_up';

    case 'landscape':
    case 'landscape-primary':
        return 'left_up';

    case 'portrait-secondary':
        return 'bottom_up';

    case 'landscape-secondary':
        return 'right_up';

    default:
        return 'unknown';
    }
}

function rotateTrigger(pluginResult, width, height, angle) {
    _orientation = angleToOrientation(angle);
    pluginResult.callbackOk(_orientation, true);
}

function rotateWhenLockedTrigger(pluginResult, edge) {
    _orientation = edgeToOrientation(edge);
    pluginResult.callbackOk(_orientation, true);
}

module.exports = {

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            systemEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            if (eventName === "orientationchange") {
                _appEvents.removeEventListener("rotate", _listeners[eventName][env.webview.id][0]);
                _appEvents.removeEventListener("rotateWhenLocked", _listeners[eventName][env.webview.id][1]);
            } else if (systemEvent === "UnhandledKeyInput") {
                env.webview.removeEventListener(systemEvent, _listeners[eventName][env.webview.id]);
            } else {
                _appEvents.removeEventListener(systemEvent, _listeners[eventName][env.webview.id]);
            }
        }

        if (eventName === "orientationchange") {
            listener = [rotateTrigger.bind(null, result), rotateWhenLockedTrigger.bind(null, result)];
            _appEvents.addEventListener("rotate", listener[0]);
            _appEvents.addEventListener("rotateWhenLocked", listener[1]);
        } else if (systemEvent === "UnhandledKeyInput") {
            env.webview.addEventListener(systemEvent, listener);
        } else {
            _appEvents.addEventListener(systemEvent, listener);
        }

        _listeners[eventName][env.webview.id] = listener;
        result.noResult(true);
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[eventName] ? _listeners[eventName][env.webview.id] : undefined,
            systemEvent = _actionMap[eventName].event;
        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            if (eventName  === "orientationchange") {
                _appEvents.removeEventListener("rotate", listener[0]);
                _appEvents.removeEventListener("rotateWhenLocked", listener[1]);
            } else if (systemEvent === "UnhandledKeyInput") {
                env.webview.removeEventListener(systemEvent, listener);
            } else {
                _appEvents.removeEventListener(systemEvent, listener);
            }
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    },

    getReadOnlyFields : function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            ro = {
                author: _config.author,
                authorEmail: _config.authorEmail,
                authorURL: _config.authorURL,
                copyright: _config.copyright,
                description: _config.description,
                id: _config.id,
                license: _config.license,
                licenseURL: _config.licenseURL,
                name: _config.name,
                version: _config.version
            };
        result.ok(ro, false);
    },

    lockOrientation : function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            orientation = JSON.parse(decodeURIComponent(args.orientation)),
            rotateTo = translateToDeviceOrientation(orientation),
            recieveRotateEvents = args.recieveRotateEvents === undefined  ? true : args.recieveRotateEvents;

        // Force rotate to the given orientation then lock it
        qnx.webplatform.getApplication().rotate(rotateTo);
        qnx.webplatform.getApplication().lockRotation(recieveRotateEvents);
        result.ok(true, false);
    },

    unlockOrientation : function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        qnx.webplatform.getApplication().unlockRotation();
        result.ok(null, false);
    },

    rotate : function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            orientation = translateToDeviceOrientation(JSON.parse(decodeURIComponent(args.orientation)), fail);
        qnx.webplatform.getApplication().rotate(orientation);
        result.ok(null, false);
    },

    currentOrientation : function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            orientation = _orientation || angleToOrientation(window.orientation);
        result.ok(orientation, false);
    },

    minimize: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        qnx.webplatform.getApplication().minimizeWindow();
        result.ok(null, false);
    },

    exit: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        window.qnx.webplatform.getApplication().exit();
        result.ok(null, false);
    },

    windowState : function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        result.ok(qnx.webplatform.getApplication().windowState, false);
    }
};

});
define('plugin/cordova-plugin-bb-card/index.js', function (require, exports, module) {
/*
 * Copyright 2011-2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var overlayWebView;

qnx.webplatform.getController().addEventListener('overlayWebView.initialized', function (webviewObj) {
    overlayWebView = webviewObj;
});

function trigger(result, type, arg) {
    var keepCallback = type === "invoke";

    result.callbackOk({
        "type": type,
        "result": arg
    }, keepCallback);
}

module.exports = {
    invokeMediaPlayer: function (success, fail, args, env) {
        var options = JSON.parse(decodeURIComponent(args.options)),
            result = new PluginResult(args, env),
            done = function (data) {
                trigger(result, "done", data);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };

        window.qnx.webplatform.getApplication().cards.mediaplayerPreviewer.open(options, done, cancel, invokeCallback);
        result.noResult(true);
    },

    invokeCamera: function (success, fail, args, env) {
        var mode = JSON.parse(decodeURIComponent(args.mode)),
            result = new PluginResult(args, env),
            done = function (path) {
                trigger(result, "done", path);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };
        if (mode === "") {
            mode = "photo";
        }
        window.qnx.webplatform.getApplication().cards.camera.open(mode, done, cancel, invokeCallback);
        result.noResult(true);
    },

    invokeFilePicker: function (success, fail, args, env) {
        var options = JSON.parse(decodeURIComponent(args.options)),
            result = new PluginResult(args, env),
            done = function (path) {
                trigger(result, "done", path);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };

        window.qnx.webplatform.getApplication().cards.filePicker.open(options, done, cancel, invokeCallback);
        result.noResult(true);
    },

    invokeIcsViewer: function (success, fail, args, env) {
        var options = JSON.parse(decodeURIComponent(args.options)),
            result = new PluginResult(args, env),
            done = function (path) {
                trigger(result, "done", path);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };

        window.qnx.webplatform.getApplication().cards.icsViewer.open(options, done, cancel, invokeCallback);
        result.noResult(true);
    },


    invokeCalendarPicker: function (success, fail, args, env) {
        var options = JSON.parse(decodeURIComponent(args.options)),
            result = new PluginResult(args, env),
            done = function (file) {
                trigger(result, "done", file);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };

        window.qnx.webplatform.getApplication().cards.calendar.picker.open(options, done, cancel, invokeCallback);
        result.noResult(true);
    },

    invokeCalendarComposer: function (success, fail, args, env) {
        var options = JSON.parse(decodeURIComponent(args.options)),
            result = new PluginResult(args, env),
            done = function (data) {
                trigger(result, "done", data);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };

        window.qnx.webplatform.getApplication().cards.calendar.composer.open(options, done, cancel, invokeCallback);
        result.noResult(true);
    },

    invokeEmailComposer: function (success, fail, args, env) {
        var options = JSON.parse(decodeURIComponent(args.options)),
            result = new PluginResult(args, env),
            done = function (data) {
                trigger(result, "done", data);
            },
            cancel = function (reason) {
                trigger(result, "cancel", reason);
            },
            invokeCallback = function (error) {
                trigger(result, "invoke", error);
            };

        window.qnx.webplatform.getApplication().cards.email.composer.open(options, done, cancel, invokeCallback);
        result.noResult(true);
    },

    invokeTargetPicker: function (success, fail, args, env) {
        var title = JSON.parse(decodeURIComponent(args.title)),
            pluginResult = new PluginResult(args, env),
            request = JSON.parse(decodeURIComponent(args.request)),
            invocation = window.qnx.webplatform.getApplication().invocation,
            onError,
            onSuccess;

        onError = function (error) {
            pluginResult.callbackOk({
                "status": "error",
                "result": error
            }, false);
        };

        onSuccess = function (result) {
            pluginResult.callbackOk({
                "status": "success",
                "result": result
            }, false);
        };

        // Pulled from the query code, we should probably keep a consistent API
        // allows the developers to define APPLICATION, VIEWER etc in an array
        if (request.target_type && Array.isArray(request.target_type)) {

            request.target_type = request.target_type.filter(function (element) {
                var result = false;
                switch (element)
                {
                case "APPLICATION":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_APPLICATION;
                    break;
                case "CARD":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_CARD;
                    break;
                case "VIEWER":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_VIEWER;
                    break;
                case "SERVICE":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_SERVICE;
                    break;

                default:
                    result = true;
                    break;
                }
                return result;
            });

            delete request.target_type;
        }

        if (request.hasOwnProperty('metadata')) {
            //Let's stringify it for them
            request.metadata = JSON.stringify(request.metadata);
        }

        overlayWebView.invocationlist.show(request, title, onSuccess, onError);
        pluginResult.noResult(true);
    }
};


});
define('plugin/cordova-plugin-bb-connection/index.js', function (require, exports, module) {
/*
* Copyright 2012 Research In Motion Limited.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

var _utils = require("../../lib/utils"),
    _deviceEvents = require("../../lib/events/deviceEvents"),
    _lastType,
    _listeners = {},
    _actionMap;

function mapConnectionType(type, technology) {
    switch (type) {
    case 'wired':
        return 'ethernet';
    case 'wifi':
        return 'wifi';
    case 'bluetooth_dun':
        return 'bluetooth_dun';
    case 'usb':
        return 'usb';
    case 'vpn':
        return 'vpn';
    case 'bb':
        return 'rim-bb';
    case 'unknown':
        return 'unknown';
    case 'none':
        return 'none';
    case 'cellular':
        switch (technology) {
        case 'edge':
        case 'gsm':
            return '2g';
        case 'evdo':
            return '3g';
        case 'umts':
            return '3g';
        case 'lte':
            return '4g';
        }
    }
    return 'unknown';
}

function currentConnectionType() {
    var connInfo = qnx.webplatform.device.activeConnection;
    if (connInfo === null) {
        connInfo = {
            type: 'none'
        };
    }
    return mapConnectionType(connInfo.type, connInfo.technology);
}

_actionMap = {
    connectionchange: {
        event: "connectionChange",
        trigger: function (pluginResult, args) {
            var currentType = currentConnectionType();
            if (_lastType && currentType !== _lastType) {
                pluginResult.callbackOk({oldType: _lastType, newType: currentType}, true);
            }
            _lastType = currentType;
        }
    }
};

module.exports = {

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            systemEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            //TODO: Change back to erroring out after reset is implemented
            //result.error("Underlying listener for " + eventName + " already running for webview " + env.webview.id);
            _deviceEvents.removeEventListener(systemEvent, _listeners[eventName][env.webview.id]);
        }

        _deviceEvents.addEventListener(systemEvent, listener);
        _listeners[eventName][env.webview.id] = listener;
        result.noResult(true);
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[eventName][env.webview.id],
            systemEvent = _actionMap[eventName].event;

        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            _deviceEvents.removeEventListener(systemEvent, listener);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    },

    type: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        try {
            result.ok(currentConnectionType(), false);
        } catch (e) {
            result.error(e, false);
        }
    }
};

});
define('plugin/cordova-plugin-bb-cover/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var _appEvents = require("./../../lib/events/applicationEvents"),
    _listeners = {},
    _actionMap = {
        entercover: {
            event: "windowCoverEnter",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        },
        exitcover: {
            event: "windowCoverExit",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        }
    };



module.exports = {

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            systemEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            //TODO: Change back to erroring out after reset is implemented
            //result.error("Underlying listener for " + eventName + " already running for webview " + env.webview.id);
            _appEvents.removeEventListener(systemEvent, _listeners[eventName][env.webview.id]);
        }

        _appEvents.addEventListener(systemEvent, listener);
        _listeners[eventName][env.webview.id] = listener;
        result.noResult(true);
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[eventName][env.webview.id],
            systemEvent = _actionMap[eventName].event;

        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            _appEvents.removeEventListener(systemEvent, listener);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    },

    resetCover: function (success, fail, args, env) {
        var app = window.qnx.webplatform.getApplication(),
            name = JSON.parse(decodeURIComponent(args.name)),
            reset = {};
        try {
            if (app.updateCovers) {
                reset[name] = { cover: "reset" };
                app.updateCovers(reset);
            } else {
                app.updateCover({ cover: "reset"});
            }
            success();
        } catch (e) {
            console.log(e);
            fail("Unable to reset cover");
        }
    },

    coverSizes: function (success, fail, args, env) {
        var app = window.qnx.webplatform.getApplication(),
            coverSizes;
        try {
            if (app.coverSizes) {
                coverSizes = (typeof app.coverSizes === "string") ? JSON.parse(app.coverSizes) : app.coverSizes;
            } else {
                coverSizes = { fullSize: (typeof app.coverSize === 'string') ? JSON.parse(app.coverSize) : app.coverSize };
            }
            success(coverSizes);
        } catch (e) {
            console.log(e);
            fail("Unable to get coverSize");
        }
    },

    updateCovers: function (success, fail, args, env) {
        var i,
            translatedCovers = {},
            app = window.qnx.webplatform.getApplication(),
            covers = JSON.parse(decodeURIComponent(args.covers));
        for (i = 0; i < covers.length; i++) {
            translatedCovers[covers[i].name] = {
                cover: {
                    type: covers[i].type
                },
                text: covers[i].text,
                transition: covers[i].transition,
                badges: covers[i].badges
            };
            if (covers[i].type === 'file') {
                translatedCovers[covers[i].name].cover.path = covers[i].path.replace(/file:\/\//, '');
                if (translatedCovers[covers[i].name].cover.path.indexOf('local:///') === 0) {
                    translatedCovers[covers[i].name].cover.path =                    
                        app.getEnv("HOME").replace("/data", "/app/native/") + 
                        translatedCovers[covers[i].name].cover.path.substring(9);
                }
            } else if (covers[i].type === 'snapshot') {
                translatedCovers[covers[i].name].cover.capture = covers[i].capture;
            }
        }
        try {
            if (app.updateCovers) {
                app.updateCovers(translatedCovers);
            } else {
                app.updateCover(translatedCovers.fullSize);
            }
            success();
        } catch (e) {
            console.log(e);
            fail("Unable to update cover");
        }
    }
};

});
define('plugin/cordova-plugin-bb-ctxmenu/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var LIB_FOLDER = "../../lib/",
    contextmenu,
    _overlayWebView,
    _utils = require(LIB_FOLDER + 'utils'),
    _listeners = {},
    _actionMap = {
        contextmenuhidden: {
            event: "contextmenu.hidden",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(undefined, true);
            }
        }
    };

function enabled(success, fail, args, env) {
    var result = new PluginResult(args, env),
        _enabled;
    if (typeof args.enabled !== 'undefined') {
        _enabled = JSON.parse(decodeURIComponent(args.enabled));
        if (typeof(_enabled) === 'boolean') {
            _overlayWebView.contextMenu.enabled = _enabled;
        }
        result.ok(true, false);
    } else {
        result.ok(_overlayWebView.contextMenu.enabled, false);
    }
}

function overrideItem(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.action = JSON.parse(decodeURIComponent(args.action));
    args.handler = function (actionId) {
        result.callbackOk(null, true);
    };
    if (_overlayWebView.contextMenu.overrideItem(args.action, args.handler)) {
        result.noResult(true);
    } else {
        result.error("Item could not be overriden", false);
    }
}

function clearOverride(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.actionId = JSON.parse(decodeURIComponent(args.actionId));
    result.ok(_overlayWebView.contextMenu.clearOverride(args.actionId), false);
}

function addItem(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.contexts = JSON.parse(decodeURIComponent(args.contexts));
    args.action = JSON.parse(decodeURIComponent(args.action));
    args.handler = function (actionId, elementId) {
        result.callbackOk(elementId, true);
    };
    _overlayWebView.contextMenu.addItem(function (data) {
        result.noResult(true);
    }, function (e) {
        result.error(e, false);
    }, args, env);
}

function removeItem(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.contexts = JSON.parse(decodeURIComponent(args.contexts));
    args.actionId = JSON.parse(decodeURIComponent(args.actionId));
    _overlayWebView.contextMenu.removeItem(function (data) {
        result.ok(data, false);
    }, function (e) {
        result.error(e, false);
    }, args, env);
}

function defineCustomContext(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.context = JSON.parse(decodeURIComponent(args.context));
    args.options = JSON.parse(decodeURIComponent(args.options));
    _overlayWebView.contextMenu.defineCustomContext(args.context, args.options);
    result.ok(null, false);
}

function disablePlatformItem(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.context = JSON.parse(decodeURIComponent(args.context));
    args.actionId = JSON.parse(decodeURIComponent(args.actionId));
    result.ok(_overlayWebView.contextMenu.disablePlatformItem(args.context, args.actionId), false);
}

function enablePlatformItem(success, fail, args, env) {
    var result = new PluginResult(args, env);
    args.context = JSON.parse(decodeURIComponent(args.context));
    args.actionId = JSON.parse(decodeURIComponent(args.actionId));
    result.ok(_overlayWebView.contextMenu.enablePlatformItem(args.context, args.actionId), false);
}

function listDisabledPlatformItems(success, fail, args, env) {
    var result = new PluginResult(args, env);
    result.ok(_overlayWebView.contextMenu.listDisabledPlatformItems(), false);
}

function startEvent(success, fail, args, env) {
    var result = new PluginResult(args, env),
        eventName = JSON.parse(decodeURIComponent(args.eventName)),
        context = _actionMap[eventName].context,
        systemEvent = _actionMap[eventName].event,
        listener = _actionMap[eventName].trigger.bind(null, result);

    if (!systemEvent) {
        return;
    }

    if (!_listeners[eventName]) {
        _listeners[eventName] = {};
    }

    if (_listeners[eventName][env.webview.id]) {
        //TODO: Change back to erroring out after reset is implemented
        //result.error("Underlying listener for " + eventName + " already running for webview " + env.webview.id);
        qnx.webplatform.core.events.un(systemEvent, _listeners[eventName][env.webview.id]);
    }

    qnx.webplatform.core.events.on(systemEvent, listener);
    _listeners[eventName][env.webview.id] = listener;

    result.noResult(true);
}

function stopEvent(success, fail, args, env) {
    var result = new PluginResult(args, env),
        eventName = JSON.parse(decodeURIComponent(args.eventName)),
        listener = _listeners[eventName][env.webview.id],
        context = _actionMap[eventName].context,
        systemEvent = _actionMap[eventName].event;

    if (!systemEvent) {
        return;
    }

    if (!listener) {
        result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
    } else {
        qnx.webplatform.core.events.un(systemEvent, listener);

        delete _listeners[eventName][env.webview.id];
        result.noResult(false);
    }
}

contextmenu = {
    enabled: enabled,
    addItem: addItem,
    removeItem: removeItem,
    overrideItem: overrideItem,
    clearOverride: clearOverride,
    disablePlatformItem: disablePlatformItem,
    enablePlatformItem: enablePlatformItem,
    listDisabledPlatformItems: listDisabledPlatformItems,
    defineCustomContext: defineCustomContext,
    startEvent: startEvent,
    stopEvent: stopEvent
};

qnx.webplatform.getController().addEventListener('ui.init', function () {
    _overlayWebView = require(LIB_FOLDER + 'overlayWebView');
});

module.exports = contextmenu;

});
define('plugin/cordova-plugin-bb-dialog/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function validateIdMessageSettings(args) {

    if (args.settings) {
        args.settings = JSON.parse(decodeURIComponent(args.settings));
    }
    else {
        args.settings = {};
    }

    if (args.message) {
        args.message = decodeURIComponent(args.message);
        args.message = args.message = args.message.replace(/^"|"$/g, "").replace(/\\"/g, '"').replace(/\\\\/g, '\\');
    } else {
        return 1;
    }

    return 0;
}

var dialog,
    overlayWebView = require('../../lib/overlayWebView'),
    _webview = require("../../lib/webview");

module.exports = {
    customAskAsync: function (success, fail, args, env) {
        var pluginResult = new PluginResult(args, env),
            messageObj;

        if (validateIdMessageSettings(args) === 1) {
            pluginResult.error("message is undefined", false);
            return;
        }

        if (args.buttons) {
            args.buttons = JSON.parse(decodeURIComponent(args.buttons));
        } else {
            pluginResult.error("buttons is undefined", false);
            return;
        }

        if (!Array.isArray(args.buttons)) {
            pluginResult.error("buttons is not an array", false);
            return;
        }

        messageObj = {
            title : args.settings.title,
            htmlmessage :  args.message,
            dialogType : "CustomAsk",
            optionalButtons : args.buttons
        };
        overlayWebView.showDialog(messageObj, function (result) {
            pluginResult.callbackOk(result, false);
        });
        pluginResult.noResult(true);
    },

    standardAskAsync: function (success, fail, args, env) {
        var pluginResult = new PluginResult(args, env),
            buttons,
            returnValue = {},
            messageObj = {};

        if (validateIdMessageSettings(args) === 1) {
            pluginResult.error("message is undefined", false);
            return;
        }

        if (args.type) {
            args.type = JSON.parse(decodeURIComponent(args.type));
        } else {
            pluginResult.error("type is undefined", false);
            return;
        }

        if (args.type < 0 || args.type > 5) {
            pluginResult.error("invalid dialog type: " + args.type, false);
            return;
        }

        buttons = {
            0: "JavaScriptAlert",                       // D_OK
            1: ["Save", "Discard"],                     // D_SAVE
            2: ["Delete", "Cancel"],                    // D_DELETE
            3: ["Yes", "No"],                           // D_YES_NO
            4: "JavaScriptConfirm",                     // D_OK_CANCEL
            5: "JavaScriptPrompt"                       // D_Prompt
        };

        if (!Array.isArray(buttons[args.type])) {
            messageObj = {
                title : args.settings.title,
                htmlmessage :  args.message,
                dialogType : buttons[args.type]
            };
            overlayWebView.showDialog(messageObj, function (result) {
                if (args.type === 0) {//Ok dialog
                    returnValue["return"] = "Ok";
                } else if (args.type === 4) {//Confirm Dialog
                    if (result.ok) {
                        returnValue["return"] = "Ok";
                    } else {
                        returnValue["return"] = "Cancel";
                    }
                } else {
                    if (result.ok) {
                        returnValue["return"] = "Ok";
                    } else {
                        returnValue["return"] = "Cancel";
                    }
                    returnValue.promptText = (result.oktext) ? decodeURIComponent(result.oktext) : null;
                }
                pluginResult.callbackOk(returnValue, false);
            });
        } else {
            messageObj = {
                title : args.settings.title,
                htmlmessage :  args.message,
                dialogType : "JavaScriptConfirm",
                oklabel : buttons[args.type][0],
                cancellabel : buttons[args.type][1]
            };
            overlayWebView.showDialog(messageObj, function (result) {
                if (result.ok) {
                    returnValue["return"] = buttons[args.type][0];
                } else {
                    returnValue["return"] = buttons[args.type][1];
                }
                pluginResult.callbackOk(returnValue, false);
            });
        }
        pluginResult.noResult(true);
    }
};

});
define('plugin/cordova-plugin-bb-identity/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var ERRON_MSG_PPS = "Cannot retrieve data from system";

module.exports = {
    getFields: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            fields = { };

        //IMSI is likely to fail since few devs will have access
        //TO compensate we will eat the error
        try {
            fields.IMSI = window.qnx.webplatform.device.IMSI;
        } catch (e) {
            //DO NOTHING
        }

        try {
            fields.uuid = window.qnx.webplatform.device.devicePin;
            fields.IMEI = window.qnx.webplatform.device.IMEI;

            if (fields.uuid || fields.IMSI || fields.IMEI) {
                result.ok(fields, false);
            } else {
                result.error(ERRON_MSG_PPS);
            }
        } catch (err) {
            result.error(err.message);
        }
    }
};

});
define('plugin/cordova-plugin-bb-invoke/index.js', function (require, exports, module) {
/*
 * Copyright 2011-2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _returnCallback,
    _actionMap = {
        "onchildcardstartpeek": {
            context: require("./invocationEvents"),
            event: "onchildcardstartpeek",
            trigger: function (pluginResult, peekType) {
                pluginResult.callbackOk(peekType, true);
            }
        },
        "onchildcardendpeek": {
            context: require("./invocationEvents"),
            event: "onchildcardendpeek",
            trigger: function (pluginResult) {
                pluginResult.callbackOk({}, true);
            }
        },
        "onchildcardclosed": {
            context: require("./invocationEvents"),
            event: "onchildcardclosed",
            trigger: function (pluginResult, info) {
                pluginResult.callbackOk(info, true);
            }
        },
        "invocation.interrupted": {
            context: require("./invocationEvents"),
            event: "invocation.interrupted",
            trigger: function (pluginResult, request, returnCallback) {
                _returnCallback = returnCallback;
                // Tell the client that we want to interrupt
                pluginResult.callbackOk(request, true);
            }
        }
    },
    _interruption,
    _listeners = {};

module.exports = {
    invoke: function (success, fail, args, env) {
        // if request contains invalid args, the invocation framework will provide error in callback
        // no validation done here
        var result = new PluginResult(args, env),
            request = JSON.parse(decodeURIComponent(args.request)),
            callback = function (error) {
                if (error) {
                    result.callbackError(error, false);
                } else {
                    result.callbackOk(undefined, false);
                }
            };

        window.qnx.webplatform.getApplication().invocation.invoke(request, callback);
        result.noResult(true);
    },

    query: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            request = JSON.parse(decodeURIComponent(args.request)),
            callback = function (error, response) {
                if (error) {
                    result.callbackError(error, false);
                } else {
                    result.callbackOk(response, false);
                }
            },
            invocation = window.qnx.webplatform.getApplication().invocation;

        if (request.target_type && Array.isArray(request.target_type)) {

            request.target_type = request.target_type.filter(function (element) {
                var result = false;
                switch (element)
                {
                case "APPLICATION":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_APPLICATION;
                    break;
                case "CARD":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_CARD;
                    break;
                case "VIEWER":
                    request.target_type_mask |= invocation.TARGET_TYPE_MASK_VIEWER;
                    break;
                default:
                    result = true;
                    break;
                }
                return result;
            });

            if (request.target_type.length === 0) {
                delete request.target_type;
            }
        }

        invocation.queryTargets(request, callback);
        result.noResult(true);
    },

    closeChildCard: function (success, fail, args, env) {
        var result = new PluginResult(args, env);

        try {
            window.qnx.webplatform.getApplication().invocation.closeChildCard();
            result.ok();
        } catch (e) {
            result.error(e);
        }
    },

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            context = _actionMap[eventName].context,
            invokeEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            result.error("Underlying listener for " + eventName + " already already running for webview " + env.webview.id);
        } else {
            context.addEventListener(invokeEvent, listener);
            _listeners[eventName][env.webview.id] = listener;
            result.noResult(true);
        }
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[eventName][env.webview.id],
            context = _actionMap[eventName].context,
            invokeEvent = _actionMap[eventName].event;

        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            context.removeEventListener(invokeEvent, listener);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    },

    returnInterruption : function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            request;

        try {
            request = JSON.parse(decodeURIComponent(args.request));
            if (typeof _returnCallback === 'function') {
                _returnCallback(request);
            }

            result.ok();
        } catch (e) {
            result.error(e);
        }
    }
};


});
define('plugin/cordova-plugin-bb-invoke/invocationEvents.js', function (require, exports, module) {
/*
 * Copyright 2010-2011 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _application = window.qnx.webplatform.getApplication();

module.exports = {
    addEventListener: function (event, trigger) {
        switch (event) {
        case "onchildcardstartpeek":
            _application.invocation.addEventListener("cardPeekStarted", trigger);
            break;
        case "onchildcardendpeek":
            _application.invocation.addEventListener("cardPeekEnded", trigger);
            break;
        case "onchildcardclosed":
            _application.invocation.addEventListener("childCardClosed", trigger);
            break;
        case "invocation.interrupted":
            _application.invocation.interrupter = trigger;
            break;
        default:
            console.log("Ignore registration for unknown event: " + event);
            break;
        }
    },
    removeEventListener: function (event, trigger) {
        switch (event) {
        case "onchildcardstartpeek":
            _application.invocation.removeEventListener("cardPeekStarted", trigger);
            break;
        case "onchildcardendpeek":
            _application.invocation.removeEventListener("cardPeekEnded", trigger);
            break;
        case "onchildcardclosed":
            _application.invocation.removeEventListener("childCardClosed", trigger);
            break;
        case "invocation.interrupted":
            _application.invocation.interrupter = undefined;
            break;
        default:
            console.log("Ignore un-registration for unknown event: " + event);
            break;
        }
    }
};

});
define('plugin/cordova-plugin-bb-invoked/index.js', function (require, exports, module) {
/*
 * Copyright 2011-2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _actionMap = {
        invoked: {
            context: require("./invocationEvents"),
            event: "invoked",
            trigger: function (pluginResult, request) {
                var onInvokedInfo = JSON.parse(request);

                // Workaround for double invoke bug
                if (onInvokedInfo.uri !== "invoke://localhost") {
                    pluginResult.callbackOk(onInvokedInfo, true);
                }
            }
        },
        oncardresize: {
            context: require("./invocationEvents"),
            event: "oncardresize",
            trigger: function (pluginResult, info) {
                pluginResult.callbackOk(info, true);
            }
        },
        oncardclosed: {
            context: require("./invocationEvents"),
            event: "oncardclosed",
            trigger: function (pluginResult, info) {
                pluginResult.callbackOk(info, true);
            }
        }
    },
    _listeners = {};

module.exports = {
    cardResizeDone: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        try {
            window.qnx.webplatform.getApplication().invocation.cardResized();
            result.noResult(true);
        } catch (e) {
            result.error(e, false);
        }
    },

    cardStartPeek: function (success, fail, args, env) {
        var cardPeek,
            result = new PluginResult(args, env);

        try {
            cardPeek = decodeURIComponent(args.peekType);
            window.qnx.webplatform.getApplication().invocation.cardPeek(cardPeek);
            result.noResult(true);
        } catch (e) {
            result.error(e, false);
        }
    },

    cardRequestClosure: function (success, fail, args, env) {
        var request,
            result = new PluginResult(args, env);

        try {
            request = JSON.parse(decodeURIComponent(args.request));
            window.qnx.webplatform.getApplication().invocation.sendCardDone(request);
            result.noResult(true);
        } catch (e) {
            result.error(e, false);
        }
    },

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            context = _actionMap[eventName].context,
            invokedEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            result.error("Underlying listener for " + eventName + " already already running for webview " + env.webview.id);
        } else {
            context.addEventListener(invokedEvent, listener);
            _listeners[eventName][env.webview.id] = listener;
            result.noResult(true);
        }
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[eventName][env.webview.id],
            context = _actionMap[eventName].context,
            invokedEvent = _actionMap[eventName].event;

        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            context.removeEventListener(invokedEvent, listener);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    }
};


});
define('plugin/cordova-plugin-bb-invoked/invocationEvents.js', function (require, exports, module) {
/*
 * Copyright 2010-2011 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _application = window.qnx.webplatform.getApplication(),
    _startupMode = _application.invocation.getStartupMode();

module.exports = {
    addEventListener: function (event, trigger) {
        switch (event) {
        case "invoked":
            if (_startupMode !== _application.invocation.LAUNCH) {
                trigger(_application.invocation.getRequest());
                _startupMode = _application.invocation.LAUNCH;
            }
            _application.invocation.addEventListener("Invoked", trigger);
            break;
        case "oncardresize":
            _application.invocation.addEventListener("cardResize", trigger);
            break;
        case "oncardclosed":
            _application.invocation.addEventListener("cardClosed", trigger);
            break;
        default:
            console.log("Ignore registration for unknown event: " + event);
            break;
        }
    },
    removeEventListener: function (event, trigger) {
        switch (event) {
        case "invoked":
            _application.invocation.removeEventListener("Invoked", trigger);
            break;
        case "oncardresize":
            _application.invocation.removeEventListener("cardResize", trigger);
            break;
        case "oncardclosed":
            _application.invocation.removeEventListener("cardClosed", trigger);
            break;
        default:
            console.log("Ignore un-registration for unknown event: " + event);
            break;
        }
    }
};


});
define('plugin/cordova-plugin-bb-io/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _util = require("./../../lib/utils"),
    _webview;

function getHomeDir() {
    var homeDir = window.qnx.webplatform.getApplication().getEnv("HOME");

    // HOME environment variable starts with two slashes for some reason, get rid of the extra slash
    if (homeDir.match("^//")) {
        return homeDir.substring(1);
    } else {
        return homeDir;
    }
}

module.exports = {
    sandbox: function (success, fail, args, env) {
        var value,
            result = new PluginResult(args, env);

        _webview = _util.requireWebview();

        if (args && args.sandbox) {
            value = JSON.parse(decodeURIComponent(args.sandbox));
            _webview.setSandbox(JSON.parse(value));
            result.ok(null, false);
        } else {
            value = _webview.getSandbox();
            result.ok(value === "1", false); // always return "0" or "1" even after explicitly setting value to true or false
        }
    },

    home: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        result.ok(getHomeDir(), false);
    },

    dataLockOperationalHome: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        result.ok(getHomeDir() + "/../_operational_data/", false);
    },

    dataLockStartupHome: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        result.ok(getHomeDir() + "/../_startup_data/", false);
    },

    sharedFolder: function (success, fail, args, env) {
        var home = getHomeDir(),
            result = new PluginResult(args, env);
        result.ok(home + "/../shared", false);
    },

    SDCard: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        result.ok("/accounts/1000/removable/sdcard", false);
    }
};

});
define('plugin/cordova-plugin-bb-notification/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var _config = require("./../../lib/config"),
    _notification = qnx.webplatform.notification;

module.exports = {
    notify: function (success, fail, sourceArgs, env) {
        var result = new PluginResult(sourceArgs, env),
            args = {},
            key;

        for (key in sourceArgs) {
            if (sourceArgs.hasOwnProperty(key)) {
                args[key] = JSON.parse(decodeURIComponent(sourceArgs[key]));
            }
        }

        // Set the target if not provided in the options but appears in the config.xml
        // Set targetAction to default when there is target but no action.
        if (!args.options.target || args.options.target.length === 0) {
            for (key in _config['invoke-target']) {
                if (_config['invoke-target'].hasOwnProperty(key)) {
                    if (_config['invoke-target'][key].type.toLowerCase() === "application") {
                        args.options.target = _config['invoke-target'][key]["@"].id;
                        break;
                    }
                }
            }
        }

        if ((args.options.target && args.options.target.length > 0) &&
            (!args.options.targetAction || args.options.targetAction.length === 0)) {
            args.options.targetAction = "bb.action.OPEN";
        }

        // Calling delete with tag before writing new notification
        // This ensures new notification will override the old one.
        _notification.remove(args.options.tag);
        _notification.notify(args, function (e) {
            if (e) {
                result.callbackError(e);
            } else {
                result.callbackOk();
            }
        });

        result.noResult(true);
    },

    remove: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            tag;

        if (!args || !args.tag) {
            result.error("No tag provided for notification removal");
        } else {
            tag = JSON.parse(decodeURIComponent(args.tag));
            _notification.remove(tag);
            result.ok();
        }
    }
};

});
define('plugin/cordova-plugin-bb-payment/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var paymentJNext,
    _util = require("../../lib/utils");

module.exports = {
    purchase: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
        purchase_arguments_t = {
                "digitalGoodID" : JSON.parse(decodeURIComponent(args.digitalGoodID)),
                "digitalGoodSKU" : JSON.parse(decodeURIComponent(args.digitalGoodSKU)),
                "digitalGoodName" : JSON.parse(decodeURIComponent(args.digitalGoodName)),
                "metaData" : JSON.parse(decodeURIComponent(args.metaData)),
                "purchaseAppName" : JSON.parse(decodeURIComponent(args.purchaseAppName)),
                "purchaseAppIcon" : JSON.parse(decodeURIComponent(args.purchaseAppIcon)),
                "extraParameters" : JSON.parse(decodeURIComponent(args.extraParameters)),
                "windowGroup" : window.qnx.webplatform.getController().windowGroup
            };

        try {
            result.ok(paymentJNext.getInstance().purchase(purchase_arguments_t), false);
        } catch (err) {
            result.error(-1, err.message);
        }
    },
    cancelSubscription: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
        cancelSubscription_arguments_t = {
                "transactionID" : JSON.parse(decodeURIComponent(args.transactionID)),
                "windowGroup" : window.qnx.webplatform.getController().windowGroup
            };

        try {
            result.ok(paymentJNext.getInstance().cancelSubscription(cancelSubscription_arguments_t), false);
        } catch (err) {
            result.error(-1, err.message);
        }

    },
    getPrice: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
        getPrice_arguments_t = {
                "id" : JSON.parse(decodeURIComponent(args.id)),
                "sku" : JSON.parse(decodeURIComponent(args.sku)),
                "windowGroup" : window.qnx.webplatform.getController().windowGroup
            };

        try {
            result.ok(paymentJNext.getInstance().getPrice(getPrice_arguments_t), false);
        } catch (err) {
            result.error(-1, err.message);
        }

    },
    getExistingPurchases: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
        getExistingPurchases_arguments_t = {
                "refresh" : JSON.parse(decodeURIComponent(args.refresh)),
                "windowGroup" : window.qnx.webplatform.getController().windowGroup
            };

        try {
            result.ok(paymentJNext.getInstance().getExistingPurchases(getExistingPurchases_arguments_t), false);
        } catch (err) {
            result.error(-1, err.message);
        }
    },
    checkExisting: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
        check_existing_args = {
                "id" : JSON.parse(decodeURIComponent(args.id)),
                "sku" : JSON.parse(decodeURIComponent(args.sku)),
                "windowGroup" : window.qnx.webplatform.getController().windowGroup
            };

        try {
            result.ok(paymentJNext.getInstance().checkExisting(check_existing_args), false);
        } catch (err) {
            result.error(-1, err.message);
        }
    },
    developmentMode: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            value, 
            developmentMode_args;
        if (args && args.developmentMode) {
            value = JSON.parse(decodeURIComponent(args.developmentMode));
            developmentMode_args = {
                "developmentMode" : value
            };
            paymentJNext.getInstance().setDevelopmentMode(developmentMode_args);
            result.ok(null, false);
        } else {
            value = paymentJNext.getInstance().getDevelopmentMode();
            result.ok(value === "true", false);
        }
    }
};

///////////////////////////////////////////////////////////////////
//JavaScript wrapper for JNEXT plugin
///////////////////////////////////////////////////////////////////

JNEXT.Payment = function ()
{
    var self = this,
        hasInstance = false;

    self.getErrorObject = function (state, errorID, errorText) {
        var result = {}, successState = {}, errorObject = {};
        successState.state = state;
        errorObject.errorID = errorID;
        errorObject.errorText = errorText;
        result.successState = {};
        result.successState = successState;
        result.errorObject = {};
        result.errorObject = errorObject;
        
        return result;
    };

    self.setDevelopmentMode = function (args) {
        JNEXT.invoke(self.m_id, "setDevelopmentMode " + JSON.stringify(args));
    };

    self.getDevelopmentMode = function () {
        var val = JNEXT.invoke(self.m_id, "getDevelopmentMode");
        return val;
    };

    self.purchase = function (args) {
        var val = JNEXT.invoke(self.m_id, "purchase " + JSON.stringify(args)),
            result;

        if (val === "-1") {
            result = self.getErrorObject("BPS_FAILURE", "-1", "Purchase Failed. Payment Service Error.");
        } else {
            result = JSON.parse(val);
        }

        return result;
    };

    self.getExistingPurchases = function (args) {
        var val = JNEXT.invoke(self.m_id, "getExistingPurchases " + JSON.stringify(args)),
            result;

        if (val === "-1") {
            result = self.getErrorObject("BPS_FAILURE", "-1", "getExistingPurchases Failed. Payment Service Error.");
        } else {
            result = JSON.parse(val);
        }

        return result;
    };

    self.cancelSubscription = function (args) {
        var val = JNEXT.invoke(self.m_id, "cancelSubscription " + JSON.stringify(args)),
            result;

        if (val === "-1") {
            result = self.getErrorObject("BPS_FAILURE", "-1", "cancelSubscription Failed. Payment Service Error.");
        } else {
            result = JSON.parse(val);
        }

        return result;
    };
    
    self.getPrice = function (args) {
        var val = JNEXT.invoke(self.m_id, "getPrice " + JSON.stringify(args)),
            result;
   
        if (val === "-1") {
            result = self.getErrorObject("BPS_FAILURE", "-1", "getPrice Failed. Payment Service Error.");
        } else {
            result = JSON.parse(val);
        }

        return result;
    };
    
    self.checkExisting = function (args) {
        var val = JNEXT.invoke(self.m_id, "checkExisting " + JSON.stringify(args)),
            result;

        if (val === "-1") {
            result = self.getErrorObject("BPS_FAILURE", "-1", "checkExisting Failed. Payment Service Error.");
        } else {
            result = JSON.parse(val);
        }

        return result;
    };    

    self.getId = function () {
        return self.m_id;
    };

    self.init = function () {
        if (!JNEXT.require("libpaymentjnext")) {
            return false;
        }

        self.m_id = JNEXT.createObject("libpaymentjnext.Payment");

        if (!self.m_id || self.m_id === "") {
            return false;
        }

        JNEXT.registerEvents(self);
    };

    self.m_id = "";

    self.getInstance = function () {
        if (!hasInstance) {
            hasInstance = true;
            self.init();
        }
        return self;
    };
};

paymentJNext = new JNEXT.Payment();

});
define('plugin/cordova-plugin-bb-push/index.js', function (require, exports, module) {
/*
* Copyright 2012 Research In Motion Limited.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
var _push,
    _results = {};

module.exports = {
    startService: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            pushOptions = { "invokeTargetId" : JSON.parse(decodeURIComponent(args.invokeTargetId)),
                            "appId" : JSON.parse(decodeURIComponent(args.appId)),
                            "ppgUrl" : JSON.parse(decodeURIComponent(args.ppgUrl)) };

        _results["push.create.callback"] = result;
        _push.getInstance().startService(pushOptions);
        result.noResult(true);
    },

    createChannel: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        _results["push.createChannel.callback"] = result;
        _push.getInstance().createChannel(args);
        result.noResult(true);
    },

    destroyChannel: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        _results["push.destroyChannel.callback"] = result;
        _push.getInstance().destroyChannel(args);
        result.noResult(true);
    },

    extractPushPayload: function (success, fail, args, env) {
        var invokeData = { "data" : JSON.parse(decodeURIComponent(args.data)) },
            result = new PluginResult(args, env);
        result.ok(_push.getInstance().extractPushPayload(invokeData));
    },

    launchApplicationOnPush: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        _results["push.launchApplicationOnPush.callback"] = result;
        _push.getInstance().launchApplicationOnPush(JSON.parse(decodeURIComponent(args.shouldLaunch)));
        result.noResult(true);
    },

    acknowledge: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            acknowledgeData = { "id" : JSON.parse(decodeURIComponent(args.id)),
                                "shouldAcceptPush" : JSON.parse(decodeURIComponent(args.shouldAcceptPush)) };

        _push.getInstance().acknowledge(acknowledgeData);
        result.ok();
    },

    registerCallback: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            id = JSON.parse(decodeURIComponent(args.id));

        _results[id] = result;
        result.noResult(true);
    }
};

///////////////////////////////////////////////////////////////////
// JavaScript wrapper for JNEXT plugin
///////////////////////////////////////////////////////////////////

JNEXT.Push = function () {
    var self = this,
        hasInstance = false;

    self.startService = function (args) {
        JNEXT.invoke(self.m_id, "startService " + JSON.stringify(args));
    };

    self.createChannel = function (args) {
        JNEXT.invoke(self.m_id, "createChannel");
    };

    self.destroyChannel = function (args) {
        JNEXT.invoke(self.m_id, "destroyChannel");
    };

    self.extractPushPayload = function (args) {
        var payload = JNEXT.invoke(self.m_id, "extractPushPayload " + JSON.stringify(args));
        return JSON.parse(payload.substring(payload.indexOf("{"), payload.lastIndexOf("}") + 1));
    };

    self.launchApplicationOnPush = function (args) {
        var shouldLaunch = args;

        if (shouldLaunch) {
            JNEXT.invoke(self.m_id, "registerToLaunch");
        } else {
            JNEXT.invoke(self.m_id, "unregisterFromLaunch");
        }
    };

    self.acknowledge = function (args) {
        JNEXT.invoke(self.m_id, "acknowledge " + JSON.stringify(args));
    };

    self.getId = function () {
        return self.m_id;
    };

    self.init = function () {
        if (!JNEXT.require("libpushjnext")) {
            return false;
        }

        self.m_id = JNEXT.createObject("libpushjnext.Push");

        if (self.m_id === "") {
            return false;
        }

        JNEXT.registerEvents(self);
    };

    self.onEvent = function (strData) {
        var arData = strData.split(" "),
            strEventId = arData[0],
            args = arData[1],
            info = {};

        // Trigger the event handler of specific Push events
        if (strEventId === "push.create.callback") {
            _results[strEventId].callbackOk(JSON.parse(args), false);

        } else if (strEventId === "push.create.simChangeCallback") {
            _results[strEventId].callbackOk(null, false);

        } else if (strEventId === "push.create.pushTransportReadyCallback") {
            _results[strEventId].callbackOk(JSON.parse(args), true);
        
        } else if (strEventId === "push.createChannel.callback") {
            info.result = JSON.parse(arData[1]);
            info.token = arData[2];
            _results[strEventId].callbackOk(info, false);

        } else if (strEventId === "push.destroyChannel.callback") {
            _results[strEventId].callbackOk(JSON.parse(args), false);

        } else if (strEventId === "push.launchApplicationOnPush.callback") {
            _results[strEventId].callbackOk(JSON.parse(args), false);

        }
    };

    self.m_id = "";

    self.getInstance = function () {
        if (!hasInstance) {
            hasInstance = true;
            self.init();
        }
        return self;
    };
};

_push = new JNEXT.Push();

});
define('plugin/cordova-plugin-bb-system/index.js', function (require, exports, module) {
/*
 * Copyright 2011-2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var Whitelist = require("../../lib/policy/whitelist").Whitelist,
    _whitelist = new Whitelist(),
    _utils = require("../../lib/utils"),
    _applicationEvents = require("../../lib/events/applicationEvents"),
    _deviceEvents = require("../../lib/events/deviceEvents"),
    _actionMap = {
        batterystatus: {
            context: _deviceEvents,
            event: "battery.statusChange",
            triggerEvent: "batterystatus",
            trigger: function (pluginResult, data) {
                pluginResult.callbackOk(data, true);
            }
        },
        batterylow: {
            context: _deviceEvents,
            event: "battery.chargeLow",
            triggerEvent: "batterylow",
            trigger: function (pluginResult, data) {
                pluginResult.callbackOk(data, true);
            }
        },
        batterycritical: {
            context: _deviceEvents,
            event: "battery.chargeCritical",
            triggerEvent: "batterycritical",
            trigger: function (pluginResult, data) {
                pluginResult.callbackOk(data, true);
            }
        },
        datalockstatechanged: {
            context: _applicationEvents,
            event: "dataLockStateChange",
            triggerEvent: "datalockstatechanged",
            trigger: function (pluginResult, state, lockTime) {
                pluginResult.callbackOk({'state': state, 'lockTime': lockTime}, true);
            }
        },
        languagechanged: {
            context: _applicationEvents,
            event: "systemLanguageChange",
            triggerEvent: "languagechanged",
            trigger: function (pluginResult, language) {
                pluginResult.callbackOk(language, true);
            }
        },
        regionchanged: {
            context: _applicationEvents,
            event: "systemRegionChange",
            triggerEvent: "regionchanged",
            trigger: function (pluginResult, region) {
                pluginResult.callbackOk(region, true);
            }
        },
        fontchanged: {
            context: _applicationEvents,
            event: "fontchanged",
            triggerEvent: "fontchanged",
            trigger: function (pluginResult, fontFamily, fontSize) {
                pluginResult.callbackOk({'fontFamily': fontFamily, 'fontSize': fontSize}, true);
            }
        },
        perimeterlocked: {
            context: _applicationEvents,
            event: "windowLock",
            triggerEvent: "perimeterlocked",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(null, true);
            }
        },
        perimeterunlocked: {
            context: _applicationEvents,
            event: "windowUnlock",
            triggerEvent: "perimeterunlocked",
            trigger: function (pluginResult) {
                pluginResult.callbackOk(null, true);
            }
        }
    },
    _listeners = {};

module.exports = {

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            context = _actionMap[eventName].context,
            systemEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            //TODO: Change back to erroring out after reset is implemented
            //result.error("Underlying listener for " + eventName + " already running for webview " + env.webview.id);
            context.removeEventListener(systemEvent, _listeners[eventName][env.webview.id]);
        }

        context.addEventListener(systemEvent, listener);
        _listeners[eventName][env.webview.id] = listener;
        result.noResult(true);
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[eventName][env.webview.id],
            context = _actionMap[eventName].context,
            systemEvent = _actionMap[eventName].event;

        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            context.removeEventListener(systemEvent, listener);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    },

    getFontInfo: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            fontFamily,
            fontSize;

        try {
            fontFamily = window.qnx.webplatform.getApplication().getSystemFontFamily();
            fontSize = window.qnx.webplatform.getApplication().getSystemFontSize();

            result.ok({'fontFamily': fontFamily, 'fontSize': fontSize}, false);
        } catch (e) {
            result.error(e, false);
        }
    },

    getDeviceProperties: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            returnObj;
        try {
            returnObj = {
                "hardwareId" : window.qnx.webplatform.device.hardwareId,
                "softwareVersion" : window.qnx.webplatform.device.scmBundle,
                "name" : window.qnx.webplatform.device.deviceName
            };
            result.ok(returnObj, false);
        } catch (err) {
            result.error(err.message, false);
        }
    },

    region: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            region;
        try {
            region = window.qnx.webplatform.getApplication().systemRegion;
            result.ok(region, false);
        } catch (e) {
            result.error(e.message, false);
        }
    },

    getCurrentTimezone: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        try {
            result.ok(window.qnx.webplatform.device.timezone, false);
        } catch (err) {
            result.error(err.message, false);
        }
    },

    getTimezones: function (success, fail, args, env) {
        var result = new PluginResult(args, env);
        try {
            window.qnx.webplatform.device.getTimezones(function (zones) {
                result.ok(zones, false);
            });
        } catch (err) {
            result.error(err.message, false);
        }
    },

    setWallpaper: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            path;
        try {
            path = _utils.translatePath(JSON.parse(decodeURIComponent(args.wallpaper)));
            // Removing file:// form the path because newWallpaper can't handle it.
            path = path.replace(/file:\/\//, '');
            window.qnx.webplatform.getApplication().newWallpaper(path);
            result.ok(null, false);
        } catch (err) {
            result.error(err.message, false);
        }
    },

    deviceLockedStatus: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            callback;

        try {
            callback = function (state) {
                result.ok(state, false);
            };
            window.qnx.webplatform.getApplication().isDeviceLocked(callback);
        } catch (err) {
            result.error(err.message, false);
        }
    },

    dataLockState: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            func,
            callback;

        try {
            callback = function (state) {
                result.ok(state, false);
            };
            func = window.qnx.webplatform.getApplication().getDataLockState;
            if (!func) {
                /* If this is used with an older BB10 version that does not support data lock,
                 * hardcode the response
                 */
                callback("notLocked");
            }
            func(callback);
        } catch (err) {
            result.error(err.message, false);
        }
    },

    dataLockTime: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            func,
            callback;

        try {
            callback = function (lockTime) {
                result.ok(lockTime, false);
            };
            func = window.qnx.webplatform.getApplication().getDataLockTime;
            if (!func) {
                /* If this is used with an older BB10 version that does not support data lock,
                 * hardcode the response
                 */
                callback(0);
            }
            func(callback);
        } catch (err) {
            result.error(err.message, false);
        }
    }
};

});
define('plugin/cordova-plugin-bbm/BBMEvents.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var bbm = require("./BBMJNEXT").bbm;

module.exports = {
    addEventListener: function (event, trigger) {
        if (event === "onaccesschanged") {
            bbm.getInstance().startEvents(trigger);
        } else if (event === "onupdate") {
            bbm.getInstance().startContactEvents(trigger);
        } else {
            console.log("Ignore registration for unknown event: " + event);
        }
    },
    removeEventListener: function (event) {
        if (event === "onaccesschanged") {
            bbm.getInstance().stopEvents();
        } else if (event === "onupdate") {
            bbm.getInstance().stopContactEvents();
        } else {
            console.log("Ignore un-registration for unknown event: " + event);
        }
    }
};


});
define('plugin/cordova-plugin-bbm/BBMJNEXT.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var bbm,
    accesschangedCallback = null,
    updateCallback = null;

///////////////////////////////////////////////////////////////////
// JavaScript wrapper for JNEXT plugin
///////////////////////////////////////////////////////////////////

JNEXT.BBM = function ()
{
    var _self = this,
        hasInstance = false;

    _self.self = {};
    _self.self.profilebox = {};
    _self.users = {};

    _self.startEvents = function (trigger) {
        if (accesschangedCallback === null) {
            accesschangedCallback = trigger;
            JNEXT.invoke(_self.m_id, "startEvents");
        }
    };

    _self.stopEvents = function () {
        accesschangedCallback = null;
        JNEXT.invoke(_self.m_id, "stopEvents");
    };

    _self.startContactEvents = function (trigger) {
        if (updateCallback === null) {
            updateCallback = trigger;
            JNEXT.invoke(_self.m_id, "startContactEvents");
        }
    };

    _self.stopContactEvents = function () {
        updateCallback = null;
        JNEXT.invoke(_self.m_id, "stopContactEvents");
    };

    _self.register = function (options) {
        JNEXT.invoke(_self.m_id, "register " + JSON.stringify(options));
    };

    _self.self.getProfile = function (field) {
        return JNEXT.invoke(_self.m_id, "self.getProfile " + field);
    };

    _self.self.getDisplayPicture = function (pluginResult) {
        _self.getDisplayPictureHandlers.push(pluginResult);
        //TODO: Send pluginResult.callbackId to native
        return JNEXT.invoke(_self.m_id, "self.getDisplayPicture");
    };

    _self.self.setStatus = function (statusArgs) {
        JNEXT.invoke(_self.m_id, "self.setStatus " + JSON.stringify(statusArgs));
    };

    _self.self.setPersonalMessage = function (personalMessage) {
        JNEXT.invoke(_self.m_id, "self.setPersonalMessage " + personalMessage);
    };

    _self.self.setDisplayPicture = function (displayPicture, pluginResult) {
        _self.setDisplayPictureHandlers.push(pluginResult);
        //TODO: Send pluginResult.callbackId to native
        JNEXT.invoke(_self.m_id, "self.setDisplayPicture " + displayPicture);
    };

    _self.self.profilebox.addItem = function (options, pluginResult) {
        _self.profileBoxAddItemHandlers.push(pluginResult);
        //TODO: Send pluginResult.callbackId to native
        JNEXT.invoke(_self.m_id, "self.profilebox.addItem " + JSON.stringify(options));
    };

    _self.self.profilebox.removeItem = function (options, pluginResult) {
        _self.profileBoxRemoveItemHandlers.push(pluginResult);
        //TODO: Send pluginResult.callbackId to native
        JNEXT.invoke(_self.m_id, "self.profilebox.removeItem " + JSON.stringify(options));
    };

    _self.self.profilebox.clearItems = function () {
        JNEXT.invoke(_self.m_id, "self.profilebox.clearItems");
    };

    _self.self.profilebox.registerIcon = function (options, pluginResult) {
        _self.profileBoxRegisterIconHandlers.push(pluginResult);
        //TODO: Send pluginResult.callbackId to native
        JNEXT.invoke(_self.m_id, "self.profilebox.registerIcon " + JSON.stringify(options));
    };

    _self.self.profilebox.getItems = function () {
        return JSON.parse(JNEXT.invoke(_self.m_id, "self.profilebox.getItems"));
    };

    _self.self.profilebox.getAccessible = function () {
        return (JNEXT.invoke(_self.m_id, "self.profilebox.getAccessible") === "1");
    };

    _self.users.inviteToDownload = function () {
        JNEXT.invoke(_self.m_id, "users.inviteToDownload");
    };

    _self.getId = function () {
        return _self.m_id;
    };

    _self.init = function () {
        if (!JNEXT.require("libbbm")) {
            return false;
        }

        _self.m_id = JNEXT.createObject("libbbm.BBM");

        if (_self.m_id === "") {
            return false;
        }

        JNEXT.registerEvents(_self);
    };

    _self.onEvent = function (strData) {
        var arData = strData.split(" "),
            strEventDesc = arData[0],
            allowed,
            obj,
            result;

        if (strEventDesc === "onaccesschanged") {
            if (arData[1] === "allowed") {
                allowed = true;
            } else {
                allowed = false;
            }
            accesschangedCallback(allowed, arData[1]);
        } else if (strEventDesc === "onupdate") {
            if (updateCallback !== null) {
                obj = arData.slice(2, arData.length).join(" ");
                updateCallback(JSON.parse(obj), arData[1]);
            }
        } else if (strEventDesc === "self.getDisplayPicture") {
            obj = arData.slice(1, arData.length).join(" ");
            //TODO: Switch from a queue getting the callbackId from native
            result = _self.getDisplayPictureHandlers.shift();
            result.callbackOk(JSON.parse(arData[1]));
        } else if (strEventDesc === "self.setDisplayPicture") {
            obj = arData.slice(1, arData.length).join(" ");
            //TODO: Switch from a queue getting the callbackId from native
            result = _self.setDisplayPictureHandlers.shift();
            result.callbackOk(JSON.parse(obj));
        } else if (strEventDesc === "self.profilebox.addItem") {
            obj = arData.slice(1, arData.length).join(" ");
            //TODO: Switch from a queue getting the callbackId from native
            result = _self.profileBoxAddItemHandlers.shift();
            result.callbackOk(JSON.parse(obj));
        } else if (strEventDesc === "self.profilebox.removeItem") {
            obj = arData.slice(1, arData.length).join(" ");
            //TODO: Switch from a queue getting the callbackId from native
            result = _self.profileBoxRemoveItemHandlers.shift();
            result.callbackOk(JSON.parse(obj));
        } else if (strEventDesc === "self.profilebox.registerIcon") {
            obj = arData.slice(1, arData.length).join(" ");
            //TODO: Switch from a queue getting the callbackId from native
            result = _self.profileBoxRegisterIconHandlers.shift();
            result.callbackOk(JSON.parse(obj));
        }
    };

    _self.m_id = "";
    _self.getDisplayPictureHandlers = [];
    _self.setDisplayPictureHandlers = [];
    _self.profileBoxAddItemHandlers = [];
    _self.profileBoxRemoveItemHandlers = [];
    _self.profileBoxRegisterIconHandlers = [];

    _self.getInstance = function () {
        if (!hasInstance) {
            _self.init();
            hasInstance = true;
        }
        return _self;
    };
};

bbm = new JNEXT.BBM();

module.exports = {
    bbm: bbm
};

});
define('plugin/cordova-plugin-bbm/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var bbm = require("./BBMJNEXT").bbm,
    _utils = require("../../lib/utils"),
    Whitelist = require("../../lib/policy/whitelist").Whitelist,
    _whitelist = new Whitelist(),
    _listeners = {},
    _actionMap = {
        onaccesschanged: {
            context: require("./BBMEvents"),
            event: "onaccesschanged",
            triggerEvent: "onaccesschanged",
            trigger: function (pluginResult, allowed, reason) {
                pluginResult.callbackOk({"allowed": allowed, "reason": reason}, true);
            }
        },
        onupdate: {
            context: require("./BBMEvents"),
            event: "onupdate",
            triggerEvent: "onupdate",
            trigger: function (pluginResult, user, event) {
                pluginResult.callbackOk({"user": user, "event": event});
            }
        }
    };

module.exports = {
    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            context = _actionMap[eventName].context,
            systemEvent = _actionMap[eventName].event,
            listener = _actionMap[eventName].trigger.bind(null, result);

        if (!_listeners[eventName]) {
            _listeners[eventName] = {};
        }

        if (_listeners[eventName][env.webview.id]) {
            //TODO: Stop all listeners on plugin reset and renable this error
            //result.error("Underlying listener for " + eventName + " already already running for webview " + env.webview.id);
            context.removeEventListener(systemEvent, _listeners[eventName][env.webview.id]);
        }

        context.addEventListener(systemEvent, listener);
        _listeners[eventName][env.webview.id] = listener;
        result.noResult(true);
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            context = _actionMap[eventName].context,
            systemEvent = _actionMap[eventName].event,
            listener;

        if (!_listeners || !_listeners[eventName] || !_listeners[eventName][env.webview.id]) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            listener = _listeners[eventName][env.webview.id];
            context.removeEventListener(systemEvent, listener);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    },

    register: function (success, fail, args, env) {
        if (args) {
            var result = new PluginResult(args, env);

            args.options = JSON.parse(decodeURIComponent(args.options));

            if (!args.options.uuid || args.options.uuid.length === 0) {
                result.error("Must specifiy UUID");
            }

            if (args.options.uuid.length < 32) {
                result.error("UUID is not valid length");
            } else {
                bbm.getInstance().register(args.options);
                result.noResult(true);
            }
        }
    },

    self : {
        appVersion : function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("appVersion"), false);
        },

        bbmsdkVersion: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(parseInt(bbm.getInstance().self.getProfile("bbmsdkVersion"), 10), false);
        },

        displayName: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("displayName"), false);
        },

        handle: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("handle"), false);
        },

        personalMessage: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("personalMessage"), false);
        },

        ppid: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("ppid"), false);
        },

        status: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("status"), false);
        },

        statusMessage: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            result.ok(bbm.getInstance().self.getProfile("statusMessage"), false);
        },

        getDisplayPicture: function (success, fail, args, env) {
            var result = new PluginResult(args, env);

            bbm.getInstance().self.getDisplayPicture(result);

            result.noResult(true);
        },

        setStatus: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            if (args) {
                args.status = JSON.parse(decodeURIComponent(args.status));
                args.statusMessage = JSON.parse(decodeURIComponent(args.statusMessage));

                if (args.status !== "available" && args.status !== "busy") {
                    result.error(-1, "Status is not valid");
                    return;
                }
            }

            bbm.getInstance().self.setStatus(args);
            result.ok(null, false);
        },

        setPersonalMessage: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            if (args) {
                args.personalMessage = JSON.parse(decodeURIComponent(args.personalMessage));

                if (args.personalMessage.length === 0) {
                    result.error(-1, "Personal message must not be empty");
                    return;
                }
            }

            bbm.getInstance().self.setPersonalMessage(args.personalMessage);
            result.ok(null, false);
        },

        setDisplayPicture: function (success, fail, args, env) {
            var result = new PluginResult(args, env);

            args.displayPicture = JSON.parse(decodeURIComponent(args.displayPicture));

            if (args.displayPicture.length === 0) {
                result.error("Display picture must not be empty");
            } else if (!_whitelist.isAccessAllowed(args.displayPicture)) {
                result.error("URL denied by whitelist: " + args.displayPicture);
            } else {
                args.displayPicture = _utils.translatePath(args.displayPicture).replace(/file:\/\//, '');
                bbm.getInstance().self.setDisplayPicture(args.displayPicture, result);
                result.noResult(true);
            }
        },

        profilebox: {
            addItem: function (success, fail, args, env) {
                var result = new PluginResult(args, env);

                args.options = JSON.parse(decodeURIComponent(args.options));

                if (!args.options.text || args.options.text.length === 0) {
                    result.error("must specify text");
                } else if (!args.options.cookie || args.options.cookie.length === 0) {
                    result.error("Must specify cookie");
                } else if (args.options.iconId && args.options.iconId < 1) {
                    result.error("Invalid icon ID");
                } else {
                    bbm.getInstance().self.profilebox.addItem(args.options, result);
                    result.noResult(true);
                }
            },

            removeItem: function (success, fail, args, env) {
                var result = new PluginResult(args, env);

                args.options = JSON.parse(decodeURIComponent(args.options));

                if (!args.options.id || args.options.id.length === 0 || typeof args.options.id !== "string") {
                    result.error("Must specify valid item id");
                } else {
                    bbm.getInstance().self.profilebox.removeItem(args.options, result);
                    result.noResult(true);
                }
            },

            clearItems: function (success, fail, args, env) {
                var result = new PluginResult(args, env);
                bbm.getInstance().self.profilebox.clearItems();
                result.ok(null, false);
            },

            registerIcon: function (success, fail, args, env) {
                var result = new PluginResult(args, env);

                args.options = JSON.parse(decodeURIComponent(args.options));

                if (!args.options.iconId || args.options.iconId <= 0) {
                    result.error("Must specify valid ID for icon");
                } else if (!args.options.icon || args.options.icon.length === 0) {
                    result.error("Must specify icon to register");
                } else if (!_whitelist.isAccessAllowed(args.options.icon)) {
                    result.error("URL denied by whitelist: " + args.displayPicture);
                } else {
                    args.options.icon = _utils.translatePath(args.options.icon).replace(/file:\/\//, '');
                    bbm.getInstance().self.profilebox.registerIcon(args.options, result);
                    result.noResult(true);
                }
            },

            getItems: function (success, fail, args, env) {
                var result = new PluginResult(args, env);
                result.ok(bbm.getInstance().self.profilebox.getItems(), false);
            },

            getAccessible : function (success, fail, args, env) {
                var result = new PluginResult(args, env);
                result.ok(bbm.getInstance().self.profilebox.getAccessible(), false);
            }
        }
    },

    users : {
        inviteToDownload: function (success, fail, args, env) {
            var result = new PluginResult(args, env);
            bbm.getInstance().users.inviteToDownload();
            result.ok(null, false);
        }
    }
};

});
define('plugin/cordova-plugin-clipboard/index.js', function (require, exports, module) {
/*
* Copyright (c) 2013 BlackBerry Limited.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

var clipboardjs,
	resultObjs = {},
	threadCallback = null,
   _utils = require("../../lib/utils");

module.exports = {

	// Code can be declared and used outside the module.exports object,
	// but any functions to be called by client.js need to be declared
	// here in this object.

	setText: function (success, fail, args, env) {
		var result = new PluginResult(args, env);
		args = JSON.parse(decodeURIComponent(args["input"]));
		var values = { value: args };
		result.ok(clipboardjs.getInstance().setText(result.callbackId, values), false);
	},
	getText: function (success, fail, args, env) {
		var result = new PluginResult(args, env);
		result.ok(clipboardjs.getInstance().getText(), false);
	}
};

///////////////////////////////////////////////////////////////////
// JavaScript wrapper for JNEXT plugin for connection
///////////////////////////////////////////////////////////////////

JNEXT.clipboardjs = function () {
	var self = this,
		hasInstance = false;

	self.getId = function () {
		return self.m_id;
	};

	self.init = function () {
		if (!JNEXT.require("libclipboard3")) {
			return false;
		}

		self.m_id = JNEXT.createObject("libclipboard3.ClipboardJS");

		if (self.m_id === "") {
			return false;
		}

		JNEXT.registerEvents(self);
	};

	// ************************
	// Enter your methods here
	// ************************

	// calls into InvokeMethod(string command) in template_js.cpp
	self.setText = function (callbackId, input) {
		return JNEXT.invoke(self.m_id, "setText " + callbackId + " " + JSON.stringify(input));
	};
	self.getText = function () {
		return JNEXT.invoke(self.m_id, "getText");
	};
	// Fired by the Event framework (used by asynchronous callbacks)
	self.onEvent = function (strData) {
		var arData = strData.split(" "),
			callbackId = arData[0],
			result = resultObjs[callbackId],
			data = arData.slice(1, arData.length).join(" ");

		if (result) {
			result.callbackOk(data, false);
			delete resultObjs[callbackId];
		}
	};

	// ************************
	// End of methods to edit
	// ************************
	self.m_id = "";

	self.getInstance = function () {
		if (!hasInstance) {
			hasInstance = true;
			self.init();
		}
		return self;
	};

};

clipboardjs = new JNEXT.clipboardjs();
});
define('plugin/cordova-plugin-mediakeys/index.js', function (require, exports, module) {
/*
* Copyright (c) 2013 BlackBerry Limited.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
* You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

var resultObjs = {},
	threadCallback = null,
	_utils = require("../../lib/utils");

module.exports = {
	bind: function (success, fail, args, env) {
		var result = new PluginResult(args, env);
		resultObjs[result.callbackId] = result;
		threadCallback = result.callbackId;
		var error;

		var validMediaKeys = ["fastForward", "pause", "play", "playPause", "rewind", "stop", "volumeDown", "volumeUp", "previous", "next"];
		var validKeyLength = ["short", "long"];

		args.mediakeys = decodeURIComponent(args.mediakeys);
		args.mediakeys = JSON.parse(args.mediakeys);

		// check that all keys are bindable
		args.mediakeys.some(function (obj) {
			if (typeof obj.mediakey !== 'string' || typeof obj.keylength !== 'string') {
				error = "Mediakey object has invalid fields";
			}

			if (!error &&
				validMediaKeys.indexOf(obj.mediakey) === -1 && 
				validKeyLength.indexOf(obj.keylength) === -1) {

				error = "Unable to bind mediakey '"+ obj.mediakey+"' of keylength '"+obj.keylength+"'";
			}

			return error;
		});

		if (!error) {
			args.mediakeys.some(function (obj) {
				error = mediaKeys.getInstance().bind(result.callbackId, obj);

				return error;
			});
		}

		if (error) {
			result.error(error, false);
			delete resultObjs[threadCallback];
		}
	}
};


///////////////////////////////////////////////////////////////////
// JavaScript wrapper for JNEXT plugin for connection
///////////////////////////////////////////////////////////////////

JNEXT.mediaKeys = function () {
	
	var self = this,
		hasInstance = false;

	self.getId = function () {
		return self.m_id;
	};

	self.init = function () {
		if (!JNEXT.require("libMediaKeys")) {
			return false;
		}

		self.m_id = JNEXT.createObject("libMediaKeys.MediaKeysJS");

		if (self.m_id === "") {
			return false;
		}

		JNEXT.registerEvents(self);

		var views = qnx.webplatform.getWebViews();
		var windowGroup = null;
		var z = -1;
		for (var i = 0; i < views.length; i++) {
				if (views[i].visible && views[i].zOrder > z){
						z = views[i].zOrder;
						windowGroup = views[i].windowGroup;
				}
		}
		var initResult = JNEXT.invoke(self.m_id, "join " + threadCallback + " " + JSON.stringify(windowGroup));
		if (initResult) {
			return initResult;
		}
	};

	// ************************
	// Enter your methods here
	// ************************

	self.bind = function (callbackId, args) {
		var error = JNEXT.invoke(self.m_id, "bind " + callbackId + " " + JSON.stringify(args));

		return error;
	};

	// Fired by the Event framework (used by asynchronous callbacks)
	self.onEvent = function (strData) {
		var arData = strData.split(" "),
			callbackId = arData[0],
			result = resultObjs[callbackId],
			data = arData.slice(1, arData.length).join(" ");
			data = JSON.parse(data);

		var isThread = (callbackId == threadCallback);

		if (data.result == "mediaKeyPressed") {
			result.callbackOk(data, isThread);
		} else {
			result.callbackError(data, isThread);
			delete resultObjs[callbackId];
		}
	};

	// ************************
	// End of methods to edit
	// ************************

	self.m_id = "";

	self.getInstance = function () {
		if (!hasInstance) {
			hasInstance = true;
			self.init();
		}
		return self;
	};

};

mediaKeys = new JNEXT.mediaKeys();

});
define('plugin/cordova-plugin-screenshot/index.js', function (require, exports, module) {
/*
 * https://github.com/jonwebb/webworks-bb10-screenshot
 *
 * Author: Jon Webb, jon@jonwebb.net
 *
 * Portions Copyright 2013 Innovatology.
 * Portions Copyright 2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var screenshotJNEXT,
    _utils = require("../../lib/utils");

module.exports = {
	/**
	* execute() finds the window handle, processes userargs then performs the screenshot
	*/
	execute: function (success, fail, args, env) {
		var result = new PluginResult(args, env),
            userargs,
            wv,
            i;

		// userargs are encoded and need decoding & parsing into a json object
		userargs = JSON.parse(decodeURIComponent(args.userargs));
		// which window handle should we use?
		wv = qnx.webplatform.getWebViews();
		for (i = 0;i < wv.length;i++) {
			if (wv[i].zOrder === '0') {
				// found window handle.
				result.ok(screenshotJNEXT.getInstance().execute({
                    handle: wv[i].jsScreenWindowHandle,
                    userargs: userargs
				}));
				return;
			}
		}
		fail("error:no window handle");
	}
};

///////////////////////////////////////////////////////////////////
// JavaScript wrapper for JNEXT plugin
///////////////////////////////////////////////////////////////////

JNEXT.ScreenshotJNEXT = function ()
{
    var _self = this,
        hasInstance = false;

	_self.execute = function (args) {
		return JNEXT.invoke(_self._id, "execute " + JSON.stringify(args));
	};
	_self.onEvent = function (strData) {
		console.log(strData);
	};

    _self.getId = function () {
        return _self._id;
    };

    _self.init = function () {
        if (!JNEXT.require("libscreenshot")) {
            return false;
        }

        _self._id = JNEXT.createObject("libscreenshot.ScreenshotJS");

        if (!_self._id || _self._id === "") {
            return false;
        }

        JNEXT.registerEvents(_self);
    };

    _self._id = "";

    _self.getInstance = function () {
        if (!hasInstance) {
            _self.init();
            hasInstance = true;
        }
        return _self;
    };
};

screenshotJNEXT = new JNEXT.ScreenshotJNEXT();

});
define('plugin/cordova-plugin-toast/index.js', function (require, exports, module) {
/*
 * Copyright 2012 Research In Motion Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var toast,
    _overlayWebView;

function show(success, fail, args, env) {
    var result = new PluginResult(args, env),
        message = args.message !== 'undefined' ? JSON.parse(decodeURIComponent(args.message)) : undefined,
        options = args.options !== 'undefined' ? JSON.parse(decodeURIComponent(args.options)) : {};

    options.dismissHandler = function (toastId) {
        result.callbackOk({reason: "dismissed", toastId: toastId}, false);
    };
    options.callbackHandler = function (toastId) {
        result.callbackOk({reason: "buttonClicked", toastId: toastId}, true);
    };

    // Return the toastId to the client from WP created toast
    result.ok({reason: "created", toastId: _overlayWebView.toast.show(message, options)}, true);
}

toast = {
    show : show
};

qnx.webplatform.getController().addEventListener('overlayWebView.initialized', function (webview) {
    _overlayWebView = webview;
});

module.exports = toast;

});
define('plugin/cordova-plugin-touch-keyboard/index.js', function (require, exports, module) {
/*
 * Copyright 2014 BlackBerry Limited.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/* global wp */

/*
{ altActive: false,
  ctrlActive: false,
  isPost: true,
  isSend: false,
  modifiers: 0,
  shiftActive: false,
  timeStamp: 70491647507582,
  touchEventType: 'TouchStart',
  touchPoints:
   [ { id: 0,
       pixelViewportPosition: { x: 1243, y: 1780 },
       screenPosition: { x: 1243, y: 1780 },
       state: 'TouchPressed' } ],
  touchSourceDevice: 'CapacitiveKeyboard',
  type: 'UnhandledTouch' }
*/

/* these functions will be called once to return values which will be
 * constant for the life span of an instantiated app instance
 */
function getScreenHeight() { return screen.height; }
function getScreenWidth() { return screen.width; }
function getKeyboardOffset() { return ('keyboardOffset' in wp.device && wp.device.keyboardOffset || "0") - 0; }
function getKeyboardHeight() { return ('keyboardHeight' in wp.device && wp.device.keyboardHeight || "0") - 0; }

var _screenHeight = getScreenHeight(),
    _screenWidth = getScreenWidth(),
    _keyboardOffset = getKeyboardOffset(),
    _keyboardHeight = getKeyboardHeight(),
    _appEvents = require("./../../lib/events/applicationEvents"),
    _orientation,
    _shift,
    _type = "touchenabledkeyboard",
    _actionMap = {
        touchenabledkeyboard: {
            trigger: function (pluginResult, data) {
                pluginResult.callbackOk(data, true);
            }
        }
    },
    /* Input:
     *
     *   Top left corner of the screen is 0,0
     *   The bottom right of the screen is 1440,1440
     *
     * PP   0 - the BlackBerry LED at the top right
     *   The keyboard starts at 0,1440 and runs to 1440,1440+{keyboardheight}
     * LP -90 - the BlackBerry LED at bottom right (phone rotated to the right)
     *   The keyboard starts at -{rotated-keyboardheight},0 and runs to 0,1440
     * LS  90 - the BlackBerry LED at top left (phone rotated to the left)
     *   The keyboard starts at 1440,0 and runs to 1440+{keyboardheight},1440
     *
     * The matrix needs to be picked to do something useful
     */
    _listeners = [];

updateShift("portrait-primary");

function updateShift(o) {
    o = o || 'unknown';
    switch (o) {
        case "portrait-primary":
            _shift = {x: 0, y: - _screenHeight - _keyboardOffset};
            break;

        case "landscape-primary":
            _shift = {x: _keyboardHeight, y: 0};
            break;

        case "portrait-secondary":
            _shift = {x: 0, y: _keyboardHeight + _keyboardOffset};
            break;

        case "landscape-secondary":
            _shift = {x: - _screenHeight - _keyboardOffset, y: 0};
            break;

        default:
            _shift = {x: 0, y: 0};
    }

    _orientation = o;
    return _shift;
}

/* This takes an UnhandledTouch event:
 * transforms the coordinates for each point,
 * and then sends that off to the application...
 */
function processTouchEvent(env, e) {
    var listener,
        touches = [];
    e = JSON.parse(e);
    if (e.touchSourceDevice !== 'CapacitiveKeyboard' ||
        !e.touchPoints ||
        !e.touchPoints.length) {
        return;
    }
    if (!_listeners[env.webviewId]) {
        return;
    }
    e.touchPoints.forEach(function (point) {
        touches.push({
            keyboardX: point.screenPosition.x + _shift.x,
            keyboardY: point.screenPosition.y + _shift.y,
            state: point.state,
            identifier: point.id
        });
    });
    listener = _listeners[env.webviewId];
    listener({
        type: _type,
        touches: touches,
        timeStamp: e.timeStamp
    });
}

function angleToOrientation(angle) {
    var orientation;

    switch (angle) {
    case 0:
        orientation = 'portrait-primary';
        break;
    case 90:
        orientation = 'landscape-secondary';
        break;
    case 180:
        orientation = 'portrait-secondary';
        break;
    case -90:
    case 270:
        orientation = 'landscape-primary';
        break;
    default:
        orientation = "unknown";
        break;
    }

    return orientation;
}

function edgeToOrientation(edge) {
    switch (edge) {
    case "left_up":
        return "landscape-primary";
    case "top_up":
        return "portrait-primary";
    case "bottom_up":
        return "portrait-secondary";
    case "right_up":
        return "landscape-secondary";
    default:
        return "unknown";
    }
}

function translateToDeviceOrientation(orientation) {
    // Convert HTML5 orientation syntax into device syntax
    switch (orientation) {
    case 'portrait':
    case 'portrait-primary':
        return 'top_up';

    case 'landscape':
    case 'landscape-primary':
        return 'left_up';

    case 'portrait-secondary':
        return 'bottom_up';

    case 'landscape-secondary':
        return 'right_up';

    default:
        return 'unknown';
    }
}
function rotateTrigger(width, height, angle) {
    updateShift(angleToOrientation(angle));
}

function rotateWhenLockedTrigger(edge) {
    updateShift(edgeToOrientation(edge));
}

var listenerCount = 0;
function register(env) {
    if (listenerCount++) {
        return;
    }

    try {
        qnx.webplatform.getWebViewById(env.webview.id).on("UnhandledTouch", processTouchEvent);
    } catch (e) {
        console.log(e);
    }
    _appEvents.addEventListener("rotate", rotateTrigger);
    _appEvents.addEventListener("rotateWhenLocked", rotateWhenLockedTrigger);
}

function unregister(env) {
    if (!(listenerCount--)) {
        return;
    }
    try {
        qnx.webplatform.getWebViewById(env.webview.id).un("UnhandledTouch", processTouchEvent);
    } catch (e) {
        console.log(e);
    }
    _appEvents.removeEventListener("rotate", rotateTrigger);
    _appEvents.removeEventListener("rotateWhenLocked", rotateWhenLockedTrigger);
}

module.exports = {

    startEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            ev = _actionMap[eventName],
            listener = ev.trigger.bind(null, result);

        if (!_listeners[env.webview.id]) {
            register(env);
        }

        _listeners[env.webview.id] = listener;
        result.noResult(true);
    },

    stopEvent: function (success, fail, args, env) {
        var result = new PluginResult(args, env),
            eventName = JSON.parse(decodeURIComponent(args.eventName)),
            listener = _listeners[env.webview.id],
            ev = _actionMap[eventName];

        if (!listener) {
            result.error("Underlying listener for " + eventName + " never started for webview " + env.webview.id);
        } else {
            unregister(env);
            delete _listeners[eventName][env.webview.id];
            result.noResult(false);
        }
    }
};

});
define('plugin/File/index.js', function (require, exports, module) {
/*
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *
*/
module.exports = {
    setSandbox : function (success, fail, args, env) {
        require("lib/webview").setSandbox(JSON.parse(decodeURIComponent(args[0])));
        new PluginResult(args, env).ok();
    },

    getHomePath: function (success, fail, args, env) {
        var homeDir = window.qnx.webplatform.getApplication().getEnv("HOME");
        new PluginResult(args, env).ok(homeDir);
    },

    requestAllPaths: function (success, fail, args, env) {
        var homeDir = 'file://' + window.qnx.webplatform.getApplication().getEnv("HOME").replace('/data', ''),
            paths = {
                applicationDirectory: homeDir + '/app/native/',
                applicationStorageDirectory: homeDir + '/',
                dataDirectory: homeDir + '/data/webviews/webfs/persistent/local__0/',
                cacheDirectory: homeDir + '/data/webviews/webfs/temporary/local__0/',
                externalRootDirectory: 'file:///accounts/1000/removable/sdcard/',
                sharedDirectory: homeDir + '/shared/'
            };
        success(paths);
    }
};

});
}());